<?php
/*
bankaccount.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");
require_once($_SESSION['VxCFG']->libdir."/transaction.php");
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('bankid');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Bank Account"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Bank Account");
}

if($_SESSION["pageindex"]->CheckNum(bank_account_qry1, "bankaccount")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear":
		addBank();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseBank($_REQUEST['id']);
         break;
      }
		browseBank($_POST['id']);
		break;

	case "edit" :
		editBank($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelBank($_REQUEST['id']);
      }
      else{
         deleteBank($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank($_POST);
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank($_POST);
		break;
      
	case "add" :
		insertBank($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listBank($_POST);
		break;

	case "commit" :
		commitBank($_POST);
      listBank($_POST);
		break;

   case "duplicate" :
      $id=duplicateBank($_REQUEST['id']);
      editBank($id);
      break;
      
   case "find":
      searchBank($_POST);
      break;
      
	case "list":
	default :
      listBank($_REQUEST);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(bank_account_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["bankid"] = "";
   $frm["name"] = "";
   $frm["number"] = "";
   
	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(bank_account_qry2, $id);
   }
   else{
      $qry=sprintf(bank_account_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $row["id"];
   $frm["bankid"] = $row["bankid"];
   $frm["name"] = $row["name"];
   $frm["number"] = $row["number"];

	return $frm;
}

function addBank()
{
   $frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/bankaccount.php");
}

function editBank($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/bankaccount.php");
}

function browseBank($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/bankaccount.php");
}

function chkdelbank($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/bankaccount.php");
}

function deleteBank($id) 
{
   $qry=sprintf(bank_account_qry6, $id);

   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertBank($frm) 
{
   $qry=sprintf(bank_account_qry5, $frm['bankid'],$frm['name'],$frm['number']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitBank($frm) 
{
   $qry=sprintf(bank_account_qry4,$frm['bankid'],$frm['name'],$frm['number'],$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateBank($id) 
{
   $frm=fillForm($id, false);
   return insertBank($frm);
}

function fillAccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function fillBankCombo($action, $id)
{
   $b=new BankDetails();
   $b->Combo($action, $id, "bankid");
}

function fillBankTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(bank_banktrans_qry12);
      echo "<select name=\"itemtype\" width=\"250\">\n";
   	while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["name"];
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
	   echo "</select>\n";
   }
   else{
      
      if($id != NULL){
         $qry=sprintf(bank_account_qry13, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

//function listBank($reconciled='N', $type='All', $start='', $end='')
function listBank($frm)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(bank_account_qry7, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no bank accounts defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no bank accounts defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='bankid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Bank")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Bank")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=bankid\">"._("Bank")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='bankid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='number'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=number\">"._("Number")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='number'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $bqry=sprintf(bank_account_qry8, $row['bankid']);
      $bresult=$_SESSION['VxCFG']->dbh->Execute($bqry);
      $brow=$bresult->FetchRow();
      if($c%2){
   		echo "<tr class=\"listdata\"><td class=\"listdata\">";
         if($brow["name"]!=""){
	   	   echo $brow["name"];
		   }
   		else{
	   	   echo "No Name";
		   }
         echo "</td><td class=\"listdata\">";
	   	if($row["name"]!=""){
		      echo $row["name"];
		   }
   		else{
	   	   echo "No Name";
		   }
   		echo "</td><td class=\"listdata\">";
         if($row["number"]!=""){
		      echo $row["number"];
		   }
   		else{
	   	   echo "No Number";
		   }
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
         if($brow["name"]!=""){
	   	   echo $brow["name"];
		   }
   		else{
	   	   echo "No Name";
		   }
         echo "</td><td class=\"listdataeven\">";
	   	if($row["name"]!=""){
		      echo $row["name"];
		   }
   		else{
	   	   echo "No Name";
		   }
   		echo "</td><td class=\"listdataeven\">";
         if($row["number"]!=""){
		      echo $row["number"];
		   }
   		else{
	   	   echo "No Number";
		   }
         echo "</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"bankaccount.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"bankaccount.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"bankaccount.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"bankaccount.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"bankaccount.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"bankaccount.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
