<?php
if(!is_dir('install')){
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
   <meta http-equiv="Content-Style-Type" content="text/css">
   <title>VxMIS Setup Druid Locked</title>
   <link rel="stylesheet" href="install/install.css" type="text/css">
</head>
<body>
<table cellspacing="0" cellpadding="0" border="0" align="center" class="shell">
<tr>
  <th width="400">VxMIS Setup Wizard Locked</th>
</tr>
<tr>
  <td>
  <p>Your VxMIS application has been secured to prevent you from
  running the installation again.  To allow yourself to run the
  installation again you must rename your installation directory
  back to 'install'.</p>
  <p>For installation help, please visit the VxMIS <a href="http://vxmis.vxgroup.com/forums/" target="_blank">support forums</a>.</p>
  </td>
</tr>
<tr>
  <td><hr></td>
</tr>
</table>
</body>
</html>

<?php
}
else {
   $install_script = true;
   session_start();
   $_SESSION['vxmis_version']='2.0.0';
   if(substr(phpversion(), 0, 1) == "5"){
      ini_set("zend.ze1_compatibility_mode", "1");
   }

$current_language = 'en_GB';

// one place for form validation/conversion to boolean
function get_boolean_from_request( $field ){
   if(!isset($_REQUEST[$field])){
      return(false);
   }

   if(($_REQUEST[$field] == 'on') || ($_REQUEST[$field] == 'yes')){
      return(true);
   }
   else{
      return(false);
   }
}

function stripslashes_checkstrings($value){
   if(is_string($value)){
      return stripslashes($value);
   }
   return $value;
}

if(get_magic_quotes_gpc() == 1){
   $_REQUEST = array_map("stripslashes_checkstrings", $_REQUEST);
   $_POST = array_map("stripslashes_checkstrings", $_POST);
   $_GET = array_map("stripslashes_checkstrings", $_GET);
}

function validate_dbconfig()
{
   $errors = array();

   if($_SESSION['db_host'] == ''){
      $errors[] = 'Host name cannot be blank.';
   }

   if($_SESSION['db_name'] == ''){
      $errors[] = 'Database name cannot be blank.';
   }
   else if(preg_match( "/[\\\\\/\.]/", $_SESSION['db_name'])){
      $errors[] = "Database name cannot contain a '\\', '/', or '.'";
   }
   else{
      $is_valid_database_name = true;
   }

   if($_SESSION['db_username'] == ''){
      $errors[] = 'User name cannot be blank.';
   }
   
   if($_SESSION['db_adminpassword'] == ''){
      $errors[] = 'Password for user admin cannot be blank.';
   }
   
   if(strcmp($_SESSION['db_adminpassword'],$_SESSION['db_adminpassword_repeat'])!=0){
      $errors[] = 'Passwords for user admin do not match.';
   }
   
   require_once("lib/adodb/adodb.inc.php");
   
   if($_SESSION['db_type']=="mysql"){
      $db = NewADOConnection("mysql",'transaction : pear');
      $db->Connect($_SESSION['db_host'],$_SESSION['db_username'],$_SESSION['db_password'],$_SESSION['db_name']);
      if(!$db){
         $errors[] = 'Can not connect to database...';
         return $errors;
      }
   }
   
   
   // check the bhpos base db is installed...
   $query = "show tables like 'contacts'";
   $result = $db->Execute($query);
   if($result){
      $row=false;
      $row=$result->FetchRow();
      if($row){
      }
      else{ // where is bhpos db?
         $errors[] = "No BhPos Base db system found - install it perhaps?";
         $result->close();
         $db->Close();
         return $errors;
      }
   }
   else{
      $errors[] = "No BhPos Base db system found - install it perhaps?";
      $db->Close();
      return $errors;
   }
   
   
   
   // check if db already installed...
   $query = "select value from missystemattribute where name='version'";
   $result = $db->Execute($query);
   if($result){
      $row=false;
      $row=$result->FetchRow();
      if($row){
         if($_SESSION['db_create_database']){
            if(!$_SESSION['db_drop_tables']){
               $errors[] = "Database ".$_SESSION['db_name']." already exists (add drop tables?).";
               $result->close();
               $db->Close();
               return $errors;
            }
            else{ // we can drop and create...
               $result->close();
               $db->Close();
               return $errors;
            }
         }
         else{
            $result->close();
            $db->Close();
         }
      }
      else{
         if(!$_SESSION['db_create_database']){
            $errors[] = "Database ".$_SESSION['db_name']. " does not exist (add create tables?).";
            return $errors;
         }
      }
   }
   else{ // force db create
      $_SESSION['db_create_database']=true;
   }    
   
   $db->Close();
   
   $_SESSION['db_update']=false;
   // upgradable?
   /*
   $query = "select value from missystemattribute where name='version'";
   $result = $db->Execute($query);
   if(!$result){
      $errors[] = "Database ".$_SESSION['db_name']. " cannot be upgraded.";
      return $errors;
   }
   $row = $result->FetchRow();
   if(!row){
      $errors[] = "Database ".$_SESSION['db_name']. " cannot be upgraded.";
      return $errors;
   }
   $installed_version=str_replace(".", "", $row);
   
   
   $result->close();
   
   */
   return $errors;
}

function validate_systemconfig()
{
   $errors = array();

   if($_SESSION['dirroot'] == ''){
      $errors[] = 'Target directory cannot be blank.';
   }
   if(is_dir($_SESSION['dirroot'])){
         if(!is_writable($_SESSION['dirroot'])){
            $errors[] = 'Session directory provided is not a writable directory.';
         }
      }
      else {
         $errors[] = 'Session directory provided is not a valid directory.';
      }
   
   if($_SESSION['wwwroot'] == ''){
      $errors[] = 'URL cannot be blank.';
   }
   /*
   if($_SESSION['confroot'] == ''){
      $errors[] = 'Configuration directory cannot be blank.';
   }
   */
   return $errors;
}

function validate_defaultsconfig()
{
   $errors = array();
   /*
   if($_SESSION['sessiontimeout'] == ''){
      $errors[] = 'Session timeout cannot be blank.';
   }
   $_SESSION['defaultimgx']
   $_SESSION['defaultimgy']
   $_SESSION['onlinehelp']
   $_SESSION['confirmdelete']
   $_SESSION['pageimages']
   $_SESSION['pagesize']
   $_SESSION['styler']
   $_SESSION['firstweekofyear']
   $_SESSION['firstdayofweek']
   $_SESSION['startofday']
   $_SESSION['endofday']
   $_SESSION['defspage']
   $_SESSION['dateformat']
   $_SESSION['timeformat']
   $_SESSION['nummodules']
   $_SESSION['nummlastviewed']
   $_SESSION['showlinks']
   $_SESSION['debug']
   */
   return $errors;
}

$next_clicked = false;
$next_page = 0;

// use a simple array to map out the steps of the installer page flow
$druid = array('page1.php', // welcome
               'page2.php', // license
               'page3.php', // system check
               'page4.php', // db setup
               'page5.php', // site configure
               'page6.php', // default options
               'page7.php', // confirm settings
               'page8.php', // setup
               'page9.php',); // register

if(!empty($_REQUEST['goto'])){
   switch($_REQUEST['goto']){
   case 'Re-check':
      //$next_page = '2';
      $next_page = '1';
      break;
   case 'Back':
      if($_REQUEST['setup_page']==1){
         $next_page = 0;
      }
      else{
         $next_page = $_REQUEST['setup_page'] - 1;
      }
      break;
   case 'Next':
   case 'Start':
      $next_page = $_REQUEST['setup_page'] + 1;
      //if($next_page == 1){
      //   $next_page=2;
      // }
      $next_clicked = true;
      break;
   }
}

$page_errors = array();

// process the data posted
if($next_clicked){
   // store the submitted data because the 'Next' button was clicked
   switch($druid[$_REQUEST['setup_page']]){
   case 'page1.php':
      session_unset();
      break;

   case 'page2.php':
      $_SESSION['license_accept'] = get_boolean_from_request('license_accept');
      $_SESSION['license_submitted'] = true;
      break;
   
   case 'page3.php': // req checks
      break;
   
   case 'page4.php': 
      $_SESSION['db_host'] = $_REQUEST['db_host'];
      $_SESSION['db_name'] = $_REQUEST['db_name'];
      $_SESSION['db_create_database'] = get_boolean_from_request( 'db_create_database' );
      $_SESSION['db_drop_tables'] = get_boolean_from_request( 'db_drop_tables' );
      $_SESSION['db_demo_data'] = get_boolean_from_request( 'db_demo_data' );
      $_SESSION['db_username'] =  $_REQUEST['db_username'];
      $_SESSION['db_password'] = $_REQUEST['db_password'];
      $_SESSION['db_adminpassword'] =  $_REQUEST['db_adminpassword'];
      $_SESSION['db_adminpassword_repeat'] =  $_REQUEST['db_adminpassword_repeat'];
      $_SESSION['db_submitted'] = true;
      $validation_errors = validate_dbconfig();
      if(count($validation_errors) > 0){
         $next_page--;
      }
      break;
      
   case 'page5.php':
      $_SESSION['dirroot'] = $_REQUEST['dirroot'];
      $_SESSION['wwwroot'] = $_REQUEST['wwwroot'];
      $_SESSION['confroot'] = $_REQUEST['confroot'];
      $_SESSION['imgdir'] = $_REQUEST['imgdir'];
      $_SESSION['tmpdir'] = $_REQUEST['tmpdir'];
      $_SESSION['printfolder'] = $_REQUEST['printfolder'];
      $_SESSION['companyname'] = $_REQUEST['companyname'];
      $_SESSION['sitename'] = $_REQUEST['sitename'];
      $_SESSION['locale'] = $_REQUEST['locale'];
      $_SESSION['defaultcountry'] = $_REQUEST['defaultcountry'];
      $_SESSION['defaultcurrency'] = $_REQUEST['defaultcurrency'];
      $_SESSION['papersize'] = $_REQUEST['papersize'];
      $_SESSION['pdfpapersize'] = $_REQUEST['pdfpapersize'];
      $_SESSION['accountingmethod'] = $_REQUEST['accountingmethod'];
      $_SESSION['system_submitted'] = true;
      $validation_errors = validate_systemconfig();
      if(count($validation_errors) > 0) {
         $next_page--;
      }
      break;
      
   case 'page6.php':
      $_SESSION['sessiontimeout'] = $_REQUEST['sessiontimeout'];
      $_SESSION['defaultimgx'] = $_REQUEST['defaultimgx'];
      $_SESSION['defaultimgy'] = $_REQUEST['defaultimgy'];
      $_SESSION['onlinehelp'] = $_REQUEST['onlinehelp'];
      $_SESSION['confirmdelete'] = $_REQUEST['confirmdelete'];
      $_SESSION['pageimages'] = $_REQUEST['pageimages'];
      $_SESSION['pagesize'] = $_REQUEST['pagesize'];
      $_SESSION['styler'] = $_REQUEST['styler'];
      $_SESSION['firstweekofyear'] = $_REQUEST['firstweekofyear'];
      $_SESSION['firstdayofweek'] = $_REQUEST['firstdayofweek'];
      $_SESSION['startofday'] = $_REQUEST['startofday'];
      $_SESSION['endofday'] = $_REQUEST['endofday'];
      $_SESSION['defspage'] = $_REQUEST['defspage'];
      $_SESSION['dateformat'] = $_REQUEST['dateformat'];
      $_SESSION['timeformat'] = $_REQUEST['timeformat'];
      $_SESSION['nummodules'] = $_REQUEST['nummodules'];
      $_SESSION['nummlastviewed'] = $_REQUEST['nummlastviewed'];
      $_SESSION['showlinks'] = $_REQUEST['showlinks'];
      $_SESSION['debug'] = $_REQUEST['debug'];
      $_SESSION['defaults_submitted'] = true;
      $validation_errors = validate_defaultsconfig();
      if(count($validation_errors) > 0) {
         $next_page--;
      }
      break;
   }
}


$filename = $druid[$next_page];

switch($filename){
case 'page1.php':
   session_unset();
   break;
   
case 'page8.php':
   session_unset();
   header("Location: index.php");
   exit;
}

require('install/' . $filename);

}
?>
