
CREATE TABLE misattribute (
  id int(11) NOT NULL auto_increment,
  attributeid int(11) NOT NULL default '0',
  name varchar(32) NOT NULL default '',
  `type` int(2) NOT NULL default '0',
  format varchar(255) NOT NULL default '',
  mask varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (id,attributeid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE misformvalidation (
  id int(11) NOT NULL auto_increment,
  menuid int(11) NOT NULL default '0',
  formid varchar(64) NOT NULL default '',
  mask varchar(64) NOT NULL default '',
  format varchar(64) NOT NULL default '',
  defaultvalue varchar(255) NOT NULL default '',
  PRIMARY KEY  (id,menuid,formid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE misgui (
  id int(11) NOT NULL auto_increment,
  misguiid int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (id,misguiid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE mismenu (
  id int(11) NOT NULL auto_increment,
  menuid int(11) NOT NULL default '0',
  parentid int(11) NOT NULL default '0',
  sortorder int(11) NOT NULL default '0',
  name varchar(64) NOT NULL default '',
  moduleid int(11) NOT NULL default '0',
  phpfile varchar(80) NOT NULL default '',
  perm_browse char(1) NOT NULL default 'N',
  perm_edit char(1) NOT NULL default 'N',
  perm_add char(1) NOT NULL default 'N',
  perm_delete char(1) NOT NULL default 'N',
  perm_grant char(1) NOT NULL default 'N',
  icon varchar(64) NOT NULL default '',
  `type` char(1) NOT NULL default 'U',
  PRIMARY KEY  (id,menuid,parentid),
  KEY sortorder (sortorder),
  KEY moduleid (moduleid),
  KEY mismuser_menu_fk (menuid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE mismodule (
  id int(11) NOT NULL auto_increment,
  parentid int(11) NOT NULL default '0',
  sortorder int(3) NOT NULL default '0',
  version varchar(12) NOT NULL default '00.00.00.00',
  name varchar(80) NOT NULL default '',
  title varchar(255) NOT NULL default '',
  author varchar(255) NOT NULL default '',
  cmid int(11) NOT NULL default '0',
  description varchar(255) NOT NULL default '',
  basedir varchar(255) NOT NULL default '',
  icon varchar(64) NOT NULL default '',
  `type` char(1) NOT NULL default 'U',
  enabled char(1) NOT NULL default 'N',
  PRIMARY KEY  (id)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE missystemattribute (
  id int(11) NOT NULL auto_increment,
  attributeid int(11) NOT NULL default '0',
  name varchar(32) NOT NULL default '',
  `type` int(2) NOT NULL default '0',
  format varchar(255) NOT NULL default '',
  mask varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY attributeid (attributeid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE misuser (
  id int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  menuid int(11) NOT NULL default '0',
  attributeid int(11) NOT NULL default '0',
  PRIMARY KEY  (id,userid,menuid,attributeid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `mismenu`
  ADD CONSTRAINT mismenu_module_fk FOREIGN KEY (moduleid) REFERENCES mismodule (id) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT mismuser_menu_fk FOREIGN KEY (menuid) REFERENCES misuser (id) ON DELETE CASCADE ON UPDATE CASCADE;
