<?php
/*
ledger.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/gl.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("General Ledger"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("General Ledger");
}

if($_SESSION['pageindex']->CheckNum(ledger_gl_qry1)){
   $_SESSION['pageindex']->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addGL();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseGL($id);
         break;
      }
		$id=updateNav($_POST);
		browseGL($id);
		break;

	case "edit" :
		editGL($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelGL($_REQUEST['id']);
      }
      else{
         deleteGL($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listGL();
      }
		break;

	case "cfmdelete" :
		deletePeriod($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listGL();
		break;

	case "add" :
		insertGL($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitGL($_POST);
		break;

   case "newsearch" :
		newSearch();
		break;
      
   case "searchparam" :
      searchFilterType($_POST);
      break;
      
   case "search" :
      searchGL($_POST);
      break;

	case "list":
	default :
		$id=updateNav($_POST);
		listGL();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(ledger_gl_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "0";
   $frm["journalid"] = "";
   $frm["ledgerid"] = "";
   $frm["accountid"] = "";
   $frm["entereddate"] = "";
   $frm["description"] = "";
   $frm["debit"] = "N";
   $frm["amount"] = "";
   $frm["posted"] = "N";
   $frm["referenceid "] = "";

   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(ledger_gl_qry2, $id);
   }
   else{
      $qry=sprintf(ledger_gl_qry3, $id);
   }
   $frm=clearForm();
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $row["id"];
      $frm["journalid"] = $row["journalid"];
      $frm["ledgerid"] = $row["ledgerid"];
      $frm["accountid"] = $row["accountid"];
      $frm["entereddate"] = $row["entereddate"];
      $frm["description"] = $row["description"];
      $frm["debit"] = $row["debit"];
      $frm["amount"] = $row["amount"];
      $frm["posted"] = $row["posted"];
      $frm["referenceid "] = $row["referenceid"];
	}
   return $frm;
}

function newSearch()
{
   // select the filter values
   $frm["newaction"] = "searchparam";
   $frm["id"] = 0;
   $frm["accountid"] = 0;
   $frm["accounttype"]="all";
   $frm["filtertype"]="none";
   $frm["filtervalue"]="";
   $frm["parentaccount"]=0;
   $frm["accountheading"]=0;
   
	include("templates/gl.php");
}

function searchFilterControl($frm)
{
   switch($frm['accounttype']){
   case 'all':
      echo "<tr><td class=\"formlabel\">"._("Account Filter")."</td>\n";
      echo "<td class=\"formlabel\">"._("All Accounts")."</td></tr>\n";
      break;
   
   case 'account':
      echo "<tr><td class=\"formlabel\">"._("Account")."</td><td class=\"formlabel\">\n";
      fillAccountCombo("add", $frm["accountid"]);
      echo "</td></tr>\n";
      break;
   
   case 'parent':
      echo "<tr><td class=\"formlabel\">"._("Group")."</td><td class=\"formlabel\">\n";
      fillParentCombo("add", $frm["parentaccount"]);
      echo "</td></tr>\n";
      break;
   
   case 'type':
      echo "<tr><td class=\"formlabel\">"._("Type")."</td><td class=\"formlabel\">\n";
      fillHeadingCombo("add", $frm["accountheading"]);
      echo "</td></tr>\n";
      break;
   }
   
   // now we know the filter type, we can add the correct controls
   switch($frm['filtertype']) {
   case 'none':
      echo "<tr><td class=\"formlabel\">"._("Filter")."</td>\n";
      echo "<td class=\"formlabel\">"._("None")."</td>\n</tr>\n";
      break;
         
   case 'datebefore':
      // date control
      echo "<tr><td class=\"formlabel\">"._("Before")."</td><td class=\"formlabel\">\n";
      $tc1=new TimeDate();
      $tc1->datecontrol("add", "datebefore");
      echo "</td></tr>\n";
      break;
            
   case 'dateafter':
      //date control
      echo "<tr><td class=\"formlabel\">"._("After")."</td><td class=\"formlabel\">\n";
      $tc1=new TimeDate();
      $tc1->datecontrol("add", "dateafter");
      echo "</td></tr>\n";
      break;
         
   case 'datebetween':
      //dual date control
      $tc1=new TimeDate();
      echo "<tr><td class=\"formlabel\">"._("Start")."</td><td class=\"formlabel\">\n";
      $tc1->datecontrol("add", "datestart");
      echo "</td></tr>\n";
      echo "<tr><td class=\"formlabel\">"._("End")."</td><td class=\"formlabel\">\n";
      $tc1->datecontrol("add", "dateend");
      echo "</td></tr>\n";
      break;
         
   case 'reconciled':
      break;
         
   case 'notreconciled':
      break;
      
   case 'settled':
      break;
      
   case 'notsettled':
      break;
      
   case 'user':
      // user combo
      echo "<tr><td class=\"formlabel\">"._("User")."</td><td class=\"formlabel\">\n";
      FillEmployeeName("add", "user", 0);
      echo "</td></tr>\n";
      break;
         
   case 'station':
      //location combo
      echo "<tr><td colspan=\"2\" class=\"formlabel\">\n";
      fillEnteredStation("add", 0);
      echo "</td></tr>\n";
      break;
   }
}

function searchFilterType($frm)
{
   $frm["accounttype"]=$frm["accounttype"];
   $frm["filtertype"]=$frm["filtertype"];
   $frm["filtervalue"]=$frm["filtervalue"];
   $frm["account"]=$frm["account"];
   $frm["parentaccount"]=$frm["parentaccount"];
   $frm["accountheading"]=$frm["accountheading"];
   $frm["newaction"] = "search";
   
   include("templates/glhdr.php");
   searchFilterControl($frm);   
   include("templates/glftr.php");
}

function searchGL($frm)
{
   // and finally search on params
   $frm["newaction"] = "search";
   include("templates/glhdr.php");
   searchFilterControl($frm);
   
   if(!isset($frm['filtertype']))
     exit();

   switch($frm['accounttype']){
   case 'all':
      $qry="select * from transaction ";
      break;
   
   case 'account':
      $qry=sprintf(ledger_gl_qry4, $frm['accountid']);
      $qry.=" and ";
      break;
   
   case 'parent':
      $qry=sprintf(ledger_gl_qry24, $frm['parentaccount']);
      $qry.=" and ";
      break;
   
   case 'type':
      $qry=sprintf(ledger_gl_qry25, $frm['accountheading']);
      $qry.=" and ";
      break;
   }

   switch($filtertype) {
   case 'none':
      $search = "";
      break;
         
   case 'datebefore':
      $date=$frm['datebeforeyear'].$frm['datebeforemonth'].$frm['datebeforeday'];
      $search = "transaction.enteredat before $bdate";
      break;
            
   case 'dateafter':
      $date=$frm['dateafteryear'].$frm['dateaftermonth'].$frm['dateafterday'];
      $search = "transaction.enteredat after $date";
      break;
         
   case 'datebetween':
      $sdate=$frm['datestartyear'].$frm['datestartmonth'].$frm['datestartday'];
      $edate=$frm['dateendyear'].$frm['dateendmonth'].$frm['dateendday'];
      $search = "transaction.enteredat between $sdate and $edate";
      break;
         
   case 'reconciled':
      $search = "transaction.reconciled = 'Y'";
      break;
         
   case 'notreconciled':
      $search = "transaction.reconciled = 'N'";
      break;
      
   case 'settled':
      $search = "transaction.settled = 'Y'";
      break;
      
   case 'notsettled':
      $search = "transaction.settled = 'N'";
      break;
      
   case 'user':
      $who =  $frm['who'];
      $search = "transaction.enteredby = $who";
      break;
         
   case 'station':
      $loc=$frm['siteid'].$frm['deptid'].$frm['groupid'].$frm['stationid'];
      $search = "transaction.enteredstation = $loc";
      break;
   }
   
   //echo $qry;
   // ok, let's bag the items from the trans table
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!result) exit();
   echo "<tr><td colspan=\"2\" nowrap><table>\n";
   echo "<tr><td class=\"listtitle\">"._("Date")."</td>\n";
   echo "<td class=\"listtitle\">"._("Who")."</td>\n";
   echo "<td class=\"listtitle\">"._("Where")."</td>\n";
   echo "<td class=\"listtitle\">"._("Amount")."</td></tr>\n";
	while($row = $result->FetchRow()){
      echo "<tr><td width=\"20%\">\n";
      $tc=new TimeDate();
      $tc->parse($row['enteredat']);
      $tc->datecontrol("browse", "datestart");
      echo "</td><td width=\"20%\">\n";
      FillEmployeeName("browse", "user", $row['enteredby']);
      echo "</td><td>\n";
      fillNarrowEnteredStation("browse", $row['enteredstation']);
      echo "</td><td>\n";
      $qry=sprintf(ledger_gl_qry26, $frm['id']);
      $aresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($aresult){
         if($arow=$aresult->FetchRow()){
            $a=sprintf("%0.2f",$arow[0]);
            echo $a;
         }
         else{
            echo "0.00";
         }
      }
      else{
         echo "0.00";
      }
      echo "</td></tr>\n";
   }
   echo "</table>\n";
   
	include("templates/glftr.php");
}

function addGL()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   
	include("templates/gl.php");
}

function editGL($id) 
{
	$frm=fillForm($id, false);
   $frm['accounttype']='All';
   $frm['filtertype']='All';
	$frm["newaction"] = "commit";

	include("templates/gl.php");
}

function browseGL($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/gl.php");
}

function insertGL($frm) 
{
   $qry=sprintf(ledger_gl_qry4,$frm['journalid'],$frm['ledgerid'],$frm['accountid'],$frm['entereddate'],
      $frm['description'],YN($frm['debit']),$frm['amount'],YN($frm['posted']),$frm['referenceid']);

	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitGL($frm) 
{
   $qry=sprintf(ledger_gl_qry5,$frm['journalid'],$frm['ledgerid'],$frm['accountid'],$frm['entereddate'],
      $frm['description'],YN($frm['debit']),$frm['amount'],YN($frm['posted']),$frm['referenceid'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($query);
}

function deleteGL($id) 
{
   $qry=sprintf(ledger_gl_qry6,$id);
	$_SESSION['VxCFG']->dbh->Execute($query);
}

function LedgerCombo($a, $id)
{
   $l=new LedgerEntry();
   $l->LedgerCombo($a, $id, "ledgerid");
}

function TypeCombo($a, $id)
{
   $l=new LedgerEntry();
   $l->TypeCombo($a, $id, "typeid");
}

function PeriodCombo($a, $id)
{
   $l=new LedgerEntry();
   $l->PeriodCombo($a, $id, "periodid");
}

function AccountCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

function SearchValueControl($a, $acc, $ftype)
{
   switch($a){
   case "newsearch" :
      echo "<tr><td colspan=\"2\" align=\"center\" class=\"formdata\">";
      echo "<input type=submit value=\"Set Filter\"></label></td></tr>\n";
		break;
      
   case "searchparam" :
      echo "<tr><td colspan=\"2\" align=\"center\" class=\"formdata\">";
      echo "<input type=submit value=\"Set Filter\"></label></td></tr>\n";
      /*
      echo "<tr><td colspan=\"2\" class=\"tinsert\">\n";
      echo "</tr></td>\";
     echo "<td class=label><?php echo erp_gl_filtervalue ?></td>";
     echo "<td><?php entry($frm[\"newaction\"], "filtervalue\", 32, 64, $frm[\"filtervalue\"]) ?></td>";
     echo "<?php helpbutton('erp_gl_filtervalue')";
     echo "</tr>"; 
     */
     break;
      
   case "search":
      echo "<tr><td colspan=\"2\" align=\"center\" class=\"formdata\">";
      echo "<input type=submit value=\"Search\"></label></td></tr>\n";
      break;
   }
   
   /*
   <tr><td colspan="2" class="tinsert">
<?php SearchValueControl(); ?>
</tr></td>

  <td class=label><?php echo erp_gl_filtervalue ?></td>
  <td><?php entry($frm["newaction"], "filtervalue", 32, 64, $frm["filtervalue"]) ?></td>
  <?php helpbutton('erp_gl_filtervalue') ?>
</tr>
<tr><td colspan="2" align="center"><input type=submit value="Set Filter"></label></td></tr>
   */
}

function AccountTypeControl($a)
{
   echo "<select name=accounttype>\n";
   if($a=="all") echo "<option selected value=\"all\">"._("All")."</option>\n";
   else echo "<option value=\"all\">"._("All")."</option>\n";
   
   if($a=="account") echo "<option selected value=\"account\">"._("Account")."</option>\n";
   else echo "<option value=\"account\">"._("Account")."</option>\n";
   
   if($a=="parent") echo "<option selected value=\"parent\">"._("Category")."</option>\n";
   else echo "<option value=\"parent\">"._("Category")."</option>\n";
   
   if($a=="type") echo "<option selected value=\"type\">"._("Type")."</option>\n";
   else echo "<option value=\"type\">"._("Type")."</option>\n";
   
   echo "</select>\n";
}

function FilterTypeControl($a)
{
   echo "<select name=filtertype>\n";
   if($a=="none") echo "<option selected value=\"none\">"._("None")."</option>\n";
   else  echo "<option value=\"none\">"._("None")."</option>\n";
   
   if($a=="datebefore") echo "<option selected value=\"datebefore\">"._("Date Before")."</option>\n";
   else  echo "<option value=\"datebefore\">"._("Date Before")."</option>\n";
   
   if($a=="dateafter") echo "<option selected value=\"dateafter\">"._("Date After")."</option>\n";
   else  echo "<option value=\"dateafter\">"._("Date After")."</option>\n";
   
   if($a=="datebetween") echo "<option selected value=\"datebetween\">"._("Date Between")."</option>\n";
   else  echo "<option value=\"datebetween\">"._("Date Between")."</option>\n";
   
   if($a=="reconciled") echo "<option selected value=\"reconciled\">"._("Reconciled")."</option>\n";
   else  echo "<option value=\"reconciled\">"._("Reconciled")."</option>\n";
   
   if($a=="notreconciled") echo "<option selected value=\"notreconciled\">"._("Not Reconciled")."</option>\n";
   else  echo "<option value=\"notreconciled\">"._("Not Reconciled")."</option>\n";
   
   if($a=="settled") echo "<option selected value=\"settled\">"._("Settled")."</option>\n";
   else  echo "<option value=\"settled\">"._("Settled")."</option>\n";
   
   if($a=="notsettled") echo "<option selected value=\"notsettled\">"._("Not Settled")."</option>\n";
   else  echo "<option value=\"notsettled\">"._("Not Settled")."</option>\n";
   
   if($a=="user") echo "<option selected value=\"user\">"._("User")."</option>\n";
   else  echo "<option value=\"user\">"._("User")."</option>\n";
   
   if($a=="station") echo "<option selected value=\"station\">"._("Station")."</option>\n";
   else  echo "<option value=\"station\">"._("Station")."</option>\n";
   
   echo "</select>\n";
}

function listGL()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(ledger_gl_qry7, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no ledger entries defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ledger'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Ledger")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Ledger")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=ledger\">"._("Ledger")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='ledger'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='account'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Account")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Account")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=account\">"._("Account")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='account'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='amount'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Amount")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Amount")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=amount\">"._("Amount")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='amount'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

	while($row = $result->FetchRow()){
      if($row["ledgerid"]!=0){
         $qry=sprintf(ledger_gl_qry8, $row['ledgerid']);
         $aresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         $arow = $aresult->FetchRow();
	      $ledger=$arow["name"];
		}
      else{
         $ledger=_("Not Set");
      }
		if($row["accountid"]!=0){
         $qry=sprintf(ledger_gl_qry9, $row['accountid']);
         $aresult=$_SESSION['VxCFG']->dbh->Execute($qry);
	      $arow = $aresult->FetchRow();
	      $account=$arow["name"];
		}
      else{
         $account=_("Not Set");
      }
      echo "<tr><td class=\"listdata\">$ledger</td><td class=\"listdata\">$account</td><td class=\"listdata\">";
      if($row["debit"]=="Y"){
         echo "<font color=\"red\">".$row["amount"]."</font></td><td class=\"listdata\">";
      }
      else{
         echo $row["amount"]."</td><td class=\"listdata\">";
      }
      
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"gl.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"gl.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"gl.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"gl.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"gl.php?action=edit&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"gl.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
