<?php
/*
 address.php
 
 Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
require_once("country.php");

/**
 * @defgroup address Address
 * @{
 */

/**
 \class AddressType
 \brief A class to handle address types
*/
class AddressType
{
   var $id;
   var $name;
   
   /*! Constructoe.
		\param id
		\return nothing.
	*/
   function AddressType($id=false)
   {
      if($id){
         if($this->Fill($id)){
            return true;
         }
      }
      $this->id=0;
      $this->name='';
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id)
   {
      if($id==0){
         return false;
      }
      
      $qry=sprintf(address_qry20, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->name=$row["name"];

         return true;
      }
      return false;
   }
   
   function Set($n)
   {
      $this->name=$n;
   }
   
   function SetFromForm($frm)
   {
      $this->name=$frm['name'];
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(address_qry19);
         echo "<select name=\"$cname\">\n";
   	   while($row = $result->FetchRow()){
   	   	$boo=$row["id"];
	   	   $poo=$row["name"];
   	   	if($id==$boo){
	   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
   		   }
      		else{
	      		echo "<option value=\"$boo\"> $poo </option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(address_qry20, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row["name"];
         }
         else{
            echo "&nbsp;";
         }
      }
   }
   
   function Add()
   {
      $qry=sprintf(address_qry2, $this->name);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(address_qry3, $this->name, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(address_qry4, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      if($this->id==0){
         $this->Fill($id);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
	      echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
	   echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">"._("Name")."</td>\n";
      echo "<td>";
	   entry($a, "name", 68, 64, $this->name);
   	echo"</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $query="SELECT * FROM addresstype WHERE ";
      if($this->name!=''){
         $query.="name='$this->name'";
      }
      
      $result=$_SESSION['VxCFG']->dbh->Execute($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>"._("No matching Item Type found for search Criteria")."</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>"._("Found ").$n._(" Matches")."</h3></td></tr>\n";
      echo "<tr><td><h3>Name</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[name]</b>";
         }
         else{
             echo $row['name'];
         }
      }
      echo "</table>\n";
      
      return true;
   }
}
/**
 \class Address
 \brief A class to handle addresses
*/
class Address
{
   var $id;
   var $addressid;
   var $typeid;
   var $address1;
	var $address2;
	var $address3;
	var $city;
   var $state;
	var $postcode;
	var $countryid;
   
   function Address($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->addressid=0;
      $this->typeid=0;
      $this->address1='';
	   $this->address2='';
      $this->address3='';
	   $this->city='';
      $this->state='';
      $this->postcode='';
	   $this->countryid=0;
   }
   
   function Getid() { return $this->id; }
   
   function Get($what) 
   {
      switch($what){
      case 'city':  return $this->city;
      case 'state':  return $this->state;
      case 'postcode':  return $this->postcode;
      }      
   }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(address_qry2, $id);
      }
      else{
         $qry=sprintf(address_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->addressid=$row["addressid"];
         $this->typeid=$row["typeid"];
         $this->address1=$row["address1"];
         $this->address2=$row["address2"];
         $this->address3=$row["address3"];
         $this->city=$row["city"];
         $this->state=$row["state"];
	      $this->postcode=$row["postcode"];
	      $this->countryid=$row["countryid"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i)
   {
      $this->addressid=$a;
      $this->typeid=$b;
      $this->address1=$c;
	   $this->address2=$d;
   	$this->address3=$e;
	   $this->city=$f;
      $this->state=$g;
   	$this->postcode=$h;
	   $this->countryid=$i;
   }
   
   function setfromform($frm)
   {
      if(isset($frm["addressid"])){
         if($frm["addressid"]!=""){
            $this->addressid=$frm["addressid"];
         }
         else{
            $this->addressid=0;
         }
      }
      else{
            $this->addressid=0;
      }
      if(isset($frm["typeid"])){
         if($frm["typeid"]!=""){
            $this->typeid=$frm["typeid"];
         }
         else{
            $this->typeid=1;
         }
      }
      else{
          $this->typeid=1;
      }
      
      $this->address1=$frm['address1'];
	   $this->address2=$frm['address2'];
   	$this->address3=$frm['address3'];
	   $this->city=$frm['city'];
      $this->state=$frm['state'];
   	$this->postcode=$frm['postcode'];
	   $this->countryid=$frm['countryid'];
   }
   
   function Add()
   {
      $qry=sprintf(address_qry4, $this->addressid,$this->typeid,$this->address1,$this->address2,$this->address3,
         $this->city,$this->state,$this->postcode,$this->countryid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      if($this->addressid==0 || $this->addressid==""){
         $qry=sprintf(address_qry23, $this->id, $this->id);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(address_qry5, $this->addressid,$this->typeid,$this->address1,$this->address2,$this->address3,
         $this->city,$this->state,$this->postcode,$this->countryid, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(address_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Template($id=false, $smarty)
   {
      if(isset($id)){
         Fill($id);
      }
      $smarty->assign('id', $this->id);
      $smarty->assign('addressid', $this->addressid);
      $smarty->assign('typeid', $this->typeid);
      $smarty->assign('address1', $this->address1);
      $smarty->assign('address2', $this->address2);
      $smarty->assign('address3', $this->address3);
      $smarty->assign('city', $this->city);
      $smarty->assign('state', $this->state);
      $smarty->assign('postcode', $this->postcode);
      $smarty->assign('countryid', $this->countryid);
   }
   
   function Soap($a, $id, $client)
   {
      if(isset($id)){
         Fill($id);
      }
      $addr=array(
         'addressid'=>$this->addressid,
         'typid'=> $this->typeid,
         'address1' => $this->address1,
         'address2' => $this->address2,
         'address3' => $this->address3,
         'city' => $this->city,
         'state' => $this->state,
         'postcode' => $this->postcode,
         'countryid' => $this->countryid);
         
      switch($a){
      case 'get':
         $row = $client->call('getaddress', $id);
         break;
      case 'add':
         $row = $client->call('addaddress', $addr);
         $this->id=$row[0];
         break;
      case 'commit':
         $row = $client->call('setaddress', $addr);
         break;
      case 'delete':
         $row = $client->call('deleteaddress', $id);
         break;
      default:
         return false;
      }
      
      if($client->fault){
         return false;
      } 
      $err = $client->getError();
      if($err){
         return false;
      }
      
      if($a=='get'){
         if($row["id"]==0) return false;
         $this->id=$row["id"];
         $this->address1=$row["address1"];
         $this->address2=$row["address2"];
         $this->address3=$row["address3"];
         $this->city=$row["city"];
         $this->state=$row["state"];
	      $this->postcode=$row["postcode"];
	      $this->countryid=$row["countryid"];
      }

      return true;
   }
   
   function ComboParameter()
   {
      echo "<select name=\"adddressparam\">\n";
   	echo "<option value='0'>Not Set</option>\n";
      echo "<option value='address1'>"._("Address 1")."</option>\n";
      echo "<option value='address2'>"._("Address 2")."</option>\n";
      echo "<option value='address3'>"._("Address 3")."</option>\n";
      echo "<option value='city'>"._("City")."</option>\n";
      echo "<option value='state'>"._("County")."</option>\n";
      echo "<option value='postcode'>"._("Post Code")."</option>\n";
      echo "<option value='country'>"._("Country")."</option>\n";
      echo "</select>\n";
   }
   
   function LabelLayout($id)
   {
      $qry=sprintf(address_qry7, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if($result->RecordCount()==0) return false;
      $row = $result->FetchRow();
      $addr="";
      if($row["address1"]!=""){
         $addr.=$row["address1"]."\n";
      }
      if($row["address2"]!=""){
         $addr.=$row["address2"]."\n";
      }
      if($row["address3"]!=""){
         $addr.=$row["address3"]."\n";
      }
      if($row["city"]!=""){
         $addr.=$row["city"]."\n";
      }
      if($row["state"]!=""){
         $addr.=$row["state"]."\n";
      }
      if($row["postcode"]!=""){
         $addr.=$row["postcode"]."\n";
      }
      if($row["countryid"]!=0){
         $qry=sprintf(misc_qry7, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            $addr.=$row["name"]."\n";
         }
      }
      return $addr;
   }
   
   function FillList($a, $id)
   {
      $qry=sprintf(address_qry21, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      
      echo "<table class=\"listtable\">\n";
      if($result->RecordCount()==0){
         echo "<tr><td colspan=\"2\">"._("There are no addresses defined")."</td></td></table>\n";
         exit;
      }
      
      echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='type'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=type\">"._("Type")."</a></td></tr></table>\n</td>\n";
      }
   
      if($sorton=='type'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
   
      echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='address1'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Address 1")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Address 1")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=address1\">"._("Address 1")."</a></td></tr></table>\n</td>\n";
      }
   
      if($sorton=='address1'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
      
      echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='city'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("City")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("City")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=city\">"._("City")."</a></td></tr></table>\n</td>\n";
      }
   
      if($sorton=='city'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
      
      echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='postcode'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Post Code")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Post Code")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=postcode\">"._("Post Code")."</a></td></tr></table>\n</td>\n";
      }
   
      if($sorton=='postcode'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
      echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
	   while($row = $result->FetchRow()){
         echo "<tr><td class=\"listdata\">";
         $t=new AddressType();
         $t->Combo("browse", $row['typeid'], "typeid");
         echo "</td>\n<td class=\"listdata\">".$row['address1']."</td>\n";
         echo "<td class=\"listdata\">".$row['city']."</td>\n";
         echo "<td class=\"listdata\">".$row['postcode']."</td>\n";
      }
   }
   
   function FillListTable($a, $id)
   {
      $qry=sprintf(address_qry22, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      
      if($result->RecordCount()==0){
         if($a=='browse'){
            echo "<table class=\"formtable\">\n"; 
            echo "<tr><td colspan=\"2\">"._("There are no addresses defined")."</td></td></table>\n";
            return;
         }
         else{
            echo "<fieldset>\n";
            echo "<legend>";
            $t=new AddressType();
            $t->Combo($a, 1, 'typeid');
            echo "</legend>\n";
            echo "<table>\n"; 
      	   echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("Address 1")."</td>\n";
            echo "<td class=\"formdata\">";
      	   entry($a, "address1", 68, 64, "");
         	echo"</td>\n";
	         echo "</tr>\n";
	
      	   echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("Address 2")."</td>\n";
            echo "<td class=\"formdata\">";
   	      entry($a, "address2", 68, 64, "");
      	   echo"</td>\n</tr>\n";

      	   echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("Address 3")."</td>\n";
         	echo "<td class=\"formdata\">";
            entry($a, "address3", 68, 64,"");
         	echo"</td>\n</tr>\n";

         	echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("City")."</td>\n";
            echo "<td class=\"formdata\">";
   	      entry($a, "city", 68, 64, "");
      	   echo "</td>\n</tr>\n";
   
            echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("County")."</td>\n";
            echo "<td class=\"formdata\">";
      	   entry($a, "state", 32, 32, "");
         	echo "</td>\n</tr>\n";

   	      echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("Post Code")."</td>\n";
            echo "<td class=\"formdata\">";
	         entry($a, "postcode", 32, 32, "");
      	   echo "</td>\n</tr>\n";
	
         	echo "<tr>\n";
            echo "<td class=\"formlabel\">"._("Country")."</td>\n";
            echo "<td class=\"formdata\">";
            $c=new Country();
            $c->Combo($a, 0, "countryid");
      	   echo "</td>\n</tr>\n</table>\n</fieldset>\n";
            
            return;
         }
      }
      echo "<table class=\"formtable\">\n"; 
      while($row = $result->FetchRow()){
         echo "<tr><td class=\"formfieldset\">\n<fieldset>\n";
         echo "<legend>";
         $t=new AddressType();
         $t->Combo($a, $row['typeid'], 'typeid');
         echo "</legend>\n";
         echo "<table>\n"; 
         $typeid=$row['typeid'];
   	   echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("Address 1")."</td>\n";
         echo "<td class=\"formdata\">";
   	   entry($a, $typeid."_address1", 68, 64, $row['address1']);
      	echo"</td>\n";
	      echo "</tr>\n";
	
      	echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("Address 2")."</td>\n";
         echo "<td class=\"formdata\">";
   	   entry($a, $typeid."_address2", 68, 64, $row['address2']);
      	echo"</td>\n</tr>\n";

   	   echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("Address 3")."</td>\n";
      	echo "<td class=\"formdata\">";
         entry($a, $typeid."_address3", 68, 64,$row['address3']);
      	echo"</td>\n</tr>\n";

      	echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("City")."</td>\n";
         echo "<td class=\"formdata\">";
	      entry($a, $typeid."_city", 68, 64, $row['city']);
   	   echo "</td>\n</tr>\n";
   
         echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("County")."</td>\n";
         echo "<td class=\"formdata\">";
   	   entry($a, $typeid."_state", 32, 32, $row['state']);
      	echo "</td>\n</tr>\n";

   	   echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("Post Code")."</td>\n";
         echo "<td class=\"formdata\">";
	      entry($a, $typeid."_postcode", 32, 32, $row['postcode']);
      	echo "</td>\n</tr>\n";
	
      	echo "<tr>\n";
         echo "<td class=\"formlabel\">"._("Country")."</td>\n";
         echo "<td class=\"formdata\">";
         $c=new Country();
         $c->Combo($a, $row['countryid'], $typeid."_countryid");
   	   echo "</td>\n</tr>\n</table>\n</fieldset>\n</td>\n</tr>\n";
      }
      echo "</table>\n";
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      //if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      //}
      //else{
      //   $this->Fill($id, true);
      //}
      echo "<input type=\"hidden\" name=\"addressid\" value=\"".$this->addressid."\">\n";
      echo "<table>\n";
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Type")."</td>\n";
      echo "<td class=\"formdata\">";
      $t=new AddressType();
      $t->Combo($a, $this->typeid, 'typeid');
   	echo"</td>\n";
	   echo "</tr>\n";
      
	   echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Address 1")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "address1", 68, 64, $this->address1);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Address 2")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "address2", 68, 64, $this->address2);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Address 3")."</td>\n";
   	echo "<td class=\"formdata\">";
      entry($a, "address3", 68, 64,$this->address3);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("City")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "city", 68, 64, $this->city);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("County")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "state", 32, 32, $this->state);
   	echo "</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Post Code")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "postcode", 32, 32, $this->postcode);
   	echo "</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Country")."</td>\n";
      echo "<td class=\"formdata\">";
      $c=new Country();
      $c->Combo($a, $this->countryid, "countryid");
   	echo "</td>\n";
	   echo "</tr>\n";
      
   	echo "</table>\n";
   }
   
   function Find($bOutput)
   {
      $band=0;
      $ba1=0;
      $ba2=0;
      $ba3=0;
      $bc=0;
      $bs=0;
      $bp=0;
      $bcn=0;
      
      $query="select * from address where ";
      if($this->address1!=''){
         $query.="address1='$this->address1'";
         $ba1=1;
         $band=1;
      }
      if($this->address2!=''){
         if($band==0){
            $query.="address2='$this->address2'";
            $band=1;
         }
         else{
            $query.="and address2='$this->address2'";
         }
         $ba2=1;
      }
      if($this->address3!=''){
         if($band==0){
            $query.="address3='$this->address3'";
            $band=1;
         }
         else{
            $query.="and address3='$this->address3'";
         }
         $ba3=1;
      }
      if($this->city!=''){
         if($band==0){
            $query.="city='$this->city'";
            $band=1;
         }
         else{
            $query.="and city='$this->city'";
         }
         $bc=1;
      }
      if($this->state!=''){
         if($band==0){
            $query.="state='$this->state'";
            $band=1;
         }
         else{
            $query.="and state='$this->state'";
         }
         $bs=1;
      }
      if($this->postcode!=''){
         if($band==0){
            $query.="postcode='$this->postcode'";
            $band=1;
         }
         else{
            $query.="and postcode='$this->postcode'";
         }
         $bp=1;
      }
      if($this->countryid!=''){
         if($band==0){
            $query.="countryid='$this->countryid'";
            $band=1;
         }
         else{
            $query.="and countryid='$this->countryid'";
         }
         $bcn=1;
      }
      
      $result=db_query($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>"._("No matching Address found for search Criteria")."</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>"._("Found ").$n._(" Matches")."</h3></td></tr>\n";
      echo "<tr><td><h3>"._("Address 1")."</h3></td><td><h3>"._("Address 2")."</h3></td><td><h3>"._("Address 3")."</h3></td>\n";
      echo "<td><h3>"._("City")."</h3></td><td><h3>"._("County")."</h3></td><td><h3>"._("Post Code")."</h3></td><td><h3>"._("Country")."</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[address1]</b>";
         }
         else{
             echo $row['address1'];
         }
         echo "</td><td>";
         if($ba2){
            echo "<b>$row[address2]</b>";
         }
         else{
            echo $row['address2'];
         }
         echo "</td><td>";
         if($ba3){
            echo "<b>$row[address3]</b>";
         }
         else{
            echo $row['address3'];
         }
         echo "</td><td>";
         if($bc){
            echo "<b>$row[city]</b>";
         }
         else{
            echo $row['city'];
         }
         echo "</td><td>";
         if($bs){
            echo "<b>$row[state]</b>";
         }
         else{
            echo $row['state'];
         }
         echo "</td><td>";
         if($bp){
            echo "<b>$row[postcode]</b>";
         }
         else{
            echo $row['postcode'];
         }
         echo "</td><td>";
         if($bcn){
            echo "<b>$row[countryid]</b>";
         }
         else{
            echo $row['countryid'];
         }
         echo "</td></tr>\n";
      }
      echo "</table>\n";
      
      return true;
   }
}

/* @} */

?>
