<?php
/*
 attribute.php
 
 Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

/**
 * @defgroup attribute Attribute
 * @{
 */

define("VXMIS_ATTRIB_TYPE_TEXT", "1");
define("VXMIS_ATTRIB_TYPE_INT", "2");
define("VXMIS_ATTRIB_TYPE_BOOL", "3");
define("VXMIS_ATTRIB_TYPE_FLOAT", "4");
define("VXMIS_ATTRIB_TYPE_CURRENCY", "5");
define("VXMIS_ATTRIB_TYPE_DATE", "6");
define("VXMIS_ATTRIB_TYPE_TIME", "7");
define("VXMIS_ATTRIB_TYPE_DATETIME", "8");
define("VXMIS_ATTRIB_TYPE_BINARY", "9");

define ("VXMIS_ATTRIB_FOCUS_NONE", "0");
define ("VXMIS_ATTRIB_FOCUS_MISSYSTEM", "1");
define ("VXMIS_ATTRIB_FOCUS_MIS", "2");
define ("VXMIS_ATTRIB_FOCUS_COMPANY", "2");
define ("VXMIS_ATTRIB_FOCUS_PRODUCT", "3");
define ("VXMIS_ATTRIB_FOCUS_SUPPLIER", "4");
define ("VXMIS_ATTRIB_FOCUS_CUSTOMER", "5");
define ("VXMIS_ATTRIB_FOCUS_CART", "6");
define ("VXMIS_ATTRIB_FOCUS_CARTSYSTEM", "7");
define ("VXMIS_ATTRIB_FOCUS_EMPLOYEE", "8");
define ("VXMIS_ATTRIB_FOCUS_STATION", "9");
define ("VXMIS_ATTRIB_FOCUS_BANK", "10");
define ("VXMIS_ATTRIB_FOCUS_SYSTEM", "10");

/**
 \class Attribute
 \brief A generic attribute handling class 
*/
class Attribute
{
   var $target;
   var $id;
   var $attributeid;
   var $name;
	var $type;
	var $format;
	var $mask;
	var $value;
   
   function Attribute($t=false, $id=false)
   {
      if($t && $id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->target=VXMIS_ATTRIB_FOCUS_NONE;
      $this->id=0;
      $this->attributeid=0;
      $this->name='';
      $this->type=0;
      $this->format='';
      $this->mask='';
      $this->value='';
   }
   
   function SetTarget($t) { $this->target=$t; }
   function GetTarget() { return $this->target; }
   function Getid() { return $this->id; }
   
   function TableName($t)
   {
      switch($t){
      case VXMIS_ATTRIB_FOCUS_SYSTEM: return "systemattribute";
      case VXMIS_ATTRIB_FOCUS_MIS: return "misattribute";
      case VXMIS_ATTRIB_FOCUS_MISSYSTEM: return "missystemattribute";
      case VXMIS_ATTRIB_FOCUS_COMPANY: return "companyattribute";
      case VXMIS_ATTRIB_FOCUS_PRODUCT: return "productattribute";
      case VXMIS_ATTRIB_FOCUS_SUPPLIER: return "supplierattribute";
      case VXMIS_ATTRIB_FOCUS_CUSTOMER: return "customerattribute";
      case VXMIS_ATTRIB_FOCUS_CART: return "cartattribute";
      case VXMIS_ATTRIB_FOCUS_CARTSYSTEM: return "cartsystemattribute";
      case VXMIS_ATTRIB_FOCUS_EMPLOYEE: return "employeeattribute";
      case VXMIS_ATTRIB_FOCUS_STATION: return "stationattribute";
      case VXMIS_ATTRIB_FOCUS_BANK: return "bankattribute";
      
      default:
      case VXMIS_ATTRIB_FOCUS_NONE:
         return false;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($this->target==VXMIS_ATTRIB_FOCUS_NONE){
         return false;
      }
      if($id==0){
         return false;
      }
      if(!($tn=TableName($t))) return false;
      if($bOffset){
         $qry=sprintf(attriute_qry3, $tn, $id);
      }
      else{
         $qry=sprintf(attriute_qry4, $tn, $id);
      }
      
      
	   if(!($result=$_SESSION['VxCFG']->dbh->Execute($qry))) return false;
      if($row = $result->FetchRow()){
         $this->id=$row["id"];
         $this->attributeid=$row["attributeid"];
         $this->name=$row["name"];
         $this->typeid=$row["typeid"];
         $this->name=$row["name"];
         $this->format=$row["format"];
         $this->mask=$row["mask"];
         $this->value=$row["values"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f)
   {
      $this->attributeid=$a;
      $this->name=$b;
      $this->type=$c;
      $this->format=$d;
      $this->mask=$e;
      $this->value=$f;
   }
   
   function setfromform($frm)
   {
      $this->attributeid=$frm["attributeid"];
      $this->name=$frm["name"];
      $this->type=$frm["type"];
      $this->format=$frm["format"];
      $this->mask=$frm["mask"];
      $this->value=$frm["value"];
   }
   
   function Add()
   {
      if(!($tn=TableName($this->target))) return false;
      $qry=sprintf(attribute_qry5, $tn, $this->name,$this->type,$this->format,$this->mask,$this->value);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       $qry=sprintf(attribute_qry6, $ts, $this->id);
       $_SESSION['VxCFG']->dbh->Execute($qry);
       //$this->attributeid, 
       return $this->id;
   }
   
   function Commit($id)
   {
      if(!($tn=TableName($this->target))) return false;
      $qry=sprintf(attribute_qry7, $tn, $this->name,$this->type,$this->format,$this->mask,$this->value,$id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      if(!($tn=TableName($this->target))) return false;
      $qry=sprintf(attribute_qry7, $tn, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Template($id=false, $smarty)
   {
      if(isset($id)){
         Fill($id);
      }
      $smarty->assign('id', $this->id);
      $smarty->assign('attibuteid', $this->attributeid);
      $smarty->assign('name', $this->name);
      $smarty->assign('type', $this->type);
      $smarty->assign('format', $this->format);
      $smarty->assign('mask', $this->mask);
      $smarty->assign('value', $this->value);
   }
   
   function Soap($a, $id, $client)
   {
      if(isset($id)){
         Fill($id);
      }
      $addr=array(
         'attributeid'=>$this->attributeid,
         'name'=> $this->name,
         'type' => $this->type,
         'format' => $this->format,
         'mask' => $this->mask,
         'value' => $this->value);
         
      switch($a){
      case 'get':
         $row = $client->call('getattribute', $id);
         break;
      case 'add':
         $row = $client->call('addattribute', $addr);
         $this->id=$row[0];
         break;
      case 'commit':
         $row = $client->call('setattribute', $addr);
         break;
      case 'delete':
         $row = $client->call('deleteattribute', $id);
         break;
      default:
         return false;
      }
      
      if($client->fault){
         return false;
      } 
      $err = $client->getError();
      if($err){
         return false;
      }
      
      if($a=='get'){
         if($row["id"]==0) return false;
         $this->id=$row["id"];
         $this->attributeid=$row["attributeid"];
         $this->name=$row["name"];
         $this->type=$row["type"];
         $this->format=$row["format"];
         $this->mask=$row["mask"];
	      $this->value=$row["value"];
      }

      return true;
   }
   
   function ComboType($a, $t)
   {
      if($a=="commit" || $a=="add"){
         echo "<select name=\"type\">\n";
      	if($t==0) echo "<option selected value='0'>"._("Not Set")."</option>\n";
         else echo "<option value='0'>"._("Not Set")."</option>\n";
         if($t==1) echo "<option selected value='1'>"._("String")."</option>\n";
         else echo "<option value='1'>"._("String")."</option>\n";
         if($t==2) echo "<option selected value='2'>"._("Integer")."</option>\n";
         else echo "<option value='2'>"._("Integer")."</option>\n";
         if($t==3) echo "<option selected value='3'>"._("Boolean")."</option>\n";
         else echo "<option value='3'>"._("Boolean")."</option>\n";
         if($t==4) echo "<option selected value='4'>"._("Currency")."</option>\n";
         else echo "<option value='4'>"._("Currency")."</option>\n";
         if($t==5) echo "<option selected value='5'>"._("Date")."</option>\n";
         else echo "<option value='5'>"._("Date")."</option>\n";
         if($t==6) echo "<option selected value='6'>"._("Time")."</option>\n";
         else echo "<option value='6'>"._("Time")."</option>\n";
         if($t==7) echo "<option selected value='7'>"._("Datetime")."</option>\n";
         else echo "<option value='7'>"._("Datetime")."</option>\n";
         echo "</select>\n";
      }
      else{
         switch($t){
         case 0: echo _("Not Set"); break;
         case 1: echo _("String"); break;
         case 2: echo _("Integer"); break;
         case 3: echo _("Boolean"); break;
         case 4: echo _("Currency"); break;
         case 5: echo _("Date"); break;
         case 6: echo _("Time"); break;
         case 7: echo _("Datetime"); break;
         }
      }
   }
   
   function ComboValue($a, $t)
   {
      if($a=="commit" || $a=="add"){
         echo "\n";
      }
      else{
         echo _("Not Set"); break;
      }
   }
   
   function FillList($a, $t, $id)
   {
      if(!($tn=TableName($t))) return false;
      $qry=sprintf(attribute_qry2, $tn, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      echo "<fieldset>\n<legend>"._("Attributes")."</legend>\n<table>\n";
      
      if(!result){
         echo "<tr><td colspan=\"2\">"._("There are no attributes defined")."</td></td></table>\n";
         return false;
      }
      if($result->RecordCount()==0){
         echo "<tr><td colspan=\"2\">"._("There are no attributes defined")."</td></td></table>\n";
         return false;
      }
      echo "<tr>\n<td class=\"inlisttitle\">"._("Name")."</td>\n";
      echo "<td class=\"inlisttitle\">"._("Value")."</td>\n</tr>\n";
      
      while($row = $result->FetchRow()){
         echo "<tr><td class=\"inlistdata\">\n";
         entry($frm["newaction"], "name", 32, 32, $row["name"]);
         echo "</td>\n<td class=\"inlistdata\">";
         entry($frm["newaction"], "value", 32, 32, $row['value']);
		   echo "</td></tr>\n";
      }
      echo "</table>\n</fieldset>\n";
   }
   
  function FillListTable($a, $t, $id, $bShort=true)
   {
      if(!($tn=TableName($t))) return false;
      $qry=sprintf(attribute_qry2, $tn, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      
      echo "<table class=\"listtable\">\n";
      if(!result){
         echo "<tr><td colspan=\"2\">"._("There are no attributes defined")."</td></td></table>\n";
         return false;
      }
      if($result->RecordCount()==0){
         echo "<tr><td colspan=\"2\">"._("There are no attributes defined")."</td></td></table>\n";
         return false;
      }
      
      echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='name'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
      }
      if($sorton=='name'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
      if(!bShort){
         echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
         if($sorton=='type'){
            if($sortorder=='asc'){
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
            }
            else{
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
            }
         }
         else{
            echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=type\">"._("Type")."</a></td></tr></table>\n</td>\n";
         }
         if($sorton=='type'){
            echo "<td class=\"listsortimg\">";
            if($sortorder=='asc'){
               echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
            }
            else{
                  echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
            }
         }
   
         echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
         if($sorton=='format'){
            if($sortorder=='asc'){
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Format")."</a></td>\n";
            }
            else{
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Format")."</a></td>\n";
            }
         }
         else{
            echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=format\">"._("Format")."</a></td></tr></table>\n</td>\n";
         }
   
         if($sorton=='format'){
            echo "<td class=\"listsortimg\">";
            if($sortorder=='asc'){
               echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
            }
            else{
               echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
            }
         }
      
         echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
         if($sorton=='mask'){
            if($sortorder=='asc'){
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Mask")."</a></td>\n";
            }
            else{
               echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Mask")."</a></td>\n";
            }
         }
         else{
            echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=mask\">"._("Mask")."</a></td></tr></table>\n</td>\n";
         }
         if($sorton=='mask'){
            echo "<td class=\"listsortimg\">";
            if($sortorder=='asc'){
               echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
            }
            else{
               echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
            }
         }
      }      
      echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
      if($sorton=='value'){
         if($sortorder=='asc'){
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Value")."</a></td>\n";
         }
         else{
            echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Value")."</a></td>\n";
         }
      }
      else{
         echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=value\">"._("Value")."</a></td></tr></table>\n</td>\n";
      }
      if($sorton=='value'){
         echo "<td class=\"listsortimg\">";
         if($sortorder=='asc'){
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
         }
         else{
            echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
         }
      }
      echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
	   while($row = $result->FetchRow()){
         echo "<tr>\n<td class=\"listdata\">";
         entry($frm["newaction"], "name", 32, 32, $row["name"]);
         echo "</td>\n";
         if(!bShort){
            echo "<td class=\"listdata\">";
            ComboType($a, $row['type']);
            echo "</td>\n<td class=\"listdata\">";
            entry($frm["newaction"], "format", 32, 32, $row['format']);
            echo "</td>\n<td class=\"listdata\">";
            entry($frm["newaction"], "format", 32, 32, $row['mask']);
            echo "</td>\n";
         }
         echo "<td class=\"listdata\">";
         entry($frm["newaction"], "format", 32, 32, $row['value']);
         echo "<td class=\"listdata\">";
		   $wibbler=$row["id"];
   		if($_SESSION['vxmisuser']->GetShowImages()){
            echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		         echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
	   	      echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
            }
         }
         else{
         	echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\">"._("View")."</a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		         echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
	   	      echo "<a href=\"".$_SERVER['PHP_SELF']."?action=attributelist&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
            }
         }
		   echo "</td></tr>\n";
      }
      echo "</table>\n";
   }
}

/* @} */

?>
