<?php
/*
calendar.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

//require_once 'Calendar.php';
require_once 'Calendar/Day.php';
require_once 'Calendar/Week.php';
require_once 'Calendar/Minute.php';
require_once 'Calendar/Month/Weekdays.php';
require_once 'Calendar/Decorator.php';

/**
 * @defgroup calendar Calendar
 * @{
 */

/**
 \class VxEvent
 \brief A class to handle events
*/
class VxEvent
{
   var $id;
   var $starts;
   var $ends;
   var $title;
   var $ownerid;
   var $events;
   
   function VxEvent($uid=null, $ts=null)
   {
      if(isset($uid)) $this->userid=$uid;
      
      if(isset($ts)){
         $t=substr($ts, 0, 10);
         $m=atoi(substr($ts, 10, 2));
         $m+=15;
         $ets=sprintf("%s%s:00",$t,$m);   
         $qry=sprintf(calendar_qry1, $this->userid, $ts, $ets);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!$result) return false;
         if(!$row=$result->FetchRow()) return false;
         $this->id=$row['id'];
         $this->starts=$row['starts'];
         $this->ends=$row['ends'];
         $this->title=$row['title'];
         //$this->userid=$row['ownerid'];
      }
      else{
         $this->id='';
         $this->starts='';
         $this->ends='';
         $this->title='';
         return false;
      }
   }
   
   function getID(){ return $this->id; }
   
   function Fill($id)
   {
      $qry=sprintf(calendar_qry1, $this->userid, $ts, $ets);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if(!$row=$result->FetchRow()) return false;
      $this->id=$row['id'];
      $this->starts=$row['starts'];
      $this->ends=$row['ends'];
      $this->title=$row['title'];
      $this->ownerid=$row['ownerid'];
   }
   
   function FillForm($id)
   {
      $qry=sprintf(useradmin_event_qry1, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if(!$row=$result->FetchRow()) return false;
      $this->id=$frm['id']=$row['id'];
      $this->starts=$frm['starts']=$row['starts'];
      $this->ends=$frm['ends']=$row['ends'];
      $this->title=$frm['title']=$row['title'];
      $this->ownerid=$frm['ownerid']=$row['ownerid'];
      return $frm;
   }
   
   function hasEvent($ts, $te)
   {
      $qry=sprintf(calendar_qry4, $this->userid, $ts, $te);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if(!($row=$result->FetchRow())) return false;
      return $row[0];
   }
   
   function getEvent($ts, $te)
   {
      $qry=sprintf(calendar_qry3, $this->userid, $ts, $te);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if($result->RecordCount()==0) return false;
      if(!($row=$result->FetchRow())) return false;
      $this->id=$row['id'];
      $this->starts=$row['starts'];
      $this->ends=$row['ends'];
      $this->title=$row['title'];
      return $this->title;
   }
   
   function build($ts, $te)
   {
      $qry=sprintf(calendar_qry3, $this->userid, $ts, $te);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      if($result->RecordCount()==0) return false;
      if(isset($this->events)){
         unset($this->events);
      }
      //$this->events=array();
      $bfirst=true;
      while(($row=$result->FetchRow())){
         if($bfirst){
            $this->events=array($row['id']=>array('starts'=>$row['starts'],'title'=>$row['title']));
            $bfirst=false;
         }
         else{
            $this->events[$row['id']]=array('starts'=>$row['starts'],'title'=>$row['title']);
         }
      }
      reset($this->events);
      return true;
   }
   
   function fetch()
   {
      if(!isset($this->events)) return false;
      $c=&current($this->events);
      next($this->events);
      return $c;
   }
}
/**
 \class VxToday
 \brief A class to handle today's events
*/
class VxToday extends Calendar_Decorator 
{
   function VxToday(&$calendar){
      parent::Calendar_Decorator($calendar);
   }

   // Overides the default fetch method of the calendar object
   function fetch() 
   {
      if($hour = parent::fetch()){
         // Recursive fetch, return only hours between 8am and 6pm
         if($hour->thisHour() < 8 || $hour->thisHour() > 17){
             return $this->fetch();
         } 
         else{
            return $hour;
         }
       } 
       else{
         return FALSE;
       }
   }
}

/**
 \class Vxweek
 \brief A class to handle this weeks events
*/
class VxWeek extends Calendar_Decorator 
{
   function VxWeek(&$calendar){
      parent::Calendar_Decorator($calendar);
   }

   function fetch() 
   {
      if($day = parent::fetch()){
         if($day->thisDay() < 8 || $hour->thisHour() > 17){
             return $this->fetch();
         } 
         else{
            return $day;
         }
       } 
       else{
         return FALSE;
       }
   }
}
/**
 \class VxMonth
 \brief A class to handle this months events
*/
class VxMonth extends Calendar_Decorator {
   /**
   * @param Calendar_Month
   */
   function VxMonth(& $Month) {
       parent::Calendar_Decorator($Month);
   }
   /**
   * Override the prevMonth method to format the output
   */
   function prevMonth() {
       $prevStamp = parent::prevMonth(TRUE);
       // Build the URL for the previous month
       return $_SERVER['PHP_SELF'].'?y='.date('Y',$prevStamp).
           '&m='.date('n',$prevStamp).'&d='.date('j',$prevStamp);
   }
   /**
   * Override the thisMonth method to format the output
   */
   function thisMonth() {
       $thisStamp = parent::thisMonth(TRUE);
       // A human readable string from this month
       return date('F Y',$thisStamp);
   }
   /**
   * Override the nextMonth method to format the output
   */
   function nextMonth() {
       $nextStamp = parent::nextMonth(TRUE);
       // Build the URL for next month
       return $_SERVER['PHP_SELF'].'?y='.date('Y',$nextStamp).
           '&m='.date('n',$nextStamp).'&d='.date('j',$nextStamp);
   }
} 
/**
 \class VxCalendar
 \brief A class to handle general calendar stuff
*/
class VxCalendar //extends Calendar
{
   var $day;
   var $month;
   var $year;
   var $employeeid;
   
   function VxCalendar($eid, $v=null) 
   {
      $this->employeeid=$eid;
      if(isset($v)){
         $this->day=date('d', $v);
         $this->month=date('m', $v);
         $this->year=date('Y', $v);
      }
      else{
         $this->day=date('d');
         $this->month=date('m');
         $this->year=date('Y');
      }
   }

   function setDate($date=null) 
   {
      
	}
   
   function drawToday()
   {
      $day=new Calendar_Day($this->year, $this->month, $this->day);
      $day->build();
      $today = new VxToday($day);
      //$e= new VxEvent($this->employeeid);
      $e= new VxEvent(1);
      
      echo "<table class=\"cal\" cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
      echo "<tr><td class=\"caldaynav\" colspan=\"2\">";
      echo "<table class=\"caldaynav\"><tr>";
      $xday=$today->prevDay(true);
      //$xday=new Calendar_Day(date('Y'), date('m'), date('d')-1);
      echo "<td class=\"caldaynav\" align=\"left\"><a href=\"".$_SERVER['PHP_SELF']."?action=d&v=".$xday."\">";
      echo strftime("%A %d %B", $xday);
      echo "</a></td>\n";
      echo "<td class=\"caldaynav\" align=\"center\">";
      echo strftime("%A %d %B", $today->getTimestamp());
      echo "</td>\n";
      $xday=$today->nextDay(true);
      echo "<td class=\"caldaynav\" align=\"right\"><a href=\"".$_SERVER['PHP_SELF']."?action=d&v=".$xday."\">";
      echo strftime("%A %d %B", $xday);
      echo "</a></td>\n";
      echo "</tr>\n</table>\n</td>\n</tr>\n";

      $z=localtime();
      //print_r($z);
      $curr_ts=strftime("%G-%m-%d ", $today->getTimestamp());
      $curr_hour=$z[2];
      $curr_min=$z[1];
      $curr_now=$curr_ts.$curr_hour.":".$curr_min.":00";
      
      while($hour = $today->fetch()){
         $hr=$hour->thisHour();
         $h=sprintf("%02d", $hr);
         //echo $today->thisMonth()."-".$today->thisYear();
         if($today->thisDay() < date('d') && ($today->thisMonth() == date('m') || $today->thisMonth() < date('m')) &&
            ($today->thisYear() == date('Y') || $today->thisYear() < date('Y'))){
            echo "<tr>\n<td class=\"caltimehourb\">".$h.":00</td>\n";
            $ts=$curr_ts.$h.":00:00";
            $te=$curr_ts.$h.":14:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
            }
            
            echo "<td class=\"caltimeb\">".$h.":15</td>\n";
            $ts=$curr_ts.$h.":15:00";
            $te=$curr_ts.$h.":29:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
            }
            echo "<td class=\"caltimeb\">".$h.":30</td>\n";
            $ts=$curr_ts.$h.":30:00";
            $te=$curr_ts.$h.":44:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
            }
            echo "<td class=\"caltimeb\">".$h.":45</td>\n";
            $ts=$curr_ts.$h.":45:00";
            $te=$curr_ts.$h.":59:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
            }
         }
         else if($today->thisDay()==date('d') && $today->thisMonth()==date('m')  && $today->thisYear()==date('Y')){
            if($hr < $curr_hour){
               echo "<tr>\n<td class=\"caltimehourb\">".$h.":00</td>\n";
               $ts=$curr_ts.$h.":00:00";
               $te=$curr_ts.$h.":14:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
               }
            
               echo "<td class=\"caltimeb\">".$h.":15</td>\n";
               $ts=$curr_ts.$h.":15:00";
               $te=$curr_ts.$h.":29:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
               }
               echo "<td class=\"caltimeb\">".$h.":30</td>\n";
               $ts=$curr_ts.$h.":30:00";
               $te=$curr_ts.$h.":44:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
               }
               echo "<td class=\"caltimeb\">".$h.":45</td>\n";
               $ts=$curr_ts.$h.":45:00";
               $te=$curr_ts.$h.":59:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldatab\">&nbsp</td>\n</tr>\n";
               }
            }
            else if($hr == $curr_hour){
               echo "<tr>\n";
               if($curr_min >= 0){
                  $ts=$curr_ts.$h.":00:00";
                  $te=$curr_ts.$h.":14:00";
                  if($curr_min < 15){ // current slot
                     echo "<td class=\"caltimehours\">".$h.":00</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatas\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatas\">&nbsp</td>\n";
                     }
                  }
                  else{
                     echo "<td class=\"caltimeb\">".$h.":00</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatab\">&nbsp</td>\n";
                     }
                  }
               }
               echo "</tr>\n";
               
               if($curr_min > 14){
                  $ts=$curr_ts.$h.":15:00";
                  $te=$curr_ts.$h.":29:00";
                  if($curr_min < 30){ // current slot
                     echo "<td class=\"caltimehours\">".$h.":15</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatas\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatas\">&nbsp</td>\n";
                     }
                  }
                  else{
                     echo "<td class=\"caltimeb\">".$h.":15</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatab\">&nbsp</td>\n";
                     }
                  }
               }
               else{
                  echo "<td class=\"caltime\">".$h.":15</td>\n";
                  if($title=$e->getEvent($ts, $te)){
                     echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                  }
                  else{
                     echo "<td class=\"caldata\">&nbsp</td>\n";
                  }
               }
               echo "</tr>\n";
               
               if($curr_min > 29){
                  $ts=$curr_ts.$h.":30:00";
                  $te=$curr_ts.$h.":44:00";
                  if($curr_min < 45){ // current slot
                     echo "<td class=\"caltimehours\">".$h.":30</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatas\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatas\">&nbsp</td>\n";
                     }
                  }
                  else{
                     echo "<td class=\"caltimeb\">".$h.":30</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                     }
                     else{
                        echo "<td class=\"caldatab\">&nbsp</td>\n";
                     }
                  }
               }
               else{
                  echo "<td class=\"caltime\">".$h.":30</td>\n";
                  if($title=$e->getEvent($ts, $te)){
                     echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                  }
                  else{
                     echo "<td class=\"caldata\">&nbsp</td>\n";
                  }
               }
               echo "</tr>\n";
            
               if($curr_min > 45){
                  $ts=$curr_ts.$h.":45:00";
                  $te=$curr_ts.$h.":59:00";
                  if($curr_min < 59){ // current slot
                     echo "<td class=\"caltimehours\">".$h.":45</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatas\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n\n";
                     }
                     else{
                        echo "<td class=\"caldatas\">&nbsp</td>\n\n";
                     }
                  }
                  else{
                     echo "<td class=\"caltimehourb\">".$h.":45</td>\n";
                     if($title=$e->getEvent($ts, $te)){
                        echo "<td class=\"caldatab\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n\n";
                     }
                     else{
                        echo "<td class=\"caldatab\">&nbsp</td>\n\n";
                     }
                  }
               }
               else{
                  echo "<td class=\"caltime\">".$h.":45</td>\n";
                  if($title=$e->getEvent($ts, $te)){
                     echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n";
                  }
                  else{
                     echo "<td class=\"caldata\">&nbsp</td>\n";
                  }
               }
            
               echo "</tr>\n";
            }
            else{
               echo "<tr>\n<td class=\"caltimehour\">".$h.":00</td>\n";
               $ts=$curr_ts.$h.":00:00";
               $te=$curr_ts.$h.":14:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
               }
               echo "<td class=\"caltime\">".$h.":15</td>\n";
               $ts=$curr_ts.$h.":15:00";
               $te=$curr_ts.$h.":29:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
               }
               echo "<td class=\"caltime\">".$h.":30</td>\n";
               $ts=$curr_ts.$h.":30:00";
               $te=$curr_ts.$h.":44:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
               }
               echo "<td class=\"caltime\">".$h.":45</td>\n";
               $ts=$curr_ts.$h.":45:00";
               $te=$curr_ts.$h.":59:00";
               if(($title=$e->getEvent($ts, $te))){
                  echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
               }
               else{
                  echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
               }
            }
         }
         else{ // after today, month, year
            echo "<tr>\n<td class=\"caltimehour\">".$h.":00</td>\n";
            $ts=$curr_ts.$h.":00:00";
            $te=$curr_ts.$h.":14:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title<a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
            }
            echo "<td class=\"caltime\">".$h.":15</td>\n";
            $ts=$curr_ts.$h.":15:00";
            $te=$curr_ts.$h.":29:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title<a/></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
            }
            echo "<td class=\"caltime\">".$h.":30</td>\n";
            $ts=$curr_ts.$h.":30:00";
            $te=$curr_ts.$h.":44:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
              echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
            }
            echo "<td class=\"caltime\">".$h.":45</td>\n";
            $ts=$curr_ts.$h.":45:00";
            $te=$curr_ts.$h.":59:00";
            if(($title=$e->getEvent($ts, $te))){
               echo "<td class=\"caldata\"><a href=\"".$_SERVER['PHP_SELF']."?action=e&id=".$e->getID()."\">$title</a></td>\n</tr>\n";
            }
            else{
               echo "<td class=\"caldata\">&nbsp</td>\n</tr>\n";
            }
         }
      }
      echo "</table>\n";
   }
   
   function drawWeek()
   {
      $fw=$_SESSION['vxmisuser']->GetFirstWeekofYear();
      $fd=$_SESSION['vxmisuser']->GetFirstDayofWeek();
      $week=new Calendar_Week($this->year, $this->month, $this->day);
      $week->build();
      //$today = new VxWeek($week);
      //$e= new VxEvent($this->employeeid);
      $e= new VxEvent(1);
      echo "<table class=\"cal\" cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
      echo "<tr><td colspan=\"8\">";
      echo "<table>\n<tr>\n<td class=\"calweeknav\">"._("Week Number").": ";
      $lastweek = $week->prevWeek(TRUE);
      $lw=new Calendar_Week($this->year, $this->month, $this->day-7);
      //$n=23;
      $n=$lw->thisWeek('n_in_year');
      echo $n." - <a href=\"".$_SERVER['PHP_SELF']."?action=w&v=".$lastweek."\">".date('d',$lastweek)." ".date('M',$lastweek)." ".date('Y',$lastweek)."</a>";
      echo "</td>\n<td class=\"calweeknav\">"._("Week Number").": ";
      $thisweek = $week->thisWeek(TRUE);
      $n=$week->thisWeek('n_in_year');
      echo $n." - ".date('d',$thisweek)." ".date('M',$thisweek)." ".date('Y',$thisweek);
      echo "</td>\n<td class=\"calweeknav\">"._("Week Number").": ";
      $nextweek = $week->nextWeek(TRUE);
      $nw=new Calendar_Week($this->year, $this->month, $this->day+7);
      $n=$nw->thisWeek('n_in_year');
      echo $n." - <a href=\"".$_SERVER['PHP_SELF']."?action=w&v=".$nextweek."\">".date('d',$nextweek)." ".date('M',$nextweek)." ".date('Y',$nextweek)."</a>";
      echo "</td>\n</tr>\n</table\n</td>\n</tr>\n<tr>\n";
      
      $z=localtime();
      //print_r($z);
      $curr_ts=strftime("%G-%m-%d ", $week->getTimestamp());
      $curr_hour=$z[2];
      $curr_min=$z[1];
      $curr_now=$curr_ts.$curr_hour.":".$curr_min.":00";
      
      echo "<tr>\n<td class=\"calweekday\">&nbsp;</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Monday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Tuesday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Wednesday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Thursday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Friday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Saturday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Sunday")."</td>\n</tr>\n";
      //while($etc = $week->fetch()){
         echo "<tr>\n";
         //if($etc->isEmpty()){
         //}
         //else{
            echo "<td class=\"calweekday\">"._("Morning")."</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "</tr>\n";

            echo "<tr>\n<td class=\"calweekday\">"._("Afternoon")."</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
            echo "<td class=\"calweekday\">&nbsp;</td>\n";
         //}
         echo "</tr>\n";
      //}
      echo "</table>\n";
   }
   
   function drawMonth()
   {
      $month = & new Calendar_Month_Weekdays($this->year,$this->month);
      $day = & new Calendar_Day($this->year,$this->month,$this->day);
      $selection = array($day); 
      $e = new VxEvent(1);
   
      $thisday=$day->thisDay(true);
   
      $prevStamp = $month->prevMonth(true);
      $prev = $_SERVER['PHP_SELF'].'?y='.date('Y',$prevStamp).'&m='.date('n',$prevStamp).'&d='.date('j',$prevStamp);
      $nextStamp = $month->nextMonth(true);
      $next = $_SERVER['PHP_SELF'].'?y='.date('Y',$nextStamp).'&m='.date('n',$nextStamp).'&d='.date('j',$nextStamp); 
   
      //echo $MonthDecorator->thisMonth();
      //$thismonth = new VxMonth($month);
      //$thismonth->build(); 
      $month->build();
      
      $z=$_SESSION['vxmisuser']->GetTodayStart();
      $y=explode(':',$z);
      $hs=$y[0];
      $ms=$y[1];
      $ts=new Calendar_Minute($this->year,$this->month,$this->day,$y[0],$y[1]);
      $z=$_SESSION['vxmisuser']->GetTodayEnd();
      $y=explode(':',$z);
      $he=$y[0];
      $me=$y[1];
      $te=new Calendar_Minute($this->year,$this->month,$this->day,$y[0],$y[1]);
      $ts=$ts->getTimestamp();
      $te=$te->getTimestamp();
      
      echo "<table class=\"cal\" cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
      echo "<tr><td colspan=\"7\">";
      echo "<table>\n<tr>\n<td class=\"calmonthnav\" align=\"left\">";
      
      $lastmonth = $month->prevMonth(TRUE);
      echo "<a href=\"".$_SERVER['PHP_SELF']."?action=m&v=".$lastmonth."\">".date('F',$lastmonth)." ".date('Y',$lastmonth)."</a>";
      echo "</td>\n<td class=\"calmonthnav\" align=\"center\">";
      $thismonth = $month->thisMonth(TRUE);
      echo date('F',$thismonth)." ".date('Y',$thismonth);
      echo "</td>\n<td class=\"calmonthnav\" align=\"right\">";
      $nextmonth = $month->nextMonth(TRUE);
      echo "<a href=\"".$_SERVER['PHP_SELF']."?action=m&v=".$nextmonth."\">".date('F',$nextmonth)." ".date('Y',$nextmonth)."</a>";
      echo "</td>\n</tr>\n</table\n</td>\n</tr>\n";
      
      echo "<tr>\n<td class=\"calweekdaytitle\">"._("Monday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Tuesday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Wednesday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Thursday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Friday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Saturday")."</td>\n";
      echo "<td class=\"calweekdaytitle\">"._("Sunday")."</td>\n</tr>\n";

      while($today = $month->fetch()){
         $tday = $today->thisDay(true);
      
         if($today->isFirst()){
            echo "<tr>\n";
         }
         if($today->isEmpty()){
            echo "<td class=\"calmonthday\">&nbsp;</td>";
         } 
         else{
            $ts=new Calendar_Minute($this->year,$this->month,$today->thisDay(),$hs,$ms);
            $te=new Calendar_Minute($this->year,$this->month,$today->thisDay(),$he,$me);
            $ts=$ts->getTimestamp();
            $te=$te->getTimestamp();
            $ts=date("Y-m-d 00:00:01", $ts);
            $te=date("Y-m-d 23:59:59", $te);
            
            echo "<td class=\"calmonthdays\"><table class=\"calmonthdays\" cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n<tr>\n";
            if($today->isSelected()){ 
               echo "<td class=\"calmonthdates\">";
            }
            else{
               if($tday < $thisday){
                  echo "<td class=\"calmonthdateb\">";
               }
               else if($tday > $thisday){
                  echo "<td class=\"calmonthdate\">";
               }
            }
            echo "<a href=\"".$_SERVER['PHP_SELF']."?action=d&ampv=".$today->thisDay(true)."\">".$today->thisDay()."</a></td>\n";
            if($today->isSelected()){ 
               echo "<td class=\"calmonthdates\">";
            }
            else{
               if($tday < $thisday){
                  echo "<td class=\"calmonthdateb\">";
               }
               else if($tday > $thisday){
                  echo "<td class=\"calmonthdate\">";
               }
            }
            echo "&nbsp;</td>\n</tr>\n";
            if($e->hasEvent($ts, $te)){
               $e->build($ts, $te);
               while(($ev=$e->fetch())){
                  echo "<tr>\n";
                  if($today->isSelected()){ 
                     echo "<td class=\"calmonthevents\">";
                  }
                  else{
                     if($today < $thisday){
                        echo "<td class=\"calmonthdateb\">";
                     }
                     else if($today > $thisday){
                        echo "<td class=\"calmonthdate\">";
                     }
                  }
                  $t=explode(' ',$ev['starts']);
                  $mt=explode(':',$t[1]);
                  echo $mt[0].":".$mt[1];
                  echo "</td>\n";
                  if($today->isSelected()){ 
                     echo "<td class=\"calmonthevents\">";
                  }
                  else{
                     if($today < $thisday){
                        echo "<td class=\"calmonthdateb\">";
                     }
                     else if($today > $thisday){
                        echo "<td class=\"calmonthdate\">";
                     }
                  }
                  echo $ev['title'];
                  echo "</td>\n</tr>\n";
               }
               echo "</table>\n</td>\n";
            }
            else{
               echo "</td>\n</tr>\n</table>\n</td>\n";
            }
         }
     
         if($today->isLast()){
            echo "</tr>\n" ;
         }
      } 
      echo "</table>\n";
      /*
      $month = new Calendar_Month_Weekdays(date('Y'), date('n'));
      $month->build();
      while($day = $month->fetch()) {
         if($day->isFirst()){
            echo "<tr>\n";
         }

         if($day->isEmpty()){
            echo "<td>&nbsp;</td>\n";
         } 
         else{
            echo '<td>'.$day->thisDay()."</td>\n";
         }
   
       if($day->isLast()){
           echo "</tr>\n";
      }
      echo "</table>\n";*/
   }
}
/* @} */
?>
