<?php
/*
 * chargeaccount.php
 * Part of:
 * BhPos, Copyright (C) 2001-2004 Al Kingsley
 * BhPos comes with ABSOLUTELY NO WARRANTY.
 *
 * @version	0.9.7
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 */
 require_once("account.php");
 require_once("bank.php");
 require_once("discount.php");
 
 class ChargeItem
 {
   var $id;
   var $chargeaccountid;
   var $targetid;
   var $transid;
   var $when;
   var $amount;

   function ChargeItem($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->id=0;
         $this->chargeaccountid=0;
         $this->targetid=0;
         $this->transid=0;
         $this->when=new TimeDate();
         $this->amount=0.0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(chargeitem_qry2, $id);
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
      }
	   $result=db_query($qry);
	   if($row = $result->FetchRow()){
         $this->id=$id;
         $this->chargeaccountid=0;
         $this->targetid=0;
         $this->transid=0;
         $this->when=new TimeDate();
         $this->amount=0.0;
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $qry=sprintf(chargeitem_qry4, $this->targetid, $this->transid, $this->when->ansi(), $this->margin, $this->amount);
      db_query($qry);
       
      $result=db_query(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->ID;
   }
   
   function Commit($id)
   {
      $qry=sprintf(chargeitem_qry5, $this->targetid, $this->transid, $this->when->ansi(), $this->margin, $this->amount,
      $this->id);
      db_query($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(chargeitem_qry6, $id);
      }
      else{
         $qry=sprintf(chargeitem_qry6, $this->id);
      }
	   db_query($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(chargeitem_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id "];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo _("Not Set");
      }
   }
   
   function TypeCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"type\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   if($id=='E'){
	      	echo "<option value=\"E\" selected>"._("Employee")."</option>\n";
            echo "<option value=\"C\">"._("Customer")."</option>\n";
            echo "<option value=\"S\">"._("Supplier")."</option>\n";
		   }
   		else if($id=='C'){
	   	   echo "<option value=\"E\">"._("Employee")."</option>\n";
            echo "<option value=\"C\" selected>"._("Customer")."</option>\n";
            echo "<option value=\"S\">"._("Supplier")."</option>\n";
   	   }
         else if($id=='S'){
	   	   echo "<option value=\"E\">"._("Employee")."</option>\n";
            echo "<option value=\"C\">"._("Customer")."</option>\n";
            echo "<option value=\"S\" selected>"._("Supplier")."</option>\n";
   	   }
         echo "</select>\n";
      }
      else{
         if($id=='E'){
	      	echo _("Employee");
		   }
   		else if($id=='C'){
	   	   echo _("Customer");
   	   }
         else if($id=='S'){
            echo _("Supplier");
         }
      }
   }
}

class ChargeAccount
{
   var $id;
   var $chargeid;
   var $typeid;
   var $cmid;
   var $bankid;
   var $creditlimit;
   var $lasttransaction;
   var $accountid;
   var $standardterms;
   var $codterms;
   var $prepaidterms;
   var $termstype;
   var $duemonthend;
   var $duedays;
   var $discountdays;
   var $discountid;
   var $notes;
   
   var $items;
   
   function ChargeAccount($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      else{
         $this->id=0;
         $this->chargeid=0;
         $this->typeid=0;
         $this->cmid=0;
         $this->bankid=0;
         $this->creditlimit=0.0;
         $this->lasttransaction= new timedate();
         $this->accountid='0';
         $this->standardterms='N';
         $this->codterms='N';
         $this->prepaidterms='N';
         $this->termstype='N';
         $this->duemonthend='N';
         $this->duedays=0;
         $this->discountdays=0;
         $this->discountid=0;
         $this->notes='';
      }
   }
   
   function GetID() { return $this->id; }
   function SetID($id) { $this->id=$id; }
   
   function Fill($id, $bOffset=false)
   {
      if($id==0){
         return false;
      }
      
      if($bOffset){
         $qry=sprintf(customerm_chargeacc_qry2, $id);
      }
      else{
         $qry=sprintf(customerm_chargeacc_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$row['id'];
         $this->chargeid=$id;
         $this->typeid=$row['typeid'];
         $this->cmid=$row['cmid'];
         $this->bankid=$row['bankid'];
         $this->creditlimit=$row['creditlimit'];
         $this->lasttransaction->parse($row['lasttransaction']);
         $this->accountid=$row['accountid'];
         $this->standardterms=$row['standardterms'];
         $this->codterms=$row['codterms'];
         $this->prepaidterms=$row['prepaidterms'];
         $this->termstype=$row['termstype'];
         $this->duemonthend=$row['duemonthend'];
         $this->duedays=$row['duedays'];
         $this->discountdays=$row['discountdays'];
         $this->discountid=$row['discountid'];
         $this->notes=$row['notes'];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l,$m,$n,$o,$p)
   {
      $this->chargeid=$a;
      $this->typeid=$b;
      $this->cmid=$c;
      $this->bankid=$d;
      $this->creditlimit=$e;
      $this->lasttransaction->parse($f);
      $this->accountid=$g;
      $this->standardterms=$h;
      $this->codterms=$i;
      $this->prepaidterms=$j;
      $this->termstype=$k;
      $this->duemonthend=$l;
      $this->duedays=$m;
      $this->discountdays=$n;
      $this->discountid=$o;
      $this->notes=$p;
   }
   
   function SetFromForm($frm)
   {
      if(isset($frm['chargeid'])){
         $this->chargeid=$frm['chargeid'];
      }
      else{
         $this->chargeid=0;
      }
      $this->typeid=$frm['typeid'];
      if(isset($frm['cacmid'])){
         $this->cmid=$frm['cacmid'];
      }
      else{
         $this->cmid=0;
      }
      if(isset($frm['bankid'])){
         $this->bankid=$frm['bankid'];
      }
      else{
         $this->bankid=0;
      }
      $this->creditlimit=$frm['creditlimit'];
      if(isset($frm['lasttransaction'])){
         $this->lasttransaction->parse($frm['lasttransaction']);
      }
      $this->accountid=$frm['accountid'];
      $this->standardterms=yesno(isset($frm['standardterms']));
      $this->codterms=yesno(isset($frm['codterms']));
      $this->prepaidterms=yesno(isset($frm['prepaidterms']));
      $this->termstype=yesno(isset($frm['termstype']));
      $this->duemonthend=yesno(isset($frm['duemonthend']));
      $this->duedays=$frm['duedays'];
      $this->discountdays=$frm['discountdays'];
      if(isset($frm['discountid'])){
         $this->discountid=$frm['discountid'];
      }
      else{
         $this->discountid=0;
      }
      if(isset($frm['notes'])){
         $this->notes=$frm['notes'];
      }
      else{
         $this->notes="";
      }
   }
   
   function Add()
   {
      if($this->chargeid==0){
         $cm=new CreateMod();
         $cm->Fill(0);
         $this->cmid=$cm->Commit();
         
         $qry=sprintf(supplierm_chargeacc_qry6,$this->typeid,$this->cmid,$this->bankid,$this->creditlimit,
         $this->lasttransaction->ansidate(),$this->accountid,$this->standardterms,$this->codterms,
         $this->prepaidterms,$this->termstype,$this->duemonthend,$this->duedays,$this->discountdays,
         $this->discountid,$this->notes);

         $_SESSION['VxCFG']->dbh->Execute($qry);
         $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
         $row = $result->FetchRow();
         $this->id=$row[0];
         $qry=sprintf(supplierm_chargeacc_qry8,$this->id,$this->id);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
      else{
         $qry=sprintf(supplierm_chargeacc_qry6,$this->chargeid,$this->typeid,$this->cmid,$this->bankid,$this->creditlimit,$this->lasttransaction->ansidate(),
            $this->accountid,$this->standardterms,$this->codterms,$this->prepaidterms,$this->termstype,
            $this->duemonthend,$this->duedays,$this->discountdays,$this->discountid,$this->notes);
         
         $_SESSION['VxCFG']->dbh->Execute($qry);
         $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
         $row = $result->FetchRow();
         $this->id=$row[0];
       }
       return $this->id;
   }
   
   function AddItem($i) 
	{
		$found=0;

		if(isset($i)){
			if(count($this->items)!=0){
				foreach($this->items as $num=>$ii){
					$plu=$ii->GetPLU();
					$tplu=$InvItem->GetPLU();
					if($plu==$tplu){
						$tqty=$ii->GetQty() + $InvItem->GetQty();
						$ii->SetQty($tqty);
						$this->items[$num] = $ii;
						$found=1;
						break;
					}
				}
			}
			if($found==0){
				array_push($this->items, $i);
			}
		}
	}
   
   function Commit()
   {
      $qry=sprintf(supplierm_chargeacc_qry7,$this->chargeid,$this->typeid,$this->cmid,$this->bankid,
         $this->creditlimit,$this->lasttransaction->ansidate(),$this->accountid,$this->standardterms,
         $this->codterms,$this->prepaidterms,$this->termstype,$this->duemonthend,$this->duedays,
         $this->discountdays,$this->discountid,$this->notes,$this->id);

      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(chargeacc_qry5,$this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function FillItemsTable($a, $cid, $title)
   {
      $result=db_query("SELECT * FROM chargeitems WHERE chargeid = '$cid'");
      if(db_num_rows($result)==0){
         return false;
      }
   }
   
   function Combo($a, $id, $title)
   {
   }
   
   function TypeCombo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>"._("Not Set")."</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(supplierm_chargeacctype_qry4);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(supplierm_chargeacctype_qry5, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo _("Not Set");
      }
   }
   
   function DiscountTable($a, $id, $title, $bOffset=false)
   {
   }
   
   function Table($a, $id, $title, $bOffset=false)
   {
      echo "<input type=\"hidden\" name=\"chargeid\" value=\"".$this->id."\">\n";
      echo "<input type=\"hidden\" name=\"cacmid\" value=\"".$this->cmid."\">\n";
      
      echo "<fieldset>\n<legend>"._("Charge Account")."</legend><table>\n";
      if($a=='browse'){
         if(!$this->Fill($id, $bOffset)){
            echo "<tr><td colspan=\"2\" class=\"formdata\">"._("There are no charge accounts defined.")."</td></tr></table>\n</fieldset>\n";
            return;
         }
      }
      else{
         $this->Fill($id, $bOffset);
      }
      echo "<tr><td class=\"formlabel\">"._("Type")."</td><td class=\"formdata\">\n";
      $this->TypeCombo($a, "typeid", $this->typeid);
   	echo"</td>\n";
      echo "<td class=\"formlabel\">"._("Standard Terms")."</td><td class=\"formdata\">\n";
      CheckBox($a, "standardterms", $this->standardterms, "");
      echo "</td></tr>\n";
      
      echo "<tr><td class=\"formlabel\">"._("Bank Account")."</td><td class=\"formdata\">\n";
      $bank=new BankAccount();
      $bank->Combo($a, $this->bankid, "bankid");
   	echo"</td>\n";
      echo "<td class=\"formlabel\">"._("COD Terms")."</td><td class=\"formdata\">\n";
      CheckBox($a, "codterms", $this->codterms, "");
      echo "</td></tr>\n";      
      
      echo "<tr><td class=\"formlabel\">"._("Account")."</td><td class=\"formdata\">\n";
      $acc=new Account();
      $acc->Combo($a, $this->accountid, "accountid");
   	echo"</td>\n";
      echo "<td class=\"formlabel\">"._("Prepaid Terms")."</td><td class=\"formdata\">\n";
      CheckBox($a, "prepaidterms", $this->prepaidterms, "");
      echo "</td></tr>\n";
      
	   echo "<tr><td class=\"formlabel\">"._("Credit Limit")."</td><td class=\"formdata\">\n";
	   entry($a, "creditlimit", 16, 16, $this->creditlimit);
   	echo"</td>";
      echo "<td class=\"formlabel\">"._("Type Terms")."</td><td class=\"formdata\">\n";
      CheckBox($a, "termstype", $this->termstype, "");
      echo "</td></tr>\n";
	
   	echo "<tr><td class=\"formlabel\">"._("Last Transaction")."</td><td class=\"formdata\">\n";
      $td=new TimeDate();
      if(isset($this->lasttransaction) && $this->lasttransaction!=''){
         $td->displayex('date', $a, 'lasttransaction', $this->lasttransaction);
      }
      else{
         $td->displayex('date', $a, 'lasttransaction');
      }
   	echo"</td>\n";
      echo "<td class=\"formlabel\">"._("Due Month End")."</td><td class=\"formdata\">\n";
      CheckBox($a, "duemonthend", $this->duemonthend, "");
      echo "</td></tr>\n";

   	echo "<tr><td class=\"formlabel\">"._("Due Days")."</td><td class=\"formdata\">\n";
      entry($a, "duedays", 8, 8,$this->duedays);
   	echo"</td><td>&nbsp;</td></tr>\n";
      
      echo "<tr><td class=\"formlabel\">"._("Discount Days")."</td><td class=\"formdata\">\n";
      entry($a, "discountdays", 8, 8,$this->discountdays);
   	echo"</td><td>&nbsp;</td></tr>\n";
      
      
      /*
      echo "<tr><td colspan=\"2\" align=\"right\">";
      $d=new Discount($this->discountid, false);
      $d->Table($a, $id, "General Discount", $bOffset, true);
   	echo"</td></tr>\n";
      */
   	echo "</table>\n</fieldset>\n";
   }
}

?>
