<?php
/*
 creatmod.php
 
Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
require_once("timedate.php");

/**
 * @defgroup generic Generic
 * @{
 */

/**
 \class CreateMod
 \brief A class to handle creation/mofification
*/
class CreateMod
{
   var $id;
   var $creationdate;
   var $modifieddate;
   var $createdby;
   var $modifiedby;

   function CreateMod($id=0)
   {
      if($id!=0){
         $this->Fill($id);
         return;
      }
      
      $this->id=0;
      $this->creationdate=new TimeDate();
      $this->modifieddate=new TimeDate();
      $this->createdby=0;
      $this->modifiedby=0;
   }
   
   function Fill($id)
   {  
      if($id==0){
         if(isset($_SESSION['vxmisuser'])){
   	      $this->createdby=$this->modifiedby=$_SESSION['vxmisuser']->GetEmployee();
         }
         return false;
      }
      $qry=sprintf(createmod_qry1, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->creationdate->parse($row[1]);
         $this->modifieddate->parse($row[2]);
         $this->createdby=$row[3];
         $this->modifiedby=$row[4];

         return true;
      }
      return false;
   }
   
   function Commit()
   {  
      $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      $row = $result->FetchRow();
      
      if($this->id==0){ // new entry
         $this->modifiedby=$this->createdby=$_SESSION['vxmisuser']->GetEmployee();
         $this->modifieddate->parse($row[0]);
         $this->creationdate->parse($row[0]);
         $mts=$this->modifieddate->ansidateEx();
         $cts=$this->creationdate->ansidateEx();
         $qry=sprintf(createmod_qry2, $cts,$mts,$this->createdby,$this->modifiedby);
         $_SESSION['VxCFG']->dbh->Execute($qry);
         $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
         $row = $result->FetchRow();
         $this->id=$row[0];
         echo $this->id;
      }
      else{ // modified entry
         $this->modifiedby=$_SESSION['vxmisuser']->GetEmployee();
         $this->modifieddate->parse($row[0]);
         $mts=$this->modifieddate->ansidate();
         $qry=sprintf(createmod_qry3, $mts, $this->modifiedby, $this->id);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
      return $this->id;
   }
   
   function Find($bOutput)
   {
      $bcreationdate=0;
      $bmodifieddate=0;
      $bcreatedby=0;
      $bmodifiedby=0;
      $band=0;
      
      $query="select * from createmod where ";
      if($this->creationdate->Filled()){
         $query.="creationdate='$this->creationdate->ansidate()'";
         $bcreationdate=1;
         $band=1;
      }
      if($this->ModifiedDate->Filled()){
         if($band==0){
            $query.="modifieddate='$this->modifieddate->ansidate()'";
            $band=1;
         }
         else{
            $query.="and modifieddate='$this->modifieddate->ansidate()'";
         }
         $bmodifieddate=1;
      }
      if($this->creadedby!=0){
         if($band==0){
            $query.="creadedby='$this->creadedby'";
            $band=1;
         }
         else{
            $query.="and creadedby='$this->creadedby'";
         }
         $bcreadedby=1;
      }
      if($this->modifiedby!=0){
         if($band==0){
            $query.="modifiedby='$this->modifiedby'";
            $band=1;
         }
         else{
            $query.="and modifiedby='$this->modifiedby'";
         }
         $bmodifiedby=1;
      }
      
      $result=$_SESSION['VxCFG']->dbh->Execute($query);
      $n=$result->RecordCount();
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>"._("No matching Create/Modify found for search Criteria")."</h2></center>";
         return false;
      }
   }
   
   function FillCreatedBy()
   {
      $qry=sprintf(createmod_qry4, $this->createdby);
	   if(!($result=$_SESSION['VxCFG']->dbh->Execute($qry))){
         echo _("Not Set");
         return;
      }
      if($result->RecordCount()==0){
         echo _("Not Set");
         return;
      }
  	   if(($row = $result->FetchRow())){
         $qry=sprintf(createmod_qry5, $row['contactid']);
	      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	      if(($row = $result->FetchRow())){
            $cwho=$row["firstname"]." ".$row["lastname"];
            if($cwho==' '){
               $cwho=_("Not Set");
            }
         }
         else{
  		      $cwho=_("Not Set");
         }
      }
  	   else{
  		   $cwho=_("Not Set");
      }
      echo $cwho;
   }
   
   function FillCreatedWhen()
   {
      $qry=sprintf(createmod_qry4, $this->createdby);
	   if(!($result=$_SESSION['VxCFG']->dbh->Execute($qry))){
         echo _("Not Set");
         return;
      }
      if($result->RecordCount()==0){
         echo _("Not Set");
         return;
      }
  	   if(($row = $result->FetchRow())){
         $this->creationdate->Set($row['creationdate']);
         $this->creationdate->datedisplay();
      }
   }
   
   function FillCell()
   {
      $qry=sprintf(createmod_qry4, $this->createdby);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	   if(($row = $result->FetchRow())){
         $qry=sprintf(createmod_qry5, $row['contactid']);
	      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	      if(($row = $result->FetchRow())){
            $cwho=$row["firstname"]." ".$row["lastname"];
            if($cwho==' '){
               $cwho=_("Not Set");
            }
         }
         else{
  		      $cwho=_("Not Set");
         }
      }
  	   else{
  		   $cwho=_("Not Set");
      }
      $qry=sprintf(createmod_qry4, $this->modifiedby);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	   if(($row = $result->FetchRow())){
         $qry=sprintf(createmod_qry5, $row['contactid']);
	      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	      if(($row = $result->FetchRow())){
   	      $mwho=$row["firstname"]." ".$row["lastname"];
            if($mwho==' '){
               $mwho=_("Not Set");
            }
         }
         else{
  		      $mwho=_("Not Set");
         }
      }
  	   else{
  		   $mwho=_("Not Set");
      }
   
      $this->creationdate->datedisplay();
   	echo " - ".$cwho;
   }
   
   function FillTable()
   {
      $qry=sprintf(createmod_qry4, $this->createdby);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result){
         $cwho=_("Not Set");
      }
      else{
     	   if(($row = $result->FetchRow())){
            $qry=sprintf(createmod_qry5, $row['contactid']);
	         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	         if(($row = $result->FetchRow())){
  		         $cwho=$row["firstname"]." ".$row["lastname"];
               if($cwho==' '){
                  $cwho=_("Not Set");
               }
            }
     	      else{
  	   	      $cwho=_("Not Set");
            }
         }
         else{
            $cwho=_("Not Set");
         }
      }
      $qry=sprintf(createmod_qry4, $this->modifiedby);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result){
         $mwho=_("Not Set");
      }
      else{
     	   if(($row = $result->FetchRow())){
            $qry=sprintf(createmod_qry5, $row['contactid']);
	         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  	         if(($row = $result->FetchRow())){
         	   $mwho=$row["firstname"]." ".$row["lastname"];
               if($mwho==' '){
                  $mwho=_("Not Set");
               }
            }
            else{
  	   	      $mwho=_("Not Set");
            }
         }
     	   else{
  	   	   $mwho=_("Not Set");
         }
      }
      echo "<table class=\"createmod\">\n";
	   echo "<tr>\n<td class=\"formlabel\">"._("Created On")."</td><td class=\"formdata\">";
      $this->creationdate->datedisplay();
   	echo "</td>\n</tr>\n<tr>\n<td class=\"formlabel\">" ._("Created By"). "</td>\n<td class=\"formdata\">$cwho</td>\n</tr>\n";
	   echo "<tr>\n<td class=\"formlabel\">" ._("Modified On"). "</td>\n<td class=\"formdata\">";
		$this->modifieddate->datedisplay();
   	echo "</td>\n</tr>\n<tr><td class=\"formlabel\">" ._("Modified By"). "</td>\n<td class=\"formdata\">$mwho</td>\n";
      echo "</tr></table>";
   }
}

/* @} */

?>
