<?php
/*
loyalty.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

class Points
{
   var $id;
   var $name;
   var $description;
   var $value;
   
   function Points($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->name='';
      $this->description='';
      $this->value=1.0;
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(customer_points_qry2, $id);
      }
      else{
         $qry=sprintf(customer_points_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->name=$row['name'];
         $this->description=$row['description'];
         $this->value=$row['value'];
       
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c)
   {
      $this->name=$a;
      $this->description=$b;
      $this->value=$c;
   }
   
   function setfromform($frm)
   {
      $this->name=$frm['name'];
      $this->description=$frm['description'];
      $this->value=$frm['value'];
   }
   
   function Add()
   {
      $qry=sprintf(customer_points_qry4, $this->name,$this->description,$this->value);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id=false)
   {
      if(!isset($id)){
         $id=$this->id;
      }
      $qry=sprintf(customer_points_qry5, $this->name,$this->description,$this->value, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(customer_points_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"point\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr>\n<td class=\"label\">".customer_points_name."</td>\n<td>";
      entry($a, "name",32,32,$this->name);
   	echo"</td>\n</tr>\n";
      
      echo "<tr>\n<td class=\"label\">".customer_points_description."</td>\n<td>";
      entry($a, "description",48,64,$this->description);
   	echo"</td>\n</tr>\n";
      
      echo "<tr>\n<td class=\"label\">".customer_points_value."</td>\n<td>";
      $v=sprintf("%0.2f", $this->value);
      entry($a, "value",48,64,$v);
   	echo"</td>\n</tr>\n";
      
      if(!$bInside){
         echo "</table>\n";
      }
   }
}

class Loyalty
{
   var $id;
   var $loyaltyid;
   var $pointsid;
   var $catalogueid;
   
   function Loyalty($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->loyaltyid=0;
      $this->pointsid=0;
      $this->catalogueid='';
   }
   
   function Getid() { return $this->id; }
   function Getpointsid() { return $this->pointsid; }
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(customerm_loyalty_qry2, $id);
      }
      else{
         $qry=sprintf(customerm_loyalty_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->loyaltyid=$row["loyaltyid"];
         $this->pointsid=$row["pointsid"];
         $this->catalogueid=$row["catalogueid"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c)
   {
      $this->loyaltyid=$a;
      $this->pointsid=$b;
      $this->catalogueid=$c;
   }
   
   function setfromform($frm)
   {
      $this->loyaltyid=$frm['loyaltyid'];
      $this->pointsid=$frm['pointsid'];
      $this->catalogueid=$frm['catalogueid'];
   }
   
   function Add()
   {
      $qry=sprintf(customerm_loyalty_qry4, $this->loyaltyid,$this->pointsid,$this->catalogueid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id=false)
   {
      if(!isset($id)){
         $id=$this->id;
      }
      $qry=sprintf(customerm_loyalty_qry5, $this->loyaltyid,$this->pointsid,$this->catalogueid, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(customerm_loyalty_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"loyalty\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }
	   /*
   	echo "<tr>\n";
      echo "<td class=\"label\">".customer_loyalty_data."</td>\n";
      echo "<td>";
	   textarea($a, "data", 64, 255, $this->data);
   	echo"</td>\n";
	   echo "</tr>\n";*/
   }
}

class PointsLog
{
   var $id;
   var $pointsid;
   var $pointstypeid;
   var $issuedon;
   var $redeemcode;
   var $number;
   var $redeemed;
   
   function PointsLog($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->pointsid=0;
      $this->pointstypeid=0;
      $this->issuedon='';
      $this->redeemcode='';
      $this->number=0;
      $this->redeemed='N';
      
      return false;
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(customer_pointslog_qry2, $id);
      }
      else{
         $qry=sprintf(customer_pointslog_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->pointsid=$row["pointsid"];
         $this->pointstypeid=$row["pointstypeid"];
         $this->issuedon=$row["issuedon"];
         $this->redeemcode=$row["redeemcode"];
         $this->number=$row["number"];
         $this->redeemed=$row["redeemed"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e)
   {
      $this->pointsid=$a;
      $this->pointstypeid=$b;
      $this->issuedon=$c;
      $this->redeemcode=$d;
      $this->number=$e;
      $this->redeemed=$f;
   }
   
   function setfromform($frm)
   {
      $this->pointsid=$frm['pointsid'];
      $this->pointstypeid=$frm['pointstypeid'];
      $this->issuedon=$frm['issuedon'];
      $this->redeemcode=$frm['redeemcode'];
      $this->typeid=$frm['typeid'];
      $this->number=$frm['number'];
      $this->redeemed=$frm['redeemed'];
   }
   
   function Add()
   {
      $qry=sprintf(customer_pointslog_qry4,$this->pointsid,$this->pointstypeid,$this->issuedon,$this->redeemcode,
         $this->number,$this->redeemed);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id=false)
   {
      $c=new CreateMod();
      $cmid=$c->Fill($this->cmid);
      $c->Commit();
      if(!isset($id)){
         $id=$this->id;
      }
      $qry=sprintf(customer_pointslog_qry5,$this->pointsid,$this->pointstypeid,$this->issuedon,$this->redeemcode,
         $this->number,$this->redeemed,$id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(customer_pointslog_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Summary($a, $id)
   {
      //$this->Fill($id);
      $result=$_SESSION['VxCFG']->dbh->Execute(customerm_points_qry9);
      echo "<fieldset>\n";
      echo "<legend>"._("Points")."</legend>";
      echo "<table cellspacing=\"5\" cellpadding=\"5\">\n<tr>\n";
      echo "<td align=\"left\" width=\"10%\"><b>"._("Type")."</b></td>\n";
      echo "<td align=\"left\" width=\"10%\"><b>"._("Value")."</b></td>\n";
      echo "<td align=\"left\" width=\"10%\"><b>"._("Number")."</b></td>\n";
      echo "<td align=\"left\" width=\"10%\"><b>"._("Total Value")."</b></td>\n";
      echo "<td align=\"right\" width=\"70%\"><b>"._("Redeemed")."</b></td>\n";
      echo "</tr>\n";
      
      while($row = $result->FetchRow()){
         $qry=sprintf(customerm_pointslog_qry14, $row['id'], 'N', $id);
         //echo $qry;
         $res=$_SESSION['VxCFG']->dbh->Execute($qry);
         $r = $res->FetchRow();
         $v=sprintf("%d",$r[0]);
         $t=sprintf("%0.2f", $r[0]*$row['value']);
         echo "<tr>\n";
         echo "<td align=\"left\" width=\"10%\">".$row['name']."</td>";
         echo "<td align=\"left\" width=\"10%\">".$row['value']."</td>";
         echo "<td align=\"left\" width=\"10%\">".$v."</td>";
         echo "<td align=\"left\" width=\"10%\">".$t."</td>";
         echo "<td align=\"right\" width=\"70%\">N</td>";
         echo "</tr>\n";
      }
      $result->MoveFirst();
      while($row = $result->FetchRow()){
         $qry=sprintf(customerm_pointslog_qry14, $row['id'], 'Y', $id);
         //echo $qry;
         $res=$_SESSION['VxCFG']->dbh->Execute($qry);
         $r = $res->FetchRow();
         $v=sprintf("%d",$r[0]);
         $t=sprintf("%0.2f", $r[0]*$row['value']);
         echo "<tr>\n";
         echo "<td align=\"left\" width=\"10%\">".$row['name']."</td>";
         echo "<td align=\"left\" width=\"10%\">".$row['value']."</td>";
         echo "<td align=\"left\" width=\"10%\">".$v."</td>";
         echo "<td align=\"left\" width=\"10%\">".$t."</td>";
         echo "<td align=\"right\" width=\"70%\">Y</td>";
         echo "</tr>\n";
      }
      //$qry=sprintf(customerm_pointslog_qry14, $row['id'], 'Y');
      echo "</table>\n</fieldset>\n";
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table class=\"pointslog\">\n";
         echo "<th colspan=\"2\">$title</th>\n";
      }
      
      $c=1;
      $ts=new TimeDate();
      echo "<tr><td><h3>".customer_pointslog_issued."</h3></td><td><h3>".customer_pointslog_number."</h3></td>\n";
      echo "<td><h3>".customer_pointslog_value."</h3></td><td><h3>".customer_pointslog_total."</h3></td>\n";
      echo "<td><h3>".customer_pointslog_redeemed."</h3></td></tr>\n";
      $qry=sprintf(customer_pointslog_qry8, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      while($row = $result->FetchRow()){
         if($c%2){
            echo "<tr bgcolor=\"DFDFDF\">\n";
         }
         else{
            echo "<tr bgcolor=\"DFDFDF\">\n";
         }
         echo "<td>";
         $ts->Parse($row["issuedon"]);
         $ts->datecontrol($a, "issedon");
         $qry=sprintf(customer_pointslog_qry8, $row["typeid"]);
	      $vresult=db_query($qry);
         if($vrow = $vresult->FetchRow()){
            echo "<td>".$vrow['value']."</td>\n";
         }
         else{
            echo "<td>0.00</td>\n";
         }
         $t=$row["number"] * $vrow["value"];
         echo "</td><td>".$row["number"]."</td><td>".$t."</td>\n<td>";
         CheckBox($a, "redeemed", $this->redeemed, "");
         echo "</tr>\n";
         $c++;
      }
   }
}

?>
