<?php
/*
  Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
   7it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
define ("FOCUSIDTYPE_HIDE", "0");
define ("FOCUSIDTYPE_NONE", "1");
define ("FOCUSIDTYPE_COMPANY", "3");
define ("FOCUSIDTYPE_PRODUCT", "4");
define ("FOCUSIDTYPE_SUPPLIER", "5");
define ("FOCUSIDTYPE_CUSTOMER", "6");
define ("FOCUSIDTYPE_EMPLOYEE", "7");
define ("FOCUSIDTYPE_STATION", "8");
define ("FOCUSIDTYPE_BANK", "9");
define ("FOCUSIDTYPE_USER", "10");
define ("FOCUSIDTYPE_CONTACT", "11");

//require_once("timedate.php");
//require_once("page.php");
/*
if(!class_exists('Hashed_Cache_Lite')){
   require_once('Cache/Lite/Hashed_Cache_Lite.php');
}
*/
 
class MISUser
{
   var $logged_in;
   var $fname;
   var $lname;
   var $groupname;
   var $userid;
   var $employeeid;
   var $contactid;
   var $menuid;
   var $started;
   var $start_time;
   var $useragent;
   var $ip;
   var $session_timeout;
   var $pda_login;
   
   var $modules;
   var $num_modules;
   var $num_tabs;
   var $curr_module;
   var $curr_tab;
   var $curr_sorton;
   var $sortorder;
   var $curr_action;
   var $start_tab;
   var $start_module;
   var $num_disptab;
   var $num_dispmodule;
   var $disp_flat;
   var $disp_count;
   var $real_array;
   var $showmodulefooterlinks;
   var $menu_str;
   var $last_viewed;
   var $last_viewed_set;
   var $num_last_viewed;
   
   var $language;
   var $dateformat;
   var $timeformat;
	var $showhelp;
	var $showimages;
	var $confirmdelete;
   var $listpagesize;
   var $todaystarttime;
   var $todayendtime;
   var $weekstartday;
   var $yearstartweek;
	var $theme;
   var $papersize;
   var $startpage;
   
   var $focusidtype;
   var $focusid;
   var $focusname;
   var $focusaction;
   
   var $validationid;
      
   var $_caching = FALSE;
   var $_force_cache_expire = TRUE; 
   var $_cache_dir = '/tmp/bhmis_cache'; // NO trailing slash
   var $_cache_expire_time=600; //600 == Ten Minutes	
   
   /**
    * Default constructor.
    *
    * @access public
    */
   function MISUser() 
   {
      $this->logged_in=false;
      $this->fname="";
      $this->lname="";
      $this->groupname="";
      $this->userid=0;
      $this->employeeid=0;
      $this->menuid=0;
      $this->siteid=0;
      $this->ip="0.0.0.0";
      $this->num_modules=0;
      $this->curr_module=0;
      $this->curr_tab=0;
      $this->curr_sorton=0;
      $this->sortorder='asc';
      $this->curr_action='list';
      $this->start_tab=0;
      $this->start_module=0;
      $this->num_disptab=8;
      $this->num_dispmodule=8;
      $this->disp_flat=false;
      $this->disp_count=0;
      $this->real_array=array();
      $this->showmodulefooterlinks=false;
      $this->last_viewed=array();
      $this->last_viewed_set=false;
      $this->num_last_viewed=4;
      $this->menu_str="";
      
      $this->useragent='';
      $this->session_timeout=3600;
      $this->defaultimgx=160;
      $this->defaultimgy=220;
      
      $this->pda_login=false;
      
      $this->language='en';
      
      $this->dateformat='D, d M';
      $this->timeformat='xxx';
	   $this->showhelp='N';
	   $this->showimages='Y';
	   $this->confirmdelete='Y';
      $this->listpagesize=20;
      $this->todaystarttime='08:00:00';
      $this->todayendtime='17:00:00';
      $this->weekstartday=1;
      $this->yearstartweek=1;
	   $this->theme='default';
      $this->papersize='A4';
      $this->startpage='main.php';
      
      $this->validationid=0;
      
      $this->focusidtype=FOCUSIDTYPE_NONE;
      $this->focusid=0;
      $this->focusname='';
      $this->focusaction='browse';
   
      /*
		 * Cache options. We default to the highest performance. If you run in to cache corruption problems,
		 * Change all the 'false' to 'true', this will slow things down slightly however.
		 */
		$cache_options = array(
			'caching' => $this->_caching,
			'cacheDir' => $this->_cache_dir.'/',
			'lifeTime' => $this->_cache_expire_time,
			'fileLocking' => true,
			'writeControl' => false,
			'readControl' => false,
		);
		//$this->Cache_Lite = new Hashed_Cache_Lite($cache_options);
   }

  /**
   * Set a user entry based upon the user id.
   *
   * @param	integer	$uid
   * @return	boolean true if successful.
   * @access	public
   */
   function SetUser($uid) 
   {
      $this->start_time=time();
      $this->started=new TimeDate();
      $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1) or die('Unable to query session start time.'); 
		$ts = $result->FetchRow();
      if(!$ts){
         return 1;
      }
      $this->started->parse($ts[0]);
      $result->Close();
      
      $q = sprintf(misuser_qry1, $uid);
      $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum user query.'); 
      if(!($u = $result->FetchRow())){
         return 2;
      }
      $this->userid=$uid;
      $this->employeeid=$u['employeeid'];
      $this->logintypesid=$u['logintypesid'];
      $result->Close();
      
      $q = sprintf(misuser_qry6, $this->employeeid);
      $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum employee query.'); 
      $n = $result->FetchRow();
      if(!$n){
         return 3;
      }
      $this->contactid=$n['contactid'];
      $groupid=$n['groupid'];
      
      $q = sprintf(misuser_qry13, $n['contactid']);
      $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum contact query.'); 
      $n = $result->FetchRow();
      if(!$n){
         return 4;
      }
      $this->fname=$n['firstname'];
      $this->lname=$n['lastname'];
      $result->Close();
      
      $qry=sprintf(misuser_qry8, $this->userid);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         return 5;
      }
      
      // system attibutes
      $result=$_SESSION['VxCFG']->dbh->Execute(misattribute_qry4);
      if(!$result) return 6;
      if($result->RecordCount()==0){
         return 6;
      }
      
      while($row = $result->FetchRow()){
         switch($row['name']){
         case 'sessiontimeout':
            $this->session_timeout=$row['value'];
            break;
         case 'defaultimgx':
            $this->defaultimgx=$row['value'];
            break;
         case 'defaultimgy':
            $this->defaultimgy=$row['value'];
            break;
         case 'paperzise':
            $this->papersize=$row['value'];
            break;
         }
      }
      
      // default values
      $result=$_SESSION['VxCFG']->dbh->Execute(misattribute_qry2);
      if(!$result) return 6;
      if($result->RecordCount()==0){
         return 6;
      }
      
      while($row = $result->FetchRow()){
         switch($row['name']){
         case 'misdefaultpagesize':
            $this->listpagesize=$row['value'];
            break;
         case 'mistheme':
            $this->theme=$row['value'];
            break;
         case 'mislanguage':
            $this->language=$row['value'];
            break;
         case 'misdateformat':
            $this->dateformat=$row['value'];
            break;
         case 'mistimeformat':
            $this->timeformat=$row['value'];
            break;
         case 'mistodaystarttime':
            $this->todaystarttime=$row['value'];
            break;
         case 'mistodayendtime':
            $this->todayendtime=$row['value'];
            break;
         case 'misfirstdayofweek':
            $this->weekstartday=$row['value'];
            break;
         case 'misfirstweekofyear':
            $this->yearstartweek=$row['value'];
            break;
         case 'misonlinehelp':
            $this->showhelp=$row['value'];
            break;
         case 'misconfirmdelete':
            $this->confirmdelete=$row['value'];
            break;
         case 'misinlineimages':
            $this->showimages=$row['value'];
            break;
         case 'misdefaultstartpage':
            $this->startpage=$row['value'];
            break;
         case 'numdispmodules':
            $this->num_dispmodule=$row['value'];
            break;
         case 'showmodulefooterlinks':
            if($row['value']=='Y' || $row['value']=='y'){
               $this->showmodulefooterlinks=true;
            }
            break;
         case 'numlastviewed':
            //$this->num_last_viewed=$row['value'];
            break;
         }
	   }
      $this->attributeid=$row['attributeid'];
      $qry=sprintf(misattribute_qry3, $row['attributeid']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         return 7;
      }
      while($row = $result->FetchRow()){
         switch($row['name']){
         case 'misdefaultpagesize':
            $this->listpagesize=$row['value'];
            break;
         case 'mistheme':
            $this->theme=$row['value'];
            break;
         case 'mislanguage':
            $this->language=$row['value'];
            break;
         case 'misdateformat':
            $this->dateformat=$row['value'];
            break;
         case 'mistimeformat':
            $this->timeformat=$row['value'];
            break;
         case 'mistodaystarttime':
            $this->todaystarttime=$row['value'];
            break;
         case 'mistodayendtime':
            $this->todayendtime=$row['value'];
            break;
         case 'misfirstdayofweek':
            $this->weekstartday=$row['value'];;
            break;
         case 'misfirstweekofyear':
            $this->yearstartweek=$row['value'];;
            break;
         case 'misonlinehelp':
            $this->showhelp=$row['value'];
            break;
         case 'misconfirmdelete':
            $this->confirmdelete=$row['value'];
            break;
         case 'misinlineimages':
            $this->showimages=$row['value'];
            break;
         case 'misdefaultstartpage':
            $this->startpage=$row['value'];
            break;
         case 'numdispmodules':
            $this->num_dispmodule=$row['value'];
            break;
         case 'showmodulefooterlinks':
            if($row['value']=='Y' || $row['value']=='y'){
               $this->showmodulefooterlinks=true;
            }
            break;
         case 'numlastviewed':
            //$this->num_last_viewed=$row['value'];
            break;
         }
	   }
      $q = sprintf(misuser_qry14, $groupid);
      $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum group query.'); 
      if(!($u = $result->FetchRow())){
         return 8;
      }
      $this->groupname=$u['name'];
      
      /*
      $q = sprintf(misuser_qry11, $uid);
      $result=db_query($q) or die('bum misuser menu query.'); 
      $n = $result->FetchRow();
      if(!$n){
         return 3;
      }
      $this->menuid=$n['menuid'];
      $result->Close();
      */
      /*
      if(getenv('HTTP_CLIENT_IP')){   
         $this->ip = getenv('HTTP_CLIENT_IP');
      }
      else{   
         $this->ip = getenv('REMOTE_ADDR');
      }*/
      $this->ip = $_SERVER['REMOTE_ADDR'];
      $this->log_start();
      return 0;
   }
   
   // get a real index out of modules
   function ModuleIndex($m)
   { 
      $i=$m;
      foreach($this->modules as $module){
         if($module['type']=='H' || $module['id']==0){
            $i++;
         }
      }
      return $i;
   }
   
   function RealIndex($m)
   { 
      $x=$m;
      $i=0;
      foreach($this->modules as $module){
         if($module['type']=='H' || $module['id']==0){
            continue;
         }
         $i++;
      }
      return $i;
   }
   
   function SetModule($m) { 
      $this->curr_module=$m;
      $i=0;
      foreach($this->real_array as $mr){
         if($mr==$m){
            $this->start_module=$i;
            return;
         }
         $i++;
      }
   }
   function SetTab($t) { $this->curr_tab=$t; }
   function SetSortOn($c) { $this->curr_sorton=$c; }
   function SetSortOrder($o) { $this->sortorder=$o; }
   function SetUserAgent($u) { $this->useragent=$u; }
   function SetLanguage($l) { $this->language=$l; }
   function SetDateFormat($d) { $this->dateformat=$d; }
   function SetTimeFormat($t) { $this->timeformat=$d; }
   function SetShowHelp($s) { $this->showhelp=$s; }
   function SetShowImages($s) { $this->showimages=$s; } 
   function SetConfirmDelete($s) { $this->confirmdelete=$s; }
   function SetPageSize($s) { $this->listpagesize=$s; }
   function SetTodayStart($s) { $this->todaystarttime=$s; }
   function SetTodayEnd($e) { $this->todayendtime=$e; }
   function SetFirstWeekofYear($s) { $this->yearstartweek=$s; }
   function SetFirstDayofWeek($s) { $this->weekstartday=$s; }
   function SetTheme($s) { $this->theme=$s; }
   function SetPaperSize($s) { $this->papersize=$s; }
   function SetSessionTimeout($s) { $this->session_timeout=$s; }
   function SetPDAlogin($b) { $this->pda_login=$b; }
   function SetAction($a){ $this->curr_action=$a; }
   function SetFocusType($f){ $this->focusidtype=$f; }
   function SetFocusID($id){ $this->focusid=$id; }
   function SetFocusName($n){ $this->focusname=$n; }
   function SetFocusAction($a){ $this->focusaction=$a; }
   function SetStartPage($p) { $this->startpage=$p; }
   function SetStart($s) { $this->start_module=$s; }
   function SetNumDispModule($n) { $this->$this->num_dispmodule=$n; }
   function SetNumLastViewed($n) { $this->num_last_viewed=$n; }
   function SetShowFooterLinks($s) { $this->showmodulefooterlinks=$s; }
   
   function GetUserAgent() { return $this->useragent; }
   function GetLanguage() { return $this->language; }
   function GetDateFormat() { return $this->dateformat; }
   function GetTimeFormat() {return $this->timeformat; }
   function GetShowHelp() { return $this->showhelp; }
   function GetShowImages() { return $this->showimages; }
   function GetPDAlogin() { return $this->pda_login; }
   function GetConfirmDelete() { return $this->confirmdelete; }
   function GetPageSize() { return $this->listpagesize; }
   function GetTodayStart() { return $this->todaystarttime; }
   function GetTodayEnd() { return $this->todayendtime; }
   function GetFirstWeekofYear() { return $this->yearstartweek; }
   function GetFirstDayofWeek() { return $this->weekstartday; }
   function GetTheme() { return $this->theme; }
   function GetPaperSize() { return $this->papersize; }
   function GetSortOn() { return $this->curr_sorton; }
   function GetSortOrder(){ return $this->sortorder; }
   function GetCurrentModule(){ return $this->curr_module; }
   function GetAction(){ return $this->curr_action; }
   function GetAttributeid() { return $this->attributeid; } 
   function GetFocusType(){ return $this->focusidtype; }
   function GetFocusID(){ return $this->focusid; }
   function GetFocusName(){ return $this->focusname; }
   function GetFocusAction(){ return $this->focusaction; }
   function GetSessionTimeout() { return $this->session_timeout; }
   function GetDefaultImageX() { return $this->defaultimgx; }
   function GetDefaultImageY() { return $this->defaultimgy; }
   function GetStartPage() { return $this->startpage; }
   function GetNumDispModule() { return $this->num_dispmodule; }
   function GetNumLastViewed() { return $this->num_last_viewed; }
   function GetShowFooterLinks() { return $this->showmodulefooterlinks; }
   
   function ClearFocus()
   {
      $this->focusidtype=FOCUSIDTYPE_NONE;
      $this->focusid=0;
      $this->focusname='';
   }
   
   function GetPerm($a)
   {
      $tab=&$this->modules[$this->curr_module]['tabs'][$this->curr_tab];
      switch($a){
      case 'add': 
         if($tab['add']=='Y') return true;
         return false;
      case 'edit':
         if($tab['edit']=='Y') return true;
         return false;
      case 'delete':
         if($tab['delete']=='Y') return true;
         return false;
      }
      return false;
   }
 
   function LoadModules()
   {
      $bFirst=1;
      $this->num_tabs=array();
      $qry=sprintf(misuser_qry8, $this->userid);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         return 1;
      }
	   if(!($row = $result->FetchRow())){
         return 2;
      }
      $qry=sprintf(misuser_qry9, $row['menuid']);
      $mdresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$mdresult){
         return 3;
      }
      $this->num_modules=$mdresult->RecordCount();
      
      if($this->num_modules==0){
         return 4;
      }
      
      // loop over distinct modules
      $n=0;
      while($mdrow = $mdresult->FetchRow()){
         $qry=sprintf(misuser_qry12, $mdrow['moduleid']);
         $mresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!$mresult) return 5;
	      if(!($mrow = $mresult->FetchRow())){
            return 6;
         }
         $moduleid=$mrow['id'];
         if($bFirst){
            $this->modules=array($moduleid=>array(
            'id'=>$moduleid, 
            'name'=>_($mrow['name']),
            'basedir'=>$mrow['basedir'], 
            'icon'=>$mrow['icon'],
            'type'=>$mrow['type'],
            'tabs'=>array()));
            $bFirst=0;
         }
         else{
            $this->modules[$moduleid]=array(
            'id'=>$moduleid, 
            'name'=>_($mrow['name']),
            'basedir'=>$mrow['basedir'], 
            'icon'=>$mrow['icon'],
            'type'=>$mrow['type'],
            'tabs'=>array());
         }
         
         if($mrow['type'] <> 'H'){
            $this->disp_count++;
            $this->real_array[$n]=$moduleid;
            $n++;
         }
            
         $qry=sprintf(misuser_qry10, $moduleid, $row['menuid']);
         $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!$nresult) return 7;
         $this->num_tabs[$moduleid]=$nresult->RecordCount();
         
         // loop over menus....
         $t=&$this->modules[$moduleid]['tabs'];
	      while($nrow = $nresult->FetchRow()){
            array_push($t, array(
               'name'=>_($nrow['name']), 
               'icon'=>$nrow['icon'],
               'page'=>$nrow['phpfile'],
               'browse'=>$nrow['perm_browse'],
               'edit'=>$nrow['perm_edit'],
               'add'=>$nrow['perm_add'],
               'delete'=>$nrow['perm_delete'],
               'grant'=>$nrow['perm_grant']
           ));
         }
      }
      
      if($this->num_modules <= $this->disp_count){
         $this->disp_flat=true;
      }
      $this->PreloadModules();
      //print_r($this->real_array);
      return 0;
   }
   
   function PreloadModules()
   {
      if($this->disp_flat) return;
      
      // the number of total menu items will be the same on each side...
      $num_menu=$this->disp_count - $this->num_dispmodule;
      
      $this->menu_str = "<script language=\"javascript\">\n";
      $this->menu_str .= "var ms = new TransMenuSet(TransMenu.direction.down, 5, 5, TransMenu.reference.bottomRight);\n";
      $this->menu_str .= "var menu1 = ms.addMenu(document.getElementById(\"MenuRightArrow\"));\n";
      
      $m=$this->num_dispmodule;
      foreach($this->modules as $module){         
         if($module['type']=='H'){
            continue;
         }
         
         if($m){
            $m--;
            continue;
         }
         $lnk=$module['basedir']."/index.php?action=list&mid=".$module['id'];
         $this->menu_str.="menu1.addItem(\"".$module['name']."\", \"".$lnk."\");\n"; 
      }
		$this->menu_str.="TransMenu.renderAll();\n</script>\n";
   }
   
   function DrawModules()
   {
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"topnav\">\n";
      echo "<td class=\"topnav\">&nbsp;</td>\n";
      echo "<td valign=\"bottom\">\n";
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"topnav\">\n<td valign=\"bottom\">\n";

      if(($this->start_module + $this->num_dispmodule) > $this->num_modules){
         $this->start_module=$this->num_modules - $this->num_dispmodule;
         if($this->start_module < 0){
            $this->start_module=0;
          }
      }
      
      if($this->curr_module==0){
         $i=0;
         $m=0;
         $j=$this->start_module + $this->num_dispmodule;
         if($j > $this->num_dispmodule) $j=$this->num_dispmodule;
         if($this->num_dispmodule > $this->disp_count) $j=$this->disp_count + 1;
      }
      else{
         $i=1;
         $m=1;
         $j=$this->start_module + $this->num_dispmodule + 1;
         if($j > $this->num_dispmodule) $j=$this->num_dispmodule;
          if($this->num_dispmodule > $this->disp_count) $j=$this->disp_count + 1;
      }

      echo "<td class=\"topnav\">&nbsp;</td>\n<td valign=\"bottom\">\n";
 
      if($this->start_module > $this->num_dispmodule){
         // show left arrow
         $lnk=$this->modules[$this->real_array[0]]['basedir'];
         echo "<td class=\"topnav\"><a class=\"topnav\" href=\"".$lnk."/index.php?action=list&mid=";
         echo $this->real_array[0]."\">";
         echo "<img src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_modleftarrow.png\"></a></td>\n";
      }
      else{
         //disabled arrow
         echo "<img src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_modleftarrow_off.png\"></a></td>\n";
      }
      
      echo "<td class=\"topnav\">&nbsp;</td>\n<td valign=\"bottom\">\n";
      echo "</tr>\n</table>\n</td>\n"; //</div>\n</td>\n";
      echo "<td valign=\"bottom\">\n";
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"topnav\">\n";
      foreach($this->modules as $module){         
         if($module['type']=='H'){
            $i++;
            $j++;
            continue;
         }
         
         if($m < $this->start_module){
            $i++;
            $m++;
            $j++;
            continue;
         }
         
         if($i < $j){
            if($this->curr_module==$module['id'] && $i!=0 && $module['type']<>'H'){
               echo "<td class=\"topnav\">". $module['name'] ."</td><td class=\"topnavdiv\">&nbsp; | &nbsp;</td>\n";
            }
            else{
               echo "<td class=\"topnav\"><a class=\"topnav\" href=\"".$module['basedir']."/index.php?action=list&mid=";
               echo $module['id']."\">". $module['name'] ."</a></td>\n";
               if($i!=$j-1){
                  echo "<td class=\"topnavdiv\">&nbsp; | &nbsp;</td>\n";
               }
            }
         }
         $i++;
         $m++;
      }
      echo "<td class=\"topnav\">&nbsp;</td>\n<td>";
      
      if(($this->start_module + $this->num_dispmodule) < $this->num_modules){
         // show right pop
         $z=$this->start_module + $this->num_dispmodule;
         echo "<a id=\"MenuRightArrow\" href=\"#\">";//Bollocks</a></td></div>";
         echo "<img src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_modrightarrow.png\"></a></td>\n";
      }
      else{
         //disabled arrow
         echo "<img src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_modrightarrow_off.png\"></a></td>\n";
      }
      echo "</td></tr>\n</table>\n</td>\n";
      echo "<td class=\"topnavpack\">&nbsp;</td>\n";
      echo "<td valign=\"bottom\">\n";
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"topnav\">\n";
      if(!$this->pda_login){
         echo "<td class=\"topnavlink\"><a class=\"topnavlink\" href=\"".$_SESSION['VxCFG']->wwwroot."/users/usertoday.php?action=list\"> "._("Today")." </a></td>\n";
         echo "<td class=\"topnavlinkdiv\"> | </td>\n";
         echo "<td class=\"topnavlink\"><a class=\"topnavlink\" href=\"".$_SESSION['VxCFG']->wwwroot."/users/userdetails.php\"> "._("My Info")." </a></td>\n";
         echo "<td class=\"topnavlinkdiv\"> | </td>\n";
         echo "<td class=\"topnavlink\"><a class=\"topnavlink\" href=\"".$_SESSION['VxCFG']->wwwroot."/logout.php\"> "._("Logout")." &nbsp;&nbsp;</a></td>\n";
      }
      else{
         echo "<td class=\"topnavlink\"><a class=\"topnavlink\" href=\"".$_SESSION['VxCFG']->wwwroot."/logoutpda.php\"> "._("Logout")." &nbsp;&nbsp;</a></td>\n";
      }
      echo "</tr>\n</table>\n</td>\n"; // </div>\n</td>\n";
      echo "</tr>\n</table>\n";
   }
   
   function DrawTitle()
   {
      echo "\n<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"titleaction\">\n";
      echo "<td class=\"titleaction\">&nbsp;</td><td class=\"titleaction\">";
      if($this->curr_module==0){
         echo "<img src=\"". $_SESSION['VxCFG']->imagedir."/icon_information.png\" class=\"moduleicon\"></td>\n";
         echo "<td class=\"moduletitle\" nowrap>VxMIS Information</td>\n";
      }
      else{
         echo "<img src=\"". $_SESSION['VxCFG']->imagedir."/";
         echo $this->modules[$this->curr_module]['icon'] ."\" class=\"moduleicon\"></td>\n";
         echo "<td class=\"moduletitle\" nowrap>".$this->modules[$this->curr_module]['name']."</td>\n";
      }
      echo "<td class=\"titlepack\">&nbsp;</td>\n";
      if($this->curr_module==0){
         echo "<td class=\"titlenav\">&nbsp;</td>\n";
         echo "</tr>\n</table>\n";
      }
      else{
         $tab=&$this->modules[$this->curr_module]['tabs'][$this->curr_tab];
         if($this->focusidtype!=FOCUSIDTYPE_HIDE){
         echo "<td class=\"titlefocus\"><img src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_target.png\"></td>\n";
            switch($this->focusidtype){
            case FOCUSIDTYPE_NONE:
               echo "<td class=\"titlefocus\">"._("None")."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_COMPANY:
               echo "<td class=\"titlefocus\">"._("Company : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_PRODUCT:
               echo "<td class=\"titlefocus\">"._("Product : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_SUPPLIER:
               echo "<td class=\"titlefocus\">"._("Supplier : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_CUSTOMER:               
               echo "<td class=\"titlefocus\">"._("Customer : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_EMPLOYEE:
               echo "<td class=\"titlefocus\">"._("Employee : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_STATION:
               echo "<td class=\"titlefocus\">"._("Station : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_BANK:
               echo "<td class=\"titlefocus\">"._("Bank : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_USER:
               echo "<td class=\"titlefocus\">"._("User : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            case FOCUSIDTYPE_CONTACT:
               echo "<td class=\"titlefocus\">"._("Contact : ")." ".$this->focusname."&nbsp;&nbsp;</td>\n";
               break;
            }
         }
         if(!$this->pda_login){
            echo "<td class=\"titlenavaction\">\n<form name=pageaction method=\"get\" action=\"";
            echo $_SERVER['PHP_SELF']."\">\n";
            echo "<input type=\"hidden\" name=\"id\" value=\"";
            echo $_SESSION['pageindex']->current();
            echo "\">\n";
            echo "<select name=\"paction\" onChange=\"this.form.submit();\" class=\"titlenavaction\">";
            echo "<option value=\"0\" class=\"titlenavaction\" selected>- "._("Action")." - &nbsp;</option>\n";
         
            // as we have an id from browse - we can edit/delete (perms permitting)
            if($this->curr_action=='browse'){
               if($this->curr_action!='list'){
                  if($tab['browse']=='Y'){
                     echo "<option value=\"list\" class=\"titlenavaction\">"._("List")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='clear'){
                  if($tab['add']=='Y'){
                     echo "<option value=\"clear\" class=\"titlenavaction\">"._("Add")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='edit'){
                  if($tab['edit']=='Y'){
                     echo "<option value=\"edit\" class=\"titlenavaction\">"._("Edit")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='delete'){
                  if($tab['delete']=='Y'){
                     echo "<option value=\"delete\" class=\"titlenavaction\">"._("Delete")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='search'){
               if($tab['browse']=='Y'){
                     echo "<option value=\"search\" class=\"titlenavaction\">"._("Search")."&nbsp;</option>\n";
                  }
               }
            }
            else{  // all other options...
               if($this->curr_action!='list'){
                  if($tab['browse']=='Y'){
                     echo "<option value=\"list\" class=\"titlenavaction\">"._("List")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='browse'){
                  if($tab['browse']=='Y'){
                     echo "<option value=\"browse\" class=\"titlenavaction\">"._("Browse")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='clear'){
                  if($tab['add']=='Y'){
                     echo "<option value=\"clear\" class=\"titlenavaction\">"._("Add")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='edit'){
                  if($tab['edit']=='Y'){
                     echo "<option value=\"edit\" class=\"titlenavaction\">"._("Edit")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='delete'){
                  if($tab['delete']=='Y'){
                     echo "<option value=\"delete\" class=\"titlenavaction\">"._("Delete")."&nbsp;</option>\n";
                  }
               }
               if($this->curr_action!='search'){
                  if($tab['browse']=='Y'){
                     echo "<option value=\"search\" class=\"titlenavaction\">"._("Search")."&nbsp;</option>\n";
                  }
               }
            }
            echo "</select>\n</form>\n</td>\n";
            if($this->showhelp=='Y'){
               echo "<td class=\"help\">\n";
               //if($this->showimages=='Y'){
                  echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\" name=\"namehelp\" src=\"";
                  echo $_SESSION['VxCFG']->styleimagedir."/icon_help.png\" onclick=\"show_help('";
                  echo $this->modules[$this->curr_module]['basedir'];
                  echo "/help/";
                  echo $this->modules[$this->curr_module]['tabs'][$this->curr_tab]['page']."')\">\n";
               //}
               //else{
               //}
               echo "</td>\n";
            }
         }
         echo "</tr>\n";
         echo "<tr><td colspan=\"4\" class=\"titlepack\">&nbsp;</td></tr>\n</table>\n";
      }   
   }
   
   function DrawTabs()
   {
      $i=0;
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr class=\"tab\">\n";
      echo "<td class=\"tabsp\"><img src=\"". $_SESSION['VxCFG']->styleimagedir ."/shim.png\" height=\"2\" width=\"3\"></td>\n";
      echo "<td class=\"tabsp\">";
      if($this->curr_module==0){
      }
      else{
         $basedir=$this->modules[$this->curr_module]['basedir'];
         foreach($this->modules[$this->curr_module]['tabs'] as $keyindex=>$tab){
            if($keyindex==-1) continue;
               if($keyindex==$this->curr_tab){
                  echo "<td class=\"tableftsel\"><img src=\"".$_SESSION['VxCFG']->styleimagedir."/tableftselected.png\" class=\"imagetab\"></td>\n";
                  if($tab['icon']!=""){
                     echo "<img src=\"". $_SESSION['VxCFG']->imagedir ."\"". $tab['icon'] ." class=\"tabicon\">\n";
                  }
                  echo "<td class=\"tabbodysel\" style=\"background-image: url(".$_SESSION['VxCFG']->styleimagedir."/tabbgselected.png); background-repeat: repeat-x;\">";
                  echo "&nbsp;". $tab['name'] ."&nbsp;</td>\n";
                  echo "<td class=\"tabrightsel\"><img src=\"".$_SESSION['VxCFG']->styleimagedir."/tabrightselected.png\" class=\"imagetab\"></td>\n";
               }
               else{
                  echo "<td class=\"tableft\"><img src=\"".$_SESSION['VxCFG']->styleimagedir."/tableft.png\" class=\"imagetab\"></td>\n";
                  if($tab['icon']!=""){
                     echo "<img src=\"". $_SESSION['VxCFG']->imagedir ."/". $tab['icon'] ."class=\"tabicon\">\n";
                  }
                  echo "<td class=\"tabbody\" style=\"background-image: url(".$_SESSION['VxCFG']->styleimagedir."/tabbg.png); background-repeat: repeat-x;\">";
                  echo "&nbsp;<a href=\"". $basedir."/".$tab['page'] ."\" class=\"tablink\">". $tab['name'] ."</a>&nbsp;</td>\n";
                  //echo "&nbsp;<a href=\"".$_SESSION['VxCFG']->wwwroot . $basedir."/".$tab['page'] ."\" class=\"tablink\">". $tab['name'] ."</a>&nbsp;</td>\n";
                  echo "<td class=\"tabright\"><img src=\"".$_SESSION['VxCFG']->styleimagedir."/tabright.png\" class=\"imagetab\"></td>\n";
               }
            //}
            //$this->num_tabs[$this->curr_module-1] as $tkey=>$num;
            //echo $this->num_tabs[$this->curr_module-1];
            if($i < $this->num_tabs[$this->curr_module]){
               echo "<td class=\"tabsp\">";
               echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir ."/shim.png\" height=\"2\" width=\"3\"></td>\n";
            }
            $i++;
         }
         echo "<td class=\"tabend\">";
         echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir ."/shim.png\" height=\"2\"></td>\n";
         /*echo "</tr>\n<tr>\n";
         foreach($this->modules[$this->curr_module]['tabs'] as $key=>$tab){
            if($key==$this->curr_tab){
               echo "<td class=\"tabsepsel\">&nbsp;</td>\n";
            }
            else{
               echo "<td class=\"tabsep\">&nbsp;</td>\n";
            }
         }*/
         echo "</tr></table>\n";
      }
   }
   
   function ModuleDecrement()
   {
      $this->start_module--;
      if($this->start_module < 0){
         $this->start_module=0;
      }
      //if($this->start_module < $this->current_module){
      //   $this->start_module=$this->current_module;
      //}
   }

   function ModuleIncrement()
   {
      $this->start_module++;
      if($this->start_module > ($this->num_modules - $this->num_dispmodule)){
         $this->start_module=$this->num_modules - $this->num_dispmodule;
      }
   }

   function ShowModulesLinks()
   {
      echo $this->menu_str;
      if(!$this->showmodulefooterlinks) return;
      $i=1;
      $j=$this->num_modules+1;
         
      echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr class=\"bottomnav\">\n";
      echo "<td class=\"bottomnavpack\">&nbsp;</td><td class=\"bottomnav\">";
      
      foreach($this->modules as $module){
         if($module['type']!='H'){
            if($i < $j){
               if($this->curr_module==$module['id'] && $i!=0 && $module['type']<>'H'){
                  echo $module['name'] ."&nbsp; | &nbsp;\n";
               }
               else{
                  echo "<a class=\"bottomnav\" href=\"".$module['basedir']."/index.php?action=list&mid=";
                  echo $module['id']."\">". $module['name'] ."</a>&nbsp; | &nbsp;\n";
               }
            }
            else{
               if($this->curr_module==$i && $i!=0){
                  echo $module['name'] ."&nbsp;\n";
               }
               else{
                  echo "<a class=\"bottomnav\" href=\"".$module['basedir']."/index.php?action=list&mid=";
                  echo $module['id']."\">". $module['name'] ."</a>&nbsp;\n";
               }
            }
         }
         $i++;
      }
      
      echo "</td>\n<td class=\"bottomnavpack\">&nbsp;</td>\n</tr>\n</table>\n";
   }
   
   function AddRecentlyVisited($page)
   {
      if($this->num_last_viewed==0) return;
      
      /* TO DO: Needs a proper folding div block */
      
      return;
      
      $name=$this->modules[$this->curr_module]['name'];
      $icon=$this->modules[$this->curr_module]['icon'];
      
      if(!$this->last_viewed_set){
         $this->last_viewed=array($this->curr_module => array(
            'page'=>$page,
            'name'=>$name,
            'icon'=>$icon));
         $this->last_viewed_set=true;
         return;
      }
      
      if(array_key_exists($this->curr_module, $this->last_viewed)){
         //echo "FOUND!";
         //$key = array_search($page, $this->last_viewed);
         
         //array_unshift($this->last_viewed, '$this->curr_module'=>$page);
         //array_unique($this->last_viewed);
         return;
      }
            
      if($this->num_last_viewed > count($this->last_viewed)){
         unset($this->last_viewed[count($this->last_viewed)]);
         $this->last_viewed[0]=array($this->curr_module => $page);
      }
      else{
         $this->last_viewed[$this->curr_module]= array(
            'page'=>$page,
            'name'=>$name,
            'icon'=>$icon);
      }
   }
   
   function DrawRecentlyVisited()
   {
      if($this->num_last_viewed==0) return;
      
      /* TO DO: Needs a proper folding div block */
      
      return;
      
      echo "<tr>\n<td id=\"pagetd\" align=\"left\" valign=\"top\">";
      
      foreach($this->last_viewed as $modid=>$lv){
         echo "<a class=\"lastviewed\" href=\"".$lv['page']."\">".$lv['name']."</a>&nbsp;\n";
      }
      echo "</td>\n</tr>\n";
   }
   
   function DrawFooter()
   {
   }
   
   function GetModules($tarray)
   {
      foreach($this->modules as $key=>$module){
         array_push($tarray, array($module[$key]['name'], $module[$key]['icon']));
      }
   }
   
   function GetModuleTitle($icon, $title)
   {
      $icon=$this->modules[$this->curr_module]['icon'];
      $title=$this->modules[$this->curr_module]['name'];
   }
   
   function GetTabs($tarray)
   {
      foreach($this->modules[$this->curr_module]['tabs'] as $tab){
         array_push($tarray, array($tab[$key]['name'], $tab[$key]['icon'], $tab[$key]['page']));
      }
   }
   
   function GetUser() 
   {
      if(!isset($this->userid)) return 0;
      return $this->userid;
   }
   
   function GetEmployee() 
   {
      if(!isset($this->employeeid)) return 0;
      return $this->employeeid;
   }
   
   function UserName()
   {
      echo $this->fname . " " . $this->lname;
   }
   
   function GetUserName()
   {
      return $this->fname . " " . $this->lname;
   }
   
   function GroupName()
   {
      echo $this->groupname;
   }
   
   function SessionStart()
   {
      echo $this->started->displayts();
   }
   
   function hasPerm($action, $page, $ip="0.0.0.0")
   {
      /*
      $p=explode("/", $page);
      $bd="/".$p[1]."/".$p[2];
      $q=sprintf(misuser_qry11,$bd,$p[3]);
      */
      $tab=&$this->modules[$this->curr_module]['tabs'][$this->curr_tab];

      if($action=='list') if($tab['browse']=='N') return 5;
      else if($action=='commit') if($tab['edit']=='N') return 5;
      else if($action=='cfmdelete') if($tab['delete']=='N') return 5;
      else if($action=='approve') if($tab['edit']=='N') return 5;
      else if($action=='approvecfm') if($tab['edit']=='N') return 5;
      else if($action=='package') if($tab['edit']=='N') return 5;
      else if($action=='packagecfm') if($tab['edit']=='N') return 5;
      else if($action=='dispatch') if($tab['edit']=='N') return 5;
      else if($action=='dispatchcfm') if($tab['edit']=='N') return 5;
      else if($action=='update') if($tab['edit']=='N') return 5;
      else if($action=='updatecfm') if($tab['edit']=='N') return 5;
      else if($action=='enablemodule') if($tab['edit']=='N') return 5;
      else if($action=='enablemenu') if($tab['edit']=='N') return 5;
      else if($action=='chperm') if($tab['edit']=='N') return 5;
      else if($action=='clear') if($tab['add']=='N') return 5;
      else if($action=='search') if($tab['browse']=='N') return 5;
      else if($action=='searchresults') if($tab['browse']=='N') return 5;
      else if($action=='summary') if($tab['browse']=='N') return 5;
      else if($action=='miniview') if($tab['browse']=='N') return 5;
      else if($action=='import') if($tab['browse']=='N') return 5;
      else if($action=='export') if($tab['browse']=='N') return 5;
      else if($action=='importcfm') if($tab['browse']=='N') return 5;
      else if($action=='exportcfm') if($tab['browse']=='N') return 5;
      else if($action=='reports') if($tab['browse']=='N') return 5;
      else if($action=='none') if($tab['browse']=='N') return 5;
      else $a='perm_'.$action;
      /*
      $result=$_SESSION['VxCFG']->dbh->Execute($q);
      if(!$result){
         return 1;
      }
      if($result->RecordCount()==0){
         return 2;
      }*/
      if($this->ip=="0.0.0.0"){;
         $this->log_end();
         return 3;
      }
      if(($this->start_time + $this->session_timeout) < time()){
         $this->log_end();
         return 4;
      }
      /*
      $row = $result->FetchRow();
      if($action=='list') $a='perm_browse';
      else if($action=='commit') $a='perm_edit';
      else if($action=='cfmdelete') $a='perm_delete';
      else if($action=='approve') $a='perm_edit';
      else if($action=='approvecfm') $a='perm_edit';
      else if($action=='package') $a='perm_edit';
      else if($action=='packagecfm') $a='perm_edit';
      else if($action=='dispatch') $a='perm_edit';
      else if($action=='dispatchcfm') $a='perm_edit';
      else if($action=='update') $a='perm_edit';
      else if($action=='updatecfm') $a='perm_edit';
      else if($action=='enablemodule') $a='perm_edit';
      else if($action=='enablemenu') $a='perm_edit';
      else if($action=='chperm') $a='perm_edit';
      else if($action=='clear') $a='perm_add';
      else if($action=='search') $a='perm_browse';
      else if($action=='searchresults') $a='perm_browse';
      else if($action=='summary') $a='perm_browse';
      else if($action=='miniview') $a='perm_browse';
      else if($action=='none') $a='perm_browse';
      else $a='perm_'.$action;
      if($row[$a]=='N'){
         return 5;
      }*/
      // reset session timer
      $this->start_time=time();
      $this->curr_action=$action;
      return 0;
   }
   
   function isloggedin() 
   {
      return $this->logged_in;
   }
   
   function log_out() 
   {
      $this->log_end();
   }
   
   /**
    * Log the action in the employee log.
    *
    * @param	string	$type	Type of entry (e.g. login or logout)
    * @access	private
    */
   function log($type) 
   {
      if(!isset($this->employeeid)){
         return;
      }
      $q = sprintf(misuser_qry4, $this->employeeid, $type);
      $_SESSION['VxCFG']->dbh->Execute($q);
  }


   /**
    * Write a log entry for the users login event.
    * Uses the internal log function to log this entry. 
    * Also sets internal flag to indicate the user is currently logged in.
    *
    * @access	public
    */
   function log_start() 
   {
      $this->logged_in = true;
      $this->log(9);
   }

   /**
    * Write a log entry for the users logout event.
    * Uses the internal log function.  Checks that the user is currently logged in. This gets around problems with session timeouts and with calls before the user has actually logged in.
    *
    * @access	public
    */
    function log_end() 
    {
       if($this->logged_in){
          $this->log(10);
          $this->logged_in = false;
       }
    }

    /**
     * Grab the time of last login from the employee log.
     * This is called prior to the new login entry so that there is no need
     * to compensate for this.
     *
     * @return	boolean	true if a previous login entry was found
     */
    function get_last_login() {
       if(!isset($this->employeeid))
           return false;
       $q=sprintf(misuser_qry5, $this->employeeid, 9);
       if(!$_SESSION['VxCFG']->dbh->Execute($q)){
           return false;
       }
       
       return true;
    }

  /**
   * Format the last login into printable format.
   *
   * @return	string	Formatted date/time.
   * @access	public
   */
  function format_last_login() {
    if (! isset($this->last_login) || $this->last_login == "")
      return "Unknown";
    $timestamp = new TimeDate();
    $timestamp->parse($this->last_login);
    $datestring = date('h:i A D F j Y', $timestamp->timestamp());
    unset($timestamp);
    return $datestring;
  }

  /**
   * Return the users id.
   *
   * @return	mixed	users id if set or false otherwise.
   * @access	public
   */
   function get_uid() 
   {
      if (isset($this->id))
         return $this->id;
      else
         return false;
   }

   function get_cache($cache_id) 
   {
      if(is_string($this->Cache_Lite->get($cache_id))){
         return unserialize($this->Cache_Lite->get($cache_id) );
      }
      return false;
   }

   function put_cache($data, $cache_id) 
   {
      return $this->Cache_Lite->save(serialize($data), $cache_id);
	}
}

?>
