<?php
/*
 * A pager thingy.
 *
 * @version	0.9.9
 * @author	Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright	(c) 2004 Al Kingsley
 * @package	MIS
 * @access	public
 *
 * Notes to bear in mind: all numbers count from zero
 * This is compensated in reporting numbers by adding 1.
 *
 */

class Page {
   var $offset;
   var $num;
   var $pagesize;
   var $numquery;
   var $prevaction;
   var $tablename;
   var $previousid;
   var $currentid;
   var $nextid;

   function Page() 
   {
      $this->offset=0;  // indexed from 1
      $this->num=0;     // from count(*)
      $this->pagesize=20;
      $this->numquery="";
      $this->tablename="zzz";
      $this->previousid=0;
      $this->currentid=0;
      $this->nextid=0;
   }
   
   function CheckNum($q, $tn)
   {
      $this->tablename=$tn;  
      if(strcmp($q, $this->numquery)==0){
         return 0;
      }
      else{
         $this->numquery=$q;
         $this->offset=0;
         $this->num=0;
         return 1;
      }
   }
   
   function SetPageSize($s)
   {
      $this->pagesize=$s;
   }
   
   function setnum($n)
   {
      $this->num=$n;
      if($this->offset > $this->num) $this->offset=$this->num;
   }
   
   function deletion($n)
   {
      $this->num=$n;
      $this->offset--;
      if($this->offset < 0) $this->offset=0;
      return $this->offset;
   }
   
   function addition($n)
   {
      $this->num=$n;
      $this->offset++;
      if($this->offset > $this->num) $this->offset=$this->num;
      return $this->offset;
   }
   
	function setcurrent($o)
   {
      $this->offset=$o;
      if($this->offset > $this->num) $this->offset=$this->num;
      if($this->offset < 0) $this->offset=0;
   }
   // this number is an offset... not an index
	function current()
	{
		return $this->offset;
	}
   
	function num()
	{
		return $this->num;
	}
   function start()
   {
      $this->offset=0;
   }
   function end($a)
   {
      if($a)
         $this->offset=$this->num-1;
      else
         $this->offset=$this->num-$this->pagesize;
   }
   function next()
   {
      $this->offset++;
      if($this->offset > $this->num-1){
         $this->offset=$this->num-1;
      }
   }
   function prev()
   {
      $this->offset--;
      if($this->offset < 0){
         $this->offset=0;
      }
   }
   function pgnext()
   {
	   if($this->num > $this->pagesize){
         $this->offset+=$this->pagesize;
   		if($this->offset > $this->num){
	      	$diff=$this->num % $this->pagesize;
		   	$this->offset=$this->num-$diff;	
		   }
	   }
      else{
         $this->offset=$this->num-1;
      }
   }
   
   function pgprev()
   {
      if($this->num > $this->pagesize){
         $this->offset-=$this->pagesize;
		   if($this->offset < 0){
			   $this->offset=0;
		   }
      }
       else{
         $this->offset=0;
      }
   }
   
   function recordof()
   {
      $ro=$this->offset+1;
      $rn=$this->num;
      echo "Record $ro of $rn";
   }
   
   function numpages()
   {
      return (int) floor($this->num/$this->pagesize);
   }
   
   function browse($id)
   {
      //$q=sprintf("select id from %s order by %s %s LIMIT 1 OFFSET %d", $this->tablename, $sorton, $sortorder, $n);
      $q=$this->numquery." where id < $id";
      if($result=$_SESSION['VxCFG']->dbh->Execute($q)){
         if($row = $result->FetchRow()){
            $this->offset=$row[0];
            return $this->offset;
         }
      }
      $this->offset=0;
      return 1;
   }
   
   function indexer($o=0)
   {
      $this->offset=$o;
      $sorton=$_SESSION["vxmisuser"]->GetSortOn();
      $sortorder=$_SESSION["vxmisuser"]->GetSortOrder(); 
      $n=$this->offset;
      $n-=1;
      $s=$e=false;
      if($n < 0){
         $n=0;
         $s=true;
      }
      if($this->pagesize >= ($this->num - 1)){
         $e=true;
      }
      $q=sprintf("select id from %s order by %s %s LIMIT 3 OFFSET %d", $this->tablename, $sorton, $sortorder, $n);
      //echo $q;
      $result=$_SESSION['VxCFG']->dbh->Execute($q);
      if(!$result) return;
      
      if(!$s){
         $row = $result->FetchRow();
         if(!$row) return;
         $this->previousid=$row[0];
      }
      $row = $result->FetchRow();
      if(!$row) return;
      $this->currentid=$row[0];
      
      if(!$e){
         $row = $result->FetchRow();
         if(!$row) return;
         $this->nextid=$row[0];
      }
   }
   
   function edit($id)
   {
      $this->offset=$id;
   }
   
   function pageof()
   {
      $nump=(int) (floor((double) $this->num / (double) $this->pagesize))+1;
      $x=(int) floor((double) ($this->offset / (double) $this->pagesize))+1;
      echo "Page $x of $nump";
   }
   function navbutton($n)
   {
      switch($n){
      case 'home':
   	   break;
      case 'pageprev':
	      break;
      case 'prev':
	      break;
      case 'next':
   	   break;
      case 'pagenext':
	      break;
      case 'end':
         break;
      }
   }
   function query($q)
   {
      $n=$this->offset;
      if($n < 0) $n=0;
      if($this->num < $this->pagesize) $n=0;
      else{ // round offset to page size
         $n=$this->pagesize*((int)($this->offset / $this->pagesize));	
      }
      $q=$q." LIMIT $this->pagesize OFFSET $n";
      
      return $q;
   }
   function setprev($action) {
      $this->prevaction = $action;
   }
   function getprev() {
      return $this->prevaction;
   }
   
   function DrawListNav($action="list")
   {
      if($this->num==0) return;
      if($this->tablename=="") return;
      
      $bSep=false;
      $id=0;
      if(isset($_REQUEST['id'])){
         $id=$_REQUEST['id'];
         $qstr=$_SERVER['PHP_SELF']."?action=".$action."&id=";
      }
      if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
      echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n<tr>\n";
      /*
      echo "<td align=\"left\" class=\"listnav\">&nbsp;</td>\n";
      echo "<td align=\"left\" valign=\"top\" class=\"listnav\" nowrap>\n";
      switch($action){
      case 'browse':
         if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         if(!$_SESSION['vxmisuser']->hasPerm('edit', $_SERVER['PHP_SELF'])){
            echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=edit&id=".$id."\">&nbsp;&nbsp;Edit&nbsp;&nbsp;</a>\n";
            $bSep=true;
         }
         if(!$_SESSION['vxmisuser']->hasPerm('add', $_SERVER['PHP_SELF'])){
            echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=duplicate&id=".$id."\">&nbsp;&nbsp;Duplicate&nbsp;&nbsp;</a>\n";
            $bSep=true;
         }
         if(!$_SESSION['vxmisuser']->hasPerm('delete', $_SERVER['PHP_SELF'])){
            echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=delete&id=".$id."\">&nbsp;&nbsp;Delete&nbsp;&nbsp;</a>\n";
            $bSep=true;
         }
         if($bSep){
            echo "</td>\n<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         }
		   break;
    
      case 'itemadd':
      case 'itemedit':   
      case 'edit':
         if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<input id=\"sbutton\" type=\"submit\" value=\""._("Commit")."\"></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
	   	break;
      
      case 'import':
      case 'importcfm':
         if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=importcfm&id=".$id."\" >&nbsp;&nbsp;Import&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
	   	break;
      
      case 'export':
      case 'exportcfm':
         if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=exportcfm&id=".$id."\" >&nbsp;&nbsp;Export&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
	   	break;
      
      case 'commit':
         break;
      
      case 'approve':
	   	if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=approve&id=".$id."\" >&nbsp;&nbsp;Approve&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         break;
         break;
      
      case 'package':
	   	if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=package&id=".$id."\" >&nbsp;&nbsp;Package&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         break;
         break;
      
      case 'dispatch':
	   	if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=dispatch&id=".$id."\" >&nbsp;&nbsp;Dispatch&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         break;
         break;
      
      case 'update':
         break;
      
      case 'add':
      case 'clear':
		   if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=add\" >&nbsp;&nbsp;Add&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
   		break;
      
      case 'delete':
		   if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=delete&id=".$id."\" >&nbsp;&nbsp;Delete&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         break;
      
      case 'cfmdelete':
		   if(isset($_REQUEST['offset'])) $this->indexer($_REQUEST['offset']);
         echo "<a class=\"listaction\" href=\"".$_SERVER['PHP_SELF']."?action=delete&id=".$id."\" >&nbsp;&nbsp;Delete&nbsp;&nbsp;</a></td>\n";
         echo "<td><img src=\"".$_SESSION['VxCFG']->styleimagedir."/list_navsep.png\"></td>\n";
         break;
   
      default:
      case 'none':
         break;
      }
      echo "</td>\n"; */
      
      echo "<td align=\"left\" width=\"100%\" class=\"listnav\">&nbsp;</td>\n";
      echo "<td nowrap class=\"listnav\" align=\"right\">";
      if($action=="list"){
         if($this->offset==0){
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_startoff.png alt='Start' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Start</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pageprevoff.png alt='Previous Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Previous Page</font>&nbsp;&nbsp;";
         }
         else{
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?navaction=home\">";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_starton.png alt='Start' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='8e1818'>Start</font>&nbsp;&nbsp;";
            echo "</a>\n";
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?navaction=pageprev\">";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pageprevon.png alt='Previous Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='8e1818'>Previous</font>&nbsp;&nbsp;";
            echo "</a>\n";
         }
      }
      else if($action=="browse" || $action=="edit"){
         if($this->offset == 0){
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_startoff.png alt='Start' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Start</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pageprevoff.png alt='Previous Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Previous Page</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_prevoff.png alt='Previous' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Previous</font>&nbsp;&nbsp;\n";
         }
         else{
            //echo "<a href=\"".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."&offset=0\">";
            echo "<a class=\"listnav\" href=\"".$qstr."&offset=0\">";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_starton.png alt='Start' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='8e1818'>Start</font>&nbsp;&nbsp;";
            echo "</a>\n";
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?navaction=pageprev\">";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pageprevon.png alt='Previous Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='8e1818'>Previous</font>&nbsp;&nbsp;";
            echo "<a class=\"listnav\" href=\"".$qstr.$this->previousid."\">";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_prevon.png alt='Previous' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='8e1818'>Previous</font>&nbsp;&nbsp;";
            echo "</a>\n";
         }
      }
      if($action=="list"){
         $a=$this->offset + 1;
         $b=$this->offset + $this->pagesize + 1;
         if($b > $this->num){
            $b=$this->num;
         }
         echo "($a - $b of $this->num)&nbsp;&nbsp;";
      }
      else if($action=="browse" || $action=="edit"){
         $a=$this->offset + 1;
         if($a > $this->num){
            $a=$this->num;
         }
         echo "($a of $this->num)&nbsp;&nbsp;";
      }
      
      if($action=="list"){
         if(($this->offset + $this->pagesize) >= $this->num){
            echo "<font color='666666'>Next Page</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pagenextoff.png alt='Next Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>End</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_endoff.png alt='End' border='0' align='absmiddle'>&nbsp;";
         }
         else{
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?navaction=pagenext\">";
            echo "<font color='8e1818'>Next</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pagenexton.png alt='Next Page' border='0' align='absmiddle'>&nbsp;";
            echo "</a>\n";
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?navaction=end\">";
            echo "<font color='8e1818'>End</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_endon.png alt='End' border='0' align='absmiddle'>&nbsp;";
            echo "</a>\n";
         }
      }
      else if($action=="browse" || $action=="edit"){
         if($this->offset >= $this->num){
            echo "<font color='666666'>Next</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_nextoff.png alt='Next' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>Next Page</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pagenextoff.png alt='Next Page' border='0' align='absmiddle'>&nbsp;";
            echo "<font color='666666'>End</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_endoff.png alt='End' border='0' align='absmiddle'>&nbsp;";
         }
         else{
            echo "<a class=\"listnav\" href=\"".$qstr.$this->nextid."\">";
            //echo "<a href=\"".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."&navaction=next\">";
            echo "<font color='8e1818'>Next</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_nexton.png alt='Next' border='0' align='absmiddle'>&nbsp;";
            echo "</a>\n";
            echo "<a class=\"listnav\" href=\"".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."&navaction=pagenext\">";
            echo "<font color='8e1818'>Next Page</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_pagenexton.png alt='Next Page' border='0' align='absmiddle'>&nbsp;";
            echo "</a>\n";
            echo "<a class=\"listnav\" href=\"".$qstr."&offset=".$this->num."\">";
            //echo "<a href=\"".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."&navaction=end\">";
            echo "<font color='8e1818'>End</font>&nbsp;&nbsp;";
            echo "<img src=".$_SESSION['VxCFG']->styleimagedir."/nav_endon.png alt='End' border='0' align='absmiddle'>&nbsp;";
            echo "</a>\n";
         }
      }
      echo "</td>\n</tr>\n</table>\n";
   }
}

?>
