<?
/*
reporter.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.

*/
require_once("timedate.php");
#require_once("graph.php");

class ReportPeriod
{
	var $period;
   var $range_type;
	var $display_increment;
	var $num_periods;
   var $start_ts;
   var $end_ts;
   var $increment_time;
	
	function ReportPeriod()
	{
		$this->init();
	}

	function init()
	{
		$this->period='day';
      $this->range_type='nperiods';
	   $this->display_increment=1;
	   $this->num_periods=1;
      
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      $row = $result->FetchRow();

      $this->start_ts=& new TimeDate();
      $this->start_ts->set($row[0]);
      
      $this->end_ts=& new TimeDate();
      $this->end_ts->set($row[0]);
      
      $this->increment_time=& new TimeDate();
      $this->increment_time->clear();
	}
   
   function calcdates()
   {
      // start is :
      // range_type=nperiods : from end minus (period * num+periods) 
      // range_type=todate :
      switch($this->period){
      case 'hour':
	      $this->increment_time->SetHour(1);
         break;
      case 'day':
	      $this->increment_time->SetDay(1);
         break;
      case 'week':
	      $this->increment_time->SetDay(7);
         break;
      case 'month':
         $this->increment_time->SetMonth(1);
         break;
      case 'quarter':
         $this->increment_time->SetMonth(3);
	      break;
      case 'year':
         $this->increment_time->SetYear(1);
         break;
      }
      $n=$this->num_periods;

      while($n){
         $this->start_ts->subdate($this->increment_time->ansidate());
         $n--;
      }
   }
   
   function SetPeriod($p)
   {
      switch($p){
      case 'hour':
      case 'day':
      case 'week':
      case 'month':
      case 'quarter':
      case 'year':
         $this->period=$p;
         //calcdates();
         break;
      default:
         return true;
      }
      return false;
   }
   
   function SetNumPeriods($p)
   {
      $this->num_periods=$p;
   }
   
   function SetDispInc($d)
   {
      switch($d){
      case 'hour':
      case 'day':
      case 'week':
      case 'month':
      case 'quarter':
      case 'year':
         $this->display_increment=$d;
         //calcdates();
         break;
      default:
         return true;
      }
      return false;
   }
   
   function SetDispType($t)
   {
      if($t=='nperiods' || $t=='todate'){
         $this->type=$t;
         return false;
      }
      return true;
   }
   
   function SetAll($p, $n, $d, $t)
   {
      $this->SetPeriod($p);
      $this->SetNumPeriods($n);
      $this->SetDispInc($d);
      $this->SetDispType($t);
      $this->calcdates();
   }
   
   function DrawControl($t='incremental')
   {
      echo "<table>\n";
      echo "<tr>\n";
      echo "<td>"._("Report Period Type")."</td>\n";
      echo "<td><select name=\"periodtype\">\n";
      echo "<option value=\"incremental\" selected>"._("Incremental")."</option>\n";
      echo "<option value=\"absolute\">"._("Absolute")."</option>\n";
      echo "</select>\n</td>\n</tr>\n";
      
      if($t=='absolute'){
         echo "<tr>\n";
         echo "<td>"._("Start Date")."</td>\n";
         echo "<td>";
         $this->start_ts->datecontrol("add", "startdate");
         echo "</td></tr><tr><td>";
         $this->end_ts->datecontrol("add", "enddate");
         echo "</td>\n</tr>\n</table>\n";
      }
      else{ // incremental
         echo "<tr>\n";
         echo "<td>"._("Report Period")."</td>\n";
         echo "<td><select name=\"period\">\n";
         if($this->period=='hour')
            echo "<option value=\"hour\" selected>"._("Hour")."</option>\n";
         else
            echo "<option value=\"hour\">"._("Hour")."</option>\n";
         if($this->period=='day')
            echo "<option value=\"day\" selected>"._("Day")."</option>\n";
         else
            echo "<option value=\"day\">"._("Day")."</option>\n";
         if($this->period=='week')
            echo "<option value=\"week\" selected>"._("Week")."</option>\n";
         else
            echo "<option value=\"week\">"._("Week")."</option>\n";
         if($this->period=='month')
            echo "<option value=\"month\" selected>"._("Month")."</option>\n";
         else
            echo "<option value=\"month\">"._("Month")."</option>\n";
         if($this->period=='quarter')
            echo "<option value=\"quarter\" selected>"._("Quarter")."</option>\n";
         else
            echo "<option value=\"quarter\">"._("Quarter")."</option>\n";
         if($this->period=='year')
            echo "<option value=\"year\" selected>"._("Year")."</option>\n";
         else
            echo "<option value=\"year\">"._("Year")."</option>\n";
         echo "</select></td>\n";
      
         echo "<td>"._("Number of Report Periods")."</td>\n";
         echo "<td><input type=\"text\" name=\"num_periods\" size=\"16\" maxlength=\"16\" value=\"$this->num_periods\"></td>\n";
      
         echo "</tr>";
         /*
         echo "<tr><td>"._("Display Increment")."</td>\n";
         echo "<td><select name=\"display_increment\">\n";
         if($this->period=='hour')
            echo "<option value=\"hour\" selected>"._("Hour")."</option>\n";
         else
            echo "<option value=\"hour\">"._("Hour")."</option>\n";
         if($this->display_increment=='day')
            echo "<option value=\"day\" selected>"._("Day")."</option>\n";
         else
            echo "<option value=\"day\">"._("Day")."</option>\n";
         if($this->display_increment=='week')
            echo "<option value=\"week\" selected>"._("Week")."</option>\n";
         else
            echo "<option value=\"week\">"._("Week")."</option>\n";
         if($this->display_increment=='month')
            echo "<option value=\"month\" selected>"._("Month")."</option>\n";
         else
            echo "<option value=\"month\">"._("Month")."</option>\n";
         if($this->display_increment=='quarter')
            echo "<option value=\"quarter\" selected>"._("Quarter")."</option>\n";
         else
            echo "<option value=\"quarter\">"._("Quarter")."</option>\n";
         if($this->display_increment=='year')
            echo "<option value=\"year\" selected>"._("Year")."</option>\n";
         else
            echo "<option value=\"year\">"._("Year")."</option>\n";
         echo "</select></td>\n";
         echo "<td>&nbsp;</td>\n";
         echo "</tr>\n";*/
         echo "</table>\n";
      }
   }
   
   function DrawStartControl($a, $n)
   {
      $this->start_ts->datecontrol($a, $n);
   }
   
   function DrawEndControl($a, $n)
   {
      $this->end_ts->datecontrol($a, $n);
   }
}

class ReportDataSet extends ReportPeriod
{
   var $table_list;
   var $field_list;
   
   function ReportDataSet()
   {
      $this->table_list = array();
      $this->field_list = array();
   }
   
   function addfields($t, $f)
   {
   }
}

class ProductReporter extends ReportPeriod
{
	var $plu;
   var $number;
   var $number_type;
   var $sinc_time;
   var $einc_time;
   var $einc_ts;
   var $e_time;
   var $x_data;
   var $y_data1;
   var $y_data2;
   
   function ProductReporter()
   {
      $this->plu='';
      $this->number=1;
      $this->x_data=array();
      $this->y_data1=array();
      $this->y_data2=array();
      $einc_ts=& new TimeDate();
      $this->init();
   }
   function SetPLU($item)
   {
      $plu=$item;
   }
   
   function SetStartDate($d, $m, $y)
   {
      $this->start_ts->SetDay($d);
      $this->start_ts->SetMonth($m);
      $this->start_ts->SetYear($y);
   }
   function SetEndDate($d, $m, $y)
   {
      $this->end_ts->SetDay($d);
      $this->end_ts->SetMonth($m);
      $this->end_ts->SetYear($y);
   }
   
   function NumNameSales()
   {
      $sa=$this->start_ts->ansidate();
      $ea=$this->end_ts->ansidate();
      $qry=sprintf(reporter_qry2, $sa, $ea);
      $result=db_query($qry);
      return db_num_rows($result);
   }
   
   function QueryByProduct()
   {
      $n=$this->num_periods;
      $this->sinc_time=$this->start_ts->ansidate();
      $this->einc_ts=$this->start_ts;
      $this->einc_ts->adddate($this->increment_time->ansidate());
      $this->einc_time=$this->einc_ts->ansidate();
      
      $z=0;
      $c=0;
      $max=0.00;
      $total_items=0;
      $total_amount=0.00;
      
      $qry=sprintf(reporter_qry3, $this->plu);
      $result=db_query($qry);
      
      if(db_num_rows($result)==0){
         echo "<table><tr><td align=\"center\"><h3>"._("Product ").$this->plu. _("not found")."</h3></td></tr></table>";
         return;
      }
      $row = $result->FetchRow();
      echo "<table cellpadding=\"2\" cellspacing=\"2\" width=\"80%\"><tr><td colspan=\"3\" align=\"center\"><h2>$this->plu - $row[0]</h2></td></tr>";
      echo "<tr><td><h3>"._("Period")."</h3></td><td align=\"right\"><h3>"._("Quantity")."</h3></td><td align=\"right\"><h3>"._("Amount")."</h3></td></tr>";
      
      $qry=sprintf(reporter_qry4, $this->plu);
      $result=db_query($qry);
      
      if($row = $result->FetchRow()){
         $price=sprintf("%0.2f", $row[0]+($row[0]*$row[1]));
      }
      
      $sa=$this->start_ts->ansidate();
      $ea=$this->end_ts->ansidate();
      
      $qry=sprintf(reporter_qry5, $sa, $ea);
      $result=db_query($qry);
      
      if($row = $result->FetchRow()){
         $total_proditems=$row[0];
      }
      $qry=sprintf(reporter_qry6, $sa, $ea);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $total_prodamount=sprintf("%0.2f", $row[0]);
      }
      
      while($n){
         $qry=sprintf(reporter_qry7, $this->sinc_time, $this->einc_time, $this->plu);
         $result=db_query($qry);
         
         $row = $result->FetchRow();
         $qty=$row[0];
         
         $amt=$price*$qty;
         $s=substr($this->sinc_time, 0, 10);
         $e=substr($this->einc_time, 0, 10);
         if($c%2==0) echo "<tr bgcolor=\"#DDDDDD\">";
         else "<tr>";
         echo "<td>$s - $e</td>\n";
         echo "<td align=\"right\">$qty</td>";
         if($amt){
            echo "<td align=\"right\">$amt</td></tr>\n";
            if($amt>$max) $max=$amt;
            $total_amount+=$amt;
         }
         else{
            echo "<td align=\"right\">0.00</td></tr>\n";
         }
         $total_items+=$qty;
         
         array_push($this->y_data1, $amt);
         array_push($this->y_data2, $qty);
         array_push($this->y_data3, Derivative(0, $inc_period_in_days, $last_qty, $qty));
         array_push($this->y_data4, Derivative(0, $inc_period_in_days, $allstocklast_qty, $allstockqty));
         array_push($this->x_data, $c);
         
         $n--;
         $z++;
         $c++;
         $this->start_ts->adddate($this->increment_time->ansidate());
         $this->sinc_time=$this->start_ts->ansidate();
         
         $this->einc_ts->adddate($this->increment_time->ansidate());
         $this->einc_time=$this->einc_ts->ansidate();
      }
      echo "<tr><td><h3>"._("Product Totals for period")."</h3></td><td align=\"right\"><h3>$total_items</h3></td><td align=\"right\"><h3>$total_amount</h3></td></tr>";
      $qry=sprintf(reporter_qry8, $s, $e, $this->plu);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $prod_retitems=$row[0];
      }
      $prod_ret=$price*$prod_retitems;
      echo "<tr><td><h3><i><font color=\"FF2222\">"._("Product Returns for period")."</font></i></h3></td>\n";
      echo "<td align=\"right\"><h3><i><font color=\"FF2222\">$prod_retitems</font></i></h3></td>\n";
      echo "<td align=\"right\"><h3><i><font color=\"FF2222\">$prod_ret</font></i></h3></td></tr>\n";
      
      echo "<tr><td><h3>"._("All Products for period<")."/h3></td><td align=\"right\"><h3>$total_proditems</h3></td><td align=\"right\"><h3>$total_prodamount</h3></td></tr>";
      
      $qry=sprintf(reporter_qry9, $s, $e);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $total_retitems=$row[0];
      }
      
      $qry=sprintf(reporter_qry10, $s, $e);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $total_retamount=$row[0];
         if($total_retamount==0) $total_retamount="0.00";
      }
      else $total_retamount="0.00";
      echo "<tr><td><h3><i><font color=\"FF2222\">"._("All Returns for period")."</font></i></h3></td>\n";
      echo "<td align=\"right\"><h3><i><font color=\"FF2222\">$total_retitems</font></i></h3></td>\n";
      echo "<td align=\"right\"><h3><i><font color=\"FF2222\">$total_retamount</font></i></h3></td></tr>\n";      
      
      echo "<tr><td colspan=\"3\"></td></tr>\n";
      echo "<tr><td colspan=\"3\" align=\"center\"><h2>"._("Summary")."</h2></td></tr>\n";
      $avg_qty=sprintf("%0.2f", ($total_items/$total_proditems)*100);
      $avg_amount=sprintf("%0.2f", ($total_amount/$total_prodamount)*100);
      echo "<tr><td><h3>"._("Sales Average for period")."</h3></td><td align=\"right\"><h3>$avg_qty%</h3></td><td align=\"right\"><h3>$avg_amount%</h3></td></tr>";

      if($total_retitems==0) $retavg_qty=0;
      else $retavg_qty=sprintf("%0.2f", ($total_retitems/$prod_retitems)*100);
      if($total_retamount==0) $retavg_amount="0.00";
      else $retavg_amount=sprintf("%0.2f", ($total_retamount/$total_prodamount)*100);
      echo "<tr><td><h3>"._("Returns Average for period")."</h3></td><td align=\"right\"><h3>$retavg_qty%</h3></td><td align=\"right\"><h3>$retavg_amount%</h3></td></tr>";

      $qry=sprintf(reporter_qry11, $s, $e);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $total_retitems=$row[0];
      }
      $avg_qty=sprintf("%0.2f", (($total_items - $prod_retitems)/($total_proditems-$total_retitems))*100);
      $avg_amount=sprintf("%0.2f", (($total_amount - $prod_ret)/($total_prodamount-$total_retamount))*100);
      echo "<tr><td><h3>"._("Net Average for period<")."/h3></td><td align=\"right\"><h3>$avg_qty%</h3></td><td align=\"right\"><h3>$avg_amount%</h3></td></tr>";
      
      $rate_qty=sprintf("%0.2f", $total_items/$this->num_periods);
      echo "<tr><td><h3>"._("Rate of Change for period")."</h3></td><td align=\"right\"><h3>$rate_qty</h3></td><td align=\"right\"><h3>-</h3></td></tr>\n";
      $rate_all=sprintf("%0.2f", $total_proditems/$this->num_periods);
      echo "<tr><td><h3>"._("All Products Rate")."</h3></td><td align=\"right\"><h3>$rate_all</h3></td><td align=\"right\"><h3>-</h3></td></tr>\n";
      
      echo "</table>";
   }
   
   function PlotByProduct($title, $type, $num)
   {
      $graph = new graph(400,250);
      $graph->parameter['path_to_fonts'] = 'fonts/';
      $graph->parameter['title']         = '$title';
      $graph->parameter['x_label']       = 'Period';
      $graph->parameter['y_label_left']  = 'Amount';
      $graph->parameter['y_label_right']  = 'Quantity';
      
      $graph->parameter['legend']        = 'outside-right';
      $graph->parameter['legend_border'] = 'black';
      $graph->parameter['legend_offset'] = 4;
      $graph->x_data=$this->x_data;
      $graph->y_data['Amount']=$this->y_data1;
      $graph->y_data['Quantity']=$this->y_data2;
      $graph->draw();
   }
   
   function PieByProduct($title, $type, $num)
   {
   }
   
   function BarByProduct($title, $type, $num)
   {
   }
   
   function QueryByTurnover()
   {
      $n=$this->num_periods;
      $this->sinc_time=$this->start_ts->ansidate();
      $this->einc_time=$this->end_ts->ansidate();
      
      $total_items=0;
      $total_bought=0;
      $qry=sprintf(reporter_qry12, $this->plu);
      $result=db_query($qry);
      if(db_num_rows($result)==0){
         echo "<table><tr><td align=\"center\"><h3>"._("Product ") .$this->plu. _("not found")."</h3></td></tr></table>";
         return;
      }
      $row = $result->FetchRow();
      echo "<table border=\"1\" cellpadding=\"2\" cellspacing=\"2\" width=\"80%\"><tr><td colspan=\"2\" align=\"center\"><h2>$this->plu - $row[0]</h2></td></tr>";
      
      $qry=sprintf(reporter_qry13, $row[0]);
      $result=db_query($qry);
      $row = $result->FetchRow();
      $invid=$row[0];      
      
      $qry=sprintf(reporter_qry14, $this->sinc_time, $this->einc_time, $this->plu);
      $result=db_query($qry);
      if($row = $result->FetchRow()){
         $total_items=$row[0];
         $max_items=$row[1];
         
         $qry=sprintf(reporter_qry15, $this->sinc_time, $this->einc_time, $invid);
         $presult=db_query($qry);
         if($prow = $presult->FetchRow()){
            $total_bought=$row[0];
         }
         $turnover=$total_bought/$total_items;
         $avgperperiod=$total_items/$this->num_periods;
         
         $qry=sprintf(reporter_qry16, $this->sinc_time, $this->einc_time);
         $presult=db_query($qry);
         if($prow = $presult->FetchRow()){
            $max_bought_id=$row[0];
            $max_bought=$row[1];
         }
         
         $presult=db_query(reporter_qry17);
         if($prow = $presult->FetchRow()){
            $max_inventory=$row[0];
         }
         
         // re-order level - max useage * max lead time
         $qry=sprintf(reporter_qry18, $invid);
         $presult=db_query($qry);
         if($prow = $presult->FetchRow()){
            $max_leadtime=$row[0];
            //$ro_level=
         }
         
         // safety buffer - reorder level - average use in maxleadtime
         
         // minimum level - reorder level - average use in min leadtime
         
         // maximum level - reorder level + EOQ - min anticipated usage in leadtime
         
         echo "<tr><td>"._("Total Sold")."</td><td>$total_items</td></tr>\n";
         echo "<tr><td>"._("Max Sold")."</td><td>$max_items</td></tr>\n";
         echo "<tr><td>"._("Max Lead Time")."</td><td>$max_leadtime</td></tr>\n";
         echo "<tr><td>"._("Total Purchased")."</td><td>$max_bought</td></tr>\n";
         //echo "<tr><td>Max Purchased Item</td><td>$max_item_name</td></tr>\n";
         echo "<tr><td>"._("Max Purchased Qty")."</td><td>$max_bought</td></tr>\n";
         echo "<tr><td>"._("Max Item Qty")."</td><td>$max_inventory</td></tr>\n";
         echo "</table>";
      }
   }
   
   function QueryByMargin($num)
   {
      $s=$this->start_ts->ansidate();
      $e=$this->end_ts->ansidate();
      $qry=sprintf(reporter_qry22, $s, $a, $this->plu, $num);
      $result=db_query($qry);
      while($row=$result->FetchRow()){
      
      }
   }
   
   function QueryTopSelling($num)
   {
   }
   
   function QueryWorstSelling($num)
   {
   }
   
   function QueryOverTarget($num)
   {
   }
   
   function QueryUnderTarget($num)
   {
   }
   
   function QueryByCategory()
   {
   }
   
   function QueryByGroup()
   {
   }
   
   function QueryByDepartment()
   {
   }
   
   function QueryBySite()
   {
   }
   
   function QueryBySupplier()
   {
   }
   
   function Derivative($sx=0, $ex, $sy, $ey)
	{
      return ($ex-$sx)/($ey-$sy);
   }
   
	function CheckPLU()
	{
		if(!isset($this->plu) || $this->plu==""){
			return 1;
		}
      $qry=sprintf(reporter_qry19, $this->plu);
      $result=db_query($qry);
		if(db_num_rows($result)==0){
			return 2;
		}
		$row = $result->FetchRow();
		$this->productID=$row["id"];
		$this->name=$row["name"];
		$this->invID=$row["invid"];
		db_free_result($result); 
		
      $qry=sprintf(reporter_qry20,$this->invID);
      $result=db_query($qry);
		if(db_num_rows($result)==0){
			return 3;
		}
		$row = $result->FetchRow();
		$bqid=$row["buyquantitypriceid"];
		db_free_result($result); 

      $qry=sprintf(reporter_qry21, $bqid);
      $result=db_query($qry);
		if(db_num_rows($result)==0){
			return 4;
		}
		$row = $result->FetchRow();
		$this->price=$row["price"];
		$this->supplierID=$row["supplierid"];
		db_free_result($result); 
		
		return 0;
	}
}

class UserReporter extends ReportPeriod
{
	var $userID;
   var $sinc_time;
   var $einc_time;
   var $einc_ts;
   var $e_time;
   var $x_data;
   var $y_data1;
   var $y_data2;
}

?>
