<?php
/*
supplier.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * @defgroup supplier Supplier
 * @{
 */

/**
 \class Supplier
 \brief A class to handle suppliers
*/

class Supplier
{
   var $id;
   var $cmid;
   var $supplierid;
   var $typeid;
   var $name;
   var $addressid;
   var $invoicename;
   var $invoicecontactid;
   var $contactid;
   var $chargeid;
   var $ediid;
   var $acccountid;
   var $linkid;
   var $type;
   var $active;
   var $notes;
   
   function Supplier($id=0, $bOffset=false)
   {
      if($id!=0){
         return $this->Fill($id, $bOffset);
      }
      else{
         $this->id=0;
         $this->cmid=0;
         $this->supplierid=0;
         $this->typeid=0;
         $this->name="";
         $this->addressid=0;
         $this->invoicename="";
         $this->invoicecontactid=0;
         $this->contactid=0;
         $this->chargeid=0;
         $this->ediid=0;
         $this->acccountid=0;
         $this->linkid=0;
         $this->type=0;
         $this->active='N';
         $this->notes="";
      }
   }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(bank_qry7, $id);
      }
      else{
         $qry=sprintf(banklib_qry6, $id);
      }
      
	   $result=db_query($qry);
      if($result){
         if($row = $result->FetchRow()){
            $this->ID=$id;
            $this->cmid=$row["cmid"];
            $this->supplierid=$row["supplierid"];
            $this->typeid=$row["typeid"];
            $this->name=$row["name"];
            $this->addressid=$row["addressid"];
            $this->invoicename=$row["invoicename"];
            $this->invoicecontactid=$row["invoicecontactid"];
            $this->contactid=$row["contactid"];
            $this->chargeid=$row["chargeid"];
            $this->ediid=$row["ediid"];
            $this->acccountid=$row["acccountid"];
            $this->linkid=$row["linkid"];
            $this->type=$row["type"];
            $this->active=$row["active"];
            $this->notes==$row["notes"];

            return true;
         }
      }
      return false;
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
   	   echo "<select name=\"$cname\" width=\"250\">\n";
         $result=db_query(supplier_qry8);
         if($result){
      	   while($row = $result->FetchRow()){
	      		$boo=$row["id"];
		         $poo=$row["name"];
		         if($id==$boo){
			         echo "<option selected value=\"$boo\"> $poo </option>\n";
   		      }
         		else{
	         		echo "<option value=\"$boo\"> $poo </option>\n";
		         }
   	      }
	   	   echo "</select>\n";
         }
         else{
            echo "Not Set";
         }
      }
      else{
         $qry=sprintf(supplier_qry9, $id);
         $result=db_query($qry);
         if($result){
            if($row = $result->FetchRow()){
               echo $row[0];
            }
            else{
               echo "Not Set";
            }
         }
         else{
            echo "Not Set";
         }
      }
   }
   
   function PriceTable($a, $cname, $id)
   {
      echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#CCCCFF\">\n";
      echo "<tr><td><h3>Supplier Name</h3></td><td><h3>Supplier Code</h3></td></tr>\n";
      if($a=="commit" || $a=="add"){
         $qry=sprintf(supplier_qry10, $id);
         $result=db_query($qry);
         if(db_num_rows($result)==0){
            echo "<tr><td colspan=\"2\">No Suppliers found</td></tr>\n</table>\n";
            return;
         }
      	while($myrow = $result->FetchRow()){
            echo "<tr>";
		      $sid=$myrow["supplierid"];
            $scode=$myrow["suppliercode"];
            $qry=sprintf(supplier_qry11, $sid);
		      $sresult=db_query($qry);
		      if($srow = $sresult->FetchRow()){
   		      echo "<td>$srow[0]</td>\n";
	   	   }
            else{
               echo "<td>Not Set</td>\n";
            }
            if(isset($scode)){
               echo "<td>$scode</td>\n";
            }
            else{
               echo "<td>Not Set</td>\n";
            }
            echo "</tr><tr><td>\n";
            BQTable($a, $sid, $id);
	      }
      }
      else{
      }
   }

   function BQTable($a, $supplierid, $invbqid)
   {
      $qry=sprintf(supplier_qry12, $invbqid, $supplierid);
      $result=db_query($qry);
   
      echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" bgcolor=\"#CCCCFF\">\n";
      echo "<tr align=\"center\"> \n";
      echo "<td colspan=\"4\"><h3>Price Quantity</h3></td></tr><tr>\n";
      if($row=$result->FetchRow()){   
         echo "<td align=\"right\" class=label width=\"20%\">Quantity</td>\n";
         echo "<td>";
         entry($a, "quantity", 12, 8, $roe["quantity"]);
         echo "</td>\n<td align=\"right\" class=label>Quantity Type</td>\n<td>";
         fillQTCombo($a, "quantitytypeid", $row["quantitytypeid"]);
         echo "</td></tr><tr>\n<td align=\"right\" class=label>Pack Size</td>\n<td>";
         entry($frm["newaction"], "udv", 12, 8, $row["udv"]); 
         echo "</td>\n<td align=\"right\" class=label>Name</td>\n<td>";
         fillinvPriceNameCombo($a, "quantitynameid", $row["quantitynameid"]);
         echo "</td></tr><tr>\n<td align=\"right\" class=label>Unit Price</td>\n<td>";
         entry($a, "price", 12, 8, $row["price"]);
         echo "</td>\n<td align=\"right\" class=label>Tax</td>\n<td>";
         fillTaxCombo($a, "taxid", $row["taxid"]);
         echo "</td></tr><tr>\n<td align=\"right\" class=label>Account</td>\n<td>";
         AccountCombo($a, $row["accountid"]);
         echo "</td>\n<td align=\"right\" class=label>Currency</td>\n<td>";
         CurrencyCombo($a, $row["basecurrencyid"]);
         echo "";
      }
      else{
         echo "<td colspan=\"4\">No Price Quantity Information found.";
      }
      echo "</td>\n</tr>\n</table>\n";
   }

   
   function Table($id)
   {
      $qry=sprintf(supplier_qry13, $id);
      $result=db_query($qry);
      if(!$result) return false;
      
   }
}

/* @} */

?>
