<?php
/*
station.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/locale.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Station Administration"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Station Administration");
}

if($_SESSION["pageindex"]->CheckNum(station_station_qry1, "stations")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addStation();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseStation($_REQUEST['id']);
         break;
      }
		browseStation($_POST['id']);
		break;

	case "edit" :
		editStation($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelStation($_REQUEST['id']);
      }
      else{
         deleteStation($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listStation($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteStation($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listStation();
		break;

	case "add" :
		insertStation($_POST);
		break;

	case "commit" :
		commitStation($_POST);
		listStation();
		break;

	case "list":
	default :
		listStation();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
 function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(station_station_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["mac"] = "";
   $frm["groupid"] = "";
   $frm["localeid"] = "";
   $frm["currencyid"] = "";
   $frm["active"] = "";

   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(station_station_qry2, $id);
   }
   else{
      $qry=sprintf(station_station_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_STATION);
   $_SESSION['vxmisuser']->SetFocusID($row['id']);   
   $_SESSION['vxmisuser']->SetFocusName($row['name']);
   
	$frm["id"] = $row["id"];
   $frm["name"] = $row["name"];
   $frm["mac"] = $row["mac"];
   $frm["groupid"] = $row["groupid"];
   $frm["localeid"] = $row["localeid"];
   $frm["currencyid"] = $row["currencyid"];
   $frm["active"] = $row["active"];

   //$if=$row["interfaceID"];
   $gid=$row["groupid"];
   $bcid = $row["currencyid"];

	if(!isset($bcid) || $bcid==0){
		$frm["currname"]=_("Not Set");
	}
	else{
		$result=db_query("select bigname from currency where id = '$bcid'");
		$row = $result->FetchRow();
		$frm["currname"]=$row["bigname"];
	}
   /*
   if($if < 2){
      $frm["ifname"]="Not Set";
   }
   else{
      $result=db_query("SELECT Name FROM interface WHERE ID = '$if'");
	   $row = $result->FetchRow();
      $frm["ifname"]=$row["Name"];
   }
   */
   if($gid < 2){
      $frm["groupname"]="Not Set";
   }
   else{
      $result=db_query("select name from groups where id = '$gid'");
   	$row = $result->FetchRow();
      $frm["groupname"]=$row["name"];
   }
   
   return $frm;
}

function addStation()
{
   $frm=clearform();
	$frm["newaction"] = "add";
		
	include("templates/station.php");
}

function editStation($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $_SESSION['vxmisuser']->SetFocusAction('edit');

	include("templates/station.php");
}

function browseStation($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
   $_SESSION['vxmisuser']->SetFocusAction('browse');
	
	include("templates/station.php");
}

function chkdelStation($id)
{
	$frm=fillform($id);
	$frm["newaction"] = "cfmdelete";
	include("templates/station.php");
}

function deleteStation($id) 
{
   $qry=sprintf(station_station_qry7, $id);
	db_query($qry);
}

function insertStation($frm) 
{
   $qry=sprintf(station_station_qry5, $frm['name'],$frm['mac'],$frm['groupid'],$frm['localeid'],$frm['currencyid'],
      YN($frm['active']));
   db_query($qry);
}

function commitStation($frm) 
{
	$qry=sprintf(station_station_qry6, $frm['name'],$frm['mac'],$frm['groupid'],$frm['localeid'],$frm['currencyid'],
      YN($frm['active']), $frm['id']);
   db_query($qry);
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function UsersByPost($a, $pid)
{
   $result=db_query("select users.employeeid, interface.name, loginmethod.name, authority.*
      from userauth, authority, postinterface, users, interface, loginmethod
      where postinterface.postid = '$pid' and
      userauth.interfaceid = postinterface.interfaceid and 
      users.id=userauth.userid and 
      interface.id=postinterface.interfaceid and
      loginmethod.id=userauth.loginmethodid and
      authority.id = userauth.authid");
   
   echo "<tr><td class=\"tinsert\">Name</td><td class=\"tinsert\">Interface</td>\n";
   echo "<td class=\"tinsert\">Type</td><td class=\"tinsert\">login</td><td class=\"tinsert\">list</td>\n";
   echo "<td class=\"tinsert\">browse</td><td class=\"tinsert\">add</td><td class=\"tinsert\">edit</td>\n";
   echo "<td class=\"tinsert\">delete</td></tr>\n";
   $c=1;
   while($row = $result->FetchRow()){
      if($c%2==0){
         echo "<tr bgcolor=\"#CFCFCF\">\n";
      }
      else{
         echo "<tr>\n";
      }
      $empid=$row[0];
      $r=$_SESSION['VxCFG']->dbh->Execute("SELECT contactid FROM employee WHERE employeeid='$empid'");
      if($rr = $r->FetchRow()){
         $cid=$row[0];
      }
      
      $nq=$_SESSION['VxCFG']->dbh->Execute("SELECT firstname, lastname FROM contacts WHERE id='$cid'");
      if($nrow = $nq->FetchRow()){
         echo "<td class=\"tinsert\">$nrow[0] $nrow[1]</td>\n";
      }
      else{
         echo "<td class=\"tinsert\">No Name</td>\n";
      }
      
      echo "<td class=\"tinsert\">$row[1]</td><td class=\"tinsert\">$row[2]</td>\n";
      perms($a, $row);
      
      echo "</tr>\n";
      $c++;
   }
}

function PostByUsers($a, $uid)
{
   $result=db_query("select distinct authority.id, posts.name, interface.name, loginmethod.name, authority.*
      from authority, userauth, postinterface, posts, users, interface, loginmethod
      where users.id='$uid' and
      userauth.interfaceid = postinterface.interfaceid and 
      userauth.userid='$uid' and 
      interface.id=postinterface.interfaceid and
      loginmethod.id=userauth.loginmethodid and
      authority.id = userauth.authid");
   
   echo "<tr><td><h3>Name</h3></td><td><h3>Interface</h3><td><h3>Type</h3></td><td><h3>login</h3></td><td><h3>list</h3></td><td><h3>browse</h3></td><td><h3>add</h3></td><td><h3>edit</h3></td><td><h3>delete</h3></td></tr>\n";
   $c=1;
   while($row = $result->FetchRow()){
      if($c%2==0){
         echo "<tr bgcolor=\"#CFCFCF\">\n";
      }
      else{
         echo "<tr>\n";
      }
      echo "<td>$row[1]</td><td>$row[2]</td><td>$row[3]</td>\n";
      perms($a, $row);
      
      echo "</tr>\n";
      $c++;
   }
}

function perms($a, $row)
{
   if($a=="commit" || $a=="add"){
      if($row["perm_login"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"1\" checked></td>\n";
      }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_login"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
   
   if($a=="commit" || $a=="add"){
      if($row["perm_list"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"1\" checked></td>\n";
      }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_list"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
   
   if($a=="commit" || $a=="add"){
      if($row["perm_browse"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"1\" checked></td>\n";
      }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_browse"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
   
   if($a=="commit" || $a=="add"){
      if($row["perm_add"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"1\" checked></td>\n";
    }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_add"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
   
   if($a=="commit" || $a=="add"){
      if($row["perm_edit"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"1\" checked></td>\n";
      }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_edit"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
   
   if($a=="commit" || $a=="add"){
      if($row["perm_delete"]=='Y'){
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"1\" checked></td>\n";
      }
      else{
         print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"0\"></td>\n";
      }
   }
   else{
      if($row["perm_delete"]=='Y'){
         print "<td align=\"center\"><image src=\"../images/tick.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
      else{
         print "<td align=\"center\"><image src=\"../images/cancel.png\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
      }
   }
}

function listStation()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(station_station_qry9, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no stations defined")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["name"]."</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["name"]."</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"station.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"station.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"station.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"station.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"station.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"station.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
