<?php
/*
reports.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/reporter.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Supplier Reports"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Supplier Reports");
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "product":
      product();
      break;
      
   case "purchase":
      purchase();
      break;
   case "purchasev":
      purchasev();
      break;
      
   case "turnover":
      turnover();
      break;
      
   case "volume":
      volume();
      break;
      
   case "amount":
      amount();
      break;
      
   case "margin":
      margin();
      break;
      
   case "qryproduct":
      qryproduct($_POST);
      break;
      
   case "qrypurchase":
   case "qrypurchasev":
   case "qryturnover":
   case "qryvolume":
   case "qryamount":
   case "qrymargin":
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function clearForm()
{
   $frm["plu"]="";
   $frm["reporttype"] = "incremental";
   $frm["newaction"] = "query";
   include("templates/reports.php");
}

function between($qry)
{
   global $start_time;
   global $end_time;
   
   if(!isset($start_time)){
      $start_ts=& new TimeDate();
      $start_ts->midnight();
      $start_time=$start_ts->ansidate();
      $nice_start_time=$start_ts->displayts();
   }

   if(!isset($end_time)){
      $end_ts=& new TimeDate();
      $end_ts->last_second();
      $end_time=$end_ts->ansidate();
      $nice_end_time=$end_ts->displayts();
   }

   $qry=$qry." t.enteredat between '$start_time' and '$end_time'";
   return $qry;
}

function product()
{
   $frm["newaction"] = "qryproduct";
   $frm["heading"] = "Supplier By Best/Worse Products";
   $frm["limit"] = 30;
   include("templates/reports_bw.php");
}

function purchase()
{
   $frm["newaction"] = "qrypurchase";
   $frm["heading"] = "Supplier By Purchased Amount";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function purchasev()
{
   $frm["newaction"] = "qrypurchasev";
   $frm["heading"] = "Supplier By Purchased Volume";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function turnover()
{
   $frm["newaction"] = "qrypurchase";
   $frm["heading"] = "Supplier By Product Turnover";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function volume()
{
   $frm["newaction"] = "qrypurchase";
   $frm["heading"] = "Supplier By Sales Volume";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function amount()
{
   $frm["newaction"] = "qrypurchase";
   $frm["heading"] = "Supplier By Sales Amount";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function margin()
{
   $frm["newaction"] = "qrypurchase";
   $frm["heading"] = "Supplier By Sales Margin";
   $frm["limit"] = 30;
   include("templates/reports.php");
}

function qryproduct($frm)
{
   $qry="select sum(ti.quantity),sum(pi.amount),p.plu,p.name,s.name from transaction as t, 
      transactionitems as ti,paymentitem as pi, product as p, inventory as i,invpricequantity as bq, supplier as s 
      where ti.plu=p.plu and ti.transactionid=t.id and pi.transid=t.id and p.sellquantityid=bq.id and
      bq.supplierid=s.id and";
      
   $qry=between($qry);
   $qry=$qry." GROUP BY s.name LIMIT ".$frm["limit"];
   $result=db_query($qry);
   echo "<br><br>";
   if(db_num_rows($result)==0){
      echo "No available reporting data in repsonse to this query";
      return;
   }
   
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
	echo "<tr><td><h3>Supplier</h3></td><td><h3>Product</h3></td><td><h3>Qty</h3></td><td><h3>Amount</h3></td></tr>";
   
   while($row = $result->FetchRow()){
      $p=$row[3]." - ".$row[4];
      echo "<tr><td>$row[5]</td><td>$p</td><td>$row[1]</td><td>$row[2]<>/td></tr>\n";
   }
   echo "<table><br>\n";
}

function qrypurchase()
{
   $qry="select sum(ti.quantity),sum(pi.amount),p.plu,p.name,s.name from transaction as t, 
      transactionitems as ti,paymentitem as pi, product as p, inventory as i,invpricequantity as bq, supplier as s 
      purchaseorder as po where ti.plu=p.plu and ti.transactionid=t.id and pi.transid=t.id and p.sellquantityid=bq.id and
      bq.supplierid=s.id and po.transactionid=t.id";
      
   $qry=between($qry);
   $qry=$qry." ORDER BY ti.quantity GROUP BY s.name LIMIT ".$frm["limit"];
   $result=db_query($qry);
   echo "<br><br>";
   if(db_num_rows($result)==0){
      echo "No available reporting data in repsonse to this query";
      return;
   }
   
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
	echo "<tr><td><h3>Supplier</h3></td><td><h3>Product</h3></td><td><h3>Qty</h3></td><td><h3>Amount</h3></td></tr>";
   
   while($row = $result->FetchRow()){
      $p=$row[3]." - ".$row[4];
      echo "<tr><td>$row[5]</td><td>$p</td><td>$row[1]</td><td>$row[2]<>/td></tr>\n";
   }
   echo "<table><br>\n";
}

function qrypurchasev()
{
   $qry="select sum(pi.quantity) as pq,p.plu,p.name,s.name from transaction as t, 
      transactionitems as ti,purchaseorderitems as pi, product as p, inventory as i,invpricequantity as bq, supplier as s 
      purchaseorder as po where po.transactionid=t.id and t.closed='Y' and p.sellquantityid=bq.id and
      pi.purchaseorderid=po.id and bq.supplierid=s.id ";
      
   $qry=between($qry);
   $qry=$qry." ORDER BY pq GROUP BY s.name LIMIT ".$frm["limit"];
   $result=db_query($qry);
   echo "<br><br>";
   if(db_num_rows($result)==0){
      echo "No available reporting data in repsonse to this query";
      return;
   }
   
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
	echo "<tr><td><h3>Supplier</h3></td><td><h3>Product</h3></td><td><h3>Qty</h3></td><td><h3>Amount</h3></td></tr>";
   
   while($row = $result->FetchRow()){
      $p=$row[3]." - ".$row[4];
      echo "<tr><td>$row[5]</td><td>$p</td><td>$row[1]</td><td>$row[2]<>/td></tr>\n";
   }
   echo "<table><br>\n";
}

function qryturnover()
{
   // as purchase volume (in) compared to volume sold by supplier (out) as a turnover ratio.
   // reporting in/out/ratio
}

function qryvolume()
{
   // straight volume by supplier/product
}

function qryamount()
{
   // straight amount by supplier/product
}

function qrymargin()
{
   // buy price against sale price against volume summed on greatest amount.
   // reporting margin (profit) on summed item sales as summed cost difference.
}


function DrawStartdate($a, $n)
{
   global $start_time;
   
   if(!isset($start_time)){
      $start_ts=& new TimeDate();
      $start_ts->tscontrol("add", "start");
   }
}

function DrawEnddate($a, $n)
{
   global $end_time;
   
   if(!isset($end_time)){
      $end_ts=& new TimeDate();
      $end_ts->tscontrol("add", "end");
   }
}

?>
