<?php
/*
auth.php

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
require_once($_SESSION['CFG']->libdir."/auth.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['titleimg']) || $_SESSION['titleimg']!=$_SESSION['CFG']->imagedir."/tlt_user.png"){
   $_SESSION['titleimg'] = $_SESSION['CFG']->imagedir."/tlt_user.png";
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(auth_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}
 
switch($_REQUEST['action']){
	case "clear" :
		addAuth();
		break;
		
	case "browse" :
      $id=updateNav($_POST);
		browseAuth($id);
		break;

	case "edit" :
		editAuth($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelAuth($_REQUEST['id']);
      }
      else{
         deleteAuth($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAuth($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteAuth($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAuth();
		break;

	case "add" :
		insertAuth($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listAuth();
		break;

	case "commit" :
		commitAuth($_POST);
		listAuth();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listAuth();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(auth_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id'] = 0;
   $frm['name'] = "" ;
   $frm['description'] = "";
   $frm['perm_login'] = 0;
   $frm['perm_list'] = 0;
   $frm['perm_browse'] = 0;
   $frm['perm_add'] = 0;
   $frm['perm_edit'] = 0;
   $frm['perm_delete'] = 0;
   $frm['perm_shutdown'] = 0;

   return $frm;
}

function fillform($id, $bOffset)
{

	if($bOffset){
      $qry=sprintf(auth_qry2, $id);
   }
   else{
      $qry=sprintf(auth_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id'] = $id;
   $frm['name'] = $row['name'];
   $frm['description'] = $row['description'];
   $frm['perm_login'] = $row['perm_login'];
   $frm['perm_list'] = $row['perm_list'];
   $frm['perm_browse'] = $row['perm_browse'];
   $frm['perm_add'] = $row['perm_add'];
   $frm['perm_edit'] = $row['perm_edit'];
   $frm['perm_delete'] = $row['perm_delete'];
   $frm['perm_shutdown'] = $row['perm_shutdown'];
   
	return $frm;
}

function addAuth() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";
   $frm["heading"] = "Authority Add";

	include("templates/authedit.php");   
}

function browseAuth($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Authority Browse";

	include("templates/authedit.php");
}

function editAuth($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Authority Edit";

	include("templates/authedit.php");
}

function deleteAuth($frm) 
{
   $qry=sprintf(auth_qry7, $frm['ID']);
	db_query($qry);
}

function chkdelAuth($id)
{
   $frm = fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["ID"] = $id;
   $frm["heading"] = "Authority Delete";
   
	include("templates/authedit.php");
}

function insertAuth($frm) 
{
   $qry=sprintf(auth_qry5, $frm['name'],$frm['description'],YN($frm['perm_login']),YN($frm['perm_list']),
      YN($frm['perm_browse']),YN($frm['perm_add']),YN($frm['perm_edit']),YN($frm['perm_delete']),
      YN($frm['perm_shutdown']));
	db_query($qry);
}

function commitAuth($frm) 
{
	$qry=sprintf(auth_qry6, $frm['name'],$frm['description'],YN($frm['perm_login']),YN($frm['perm_list']),
      YN($frm['perm_browse']),YN($frm['perm_add']),YN($frm['perm_edit']),YN($frm['perm_delete']),
      YN($frm['perm_shutdown']),$frm['id']);
	db_query($qry);
}

function listAuth()
{
   $q=$_SESSION["pageindex"]->query(auth_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Description</h3></td><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		printf( "<tr><td>%s</td>\n<td>%s</td>\n<td>", $row["name"], $row["description"]);
		if($_SESSION['CFG']->pageimages){
         echo "<a href=\"auth.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_view.png\"></a>&nbsp;\n";
		   echo "<a href=\"auth.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_edit.png\"></a>&nbsp; \n";
		   echo "<a href=\"auth.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_delete.png\"></a>&nbsp; \n";
      }
      else{
      	echo "<a href=\"auth.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		   echo "<a href=\"auth.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		   echo "<a href=\"auth.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</td></tr>";
}

?>
